{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} UNIT Prog2Data; {>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


{///////////////////////////////////////////////////////////////////////////}
{/                                                                         /}
{/  Author     : Charlie Wiederhold                                        /}
{/  Date       : March 04, 1996                                            /}
{/  Assignment : Program assignment 2                                      /}
{/  TA         : Gooty                                                     /}
{/  Purpose    : To read in an ifnfix expression, and convert it to a      /}
{/               postfix expression and then evaluate that postfix         /}
{/               expression to obtain a real result.                       /}
{/                                                                         /}
{///////////////////////////////////////////////////////////////////////////}


{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


CONST
  MainColor   = 1;              {* Color of the main background            *}
  TextColor   = 0;              {* Color of window text                    *}
  BackColor   = 7;              {* Color of window background              *}
  HeaderColor = 14;             {* Color of the header                     *}
  Highlight   = 5;              {* Color of highlighted text               *}
  ErrorText   = 31;             {* Color of the error message text         *}
  ErrorBack   = 4;              {* Color of the error message background   *}
  UpperXPos   = 5;              {* Upper X position of the window          *}
  UpperYPos   = 8;              {* Upper Y position of the window          *}
  Width       = 70;             {* Width of the window                     *}
  Height      = 10;             {* Height of the window                    *}

TYPE
  {* The different contents that a token can be *}
  ContentsType = (Operator,Operand,LeftParen,RtParen,EndExpression);

  {* An individual token in a stack taken from an expression *}
  TokenType    = RECORD  (* variant record! *)
                   (* Variant Part *)
                   CASE Contents : ContentsType  OF
                     Operator,
                     LeftParen     : (Character : Char);
                     Operand       : (Value : Real;
                                      StrPart : String);
                     RtParen       : ();
                     EndExpression : ();
                 END; (* TokenType *)

  {* Name used by StackADT for the elements of the stacks *}
  StackElementType = TokenType;

{===========================================================================}
{=                                                                         =}
{=                 This unit used just for type declarations.              =}
{=                   Not procedures or functions used here.                =}
{=                                                                         =}
{===========================================================================}


{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


{***************************************************************************}
{*                                                                         *}
{*                 This unit used just for type declarations.              *}
{*                   Not procedures or functions used here.                *}
{*                                                                         *}
{***************************************************************************}

END. {* Unit Prog2Data *}