UNIT GameCon3;

INTERFACE

PROCEDURE GamePart7 (VAR Game : Text);
PROCEDURE GamePart8 (VAR Game : Text);
PROCEDURE GamePart9 (VAR Game : Text);

IMPLEMENTATION

{***********************************}
PROCEDURE GamePart7 (VAR Game : Text);
BEGIN
  writeln (Game, '        else ifp prunningback action PRUNBACK');
  writeln (Game, '        else ifp pjumping');
  writeln (Game, '            action PJUMPING');
  writeln (Game, '        else ifp pducking action PDUCKING');
  writeln (Game, '    }');
  writeln (Game, '');
  writeln (Game, '    else ifaction PWALKBACK');
  writeln (Game, '    {');
  writeln (Game, '        ifp pstanding action PSTAND');
  writeln (Game, '        else ifp pwalking action PWALK');
  writeln (Game, '        else ifp prunning action PRUN');
  writeln (Game, '        else ifp prunningback action PRUNBACK');
  writeln (Game, '        else ifp pjumping');
  writeln (Game, '            action PJUMPING');
  writeln (Game, '        else ifp pducking action PDUCKING');
  writeln (Game, '    }');
  writeln (Game, '');
  writeln (Game, '    else ifaction PRUNBACK');
  writeln (Game, '    {');
  writeln (Game, '        ifp pstanding action PSTAND');
  writeln (Game, '        else ifp pwalking action PWALK');
  writeln (Game, '        else ifp prunning action PRUN');
  writeln (Game, '        else ifp pwalkingback action PWALKBACK');
  writeln (Game, '        else ifp pjumping');
  writeln (Game, '            action PJUMPING');
  writeln (Game, '        else ifp pducking action PDUCKING');
  writeln (Game, '    }');
  writeln (Game, 'enda');
  writeln (Game, '');
  writeln (Game, 'actor ORGANTIC TURRETSTRENGTH');
  writeln (Game, '    ifcount 48 resetcount');
  writeln (Game, '    else { ifcount 32 sizeto 32 32 }');
  writeln (Game, '    else ifcount 16 { sizeto 48 18 ifpdistl 2048 { sound TURR_ATTACK addphealth -2 palfrom 32 16 } }');
  writeln (Game, '    ifhitweapon { ifdead { addkills 1 sound TURR_DYING guts JIBS5 10 state delete_enemy } sound ',
                 'TURR_PAIN break }');
  writeln (Game, '    ifrnd 1 soundonce TURR_ROAM');
  writeln (Game, 'enda');
  writeln (Game, '');
  writeln (Game, 'state rf');
  writeln (Game, '    ifrnd 128 cstat 4');
  writeln (Game, '    else cstat 0');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, '');
  writeln (Game, '//');
  writeln (Game, '//');
  writeln (Game, '//      TROOP/LIZTROOP CODE');
  writeln (Game, '//');
  writeln (Game, '//');
  writeln (Game, '');
  writeln (Game, 'action ATROOPSTAND       0    1    5    1    1');
  writeln (Game, 'action ATROOPSTAYSTAND  -2    1    5    1    1');
  writeln (Game, 'action ATROOPWALKING     0    4    5    1   12');
  writeln (Game, 'action ATROOPWALKINGBACK 15   4    5   -1   12');
  writeln (Game, 'action ATROOPRUNNING     0    4    5    1    8');
  writeln (Game, 'action ATROOPSHOOT      35    1    5    1   30');
  writeln (Game, 'action ATROOPJETPACK    40    1    5    1    1');
  writeln (Game, 'action ATROOPJETPACKILL 40    2    5    1   50');
  writeln (Game, 'action ATROOPFLINTCH    50    1    1    1    6');
  writeln (Game, 'action ATROOPDYING      50    5    1    1   16');
  writeln (Game, 'action ATROOPDEAD       54');
  writeln (Game, 'action ATROOPPLAYDEAD   54');
  writeln (Game, 'action ATROOPSUFFERDEAD 58    2    1   -4   24');
  writeln (Game, 'action ATROOPSUFFERING  59    2    1    1   21');
  writeln (Game, 'action ATROOPDUCK       64    1    5    1    3');
  writeln (Game, 'action ATROOPDUCKSHOOT  64    2    5    1   25');
  writeln (Game, 'action ATROOPABOUTHIDE  74    1    1    1   25');
  writeln (Game, 'action ATROOPHIDE       79    1    1    1   25');
  writeln (Game, 'action ATROOPREAPPEAR   74    1    1    1   25');
  writeln (Game, 'action ATROOPFROZEN      0    1    5');
  writeln (Game, '');
  writeln (Game, 'move TROOPWALKVELS 72');
  writeln (Game, 'move TROOPWALKVELSBACK -72');
  writeln (Game, 'move TROOPJETPACKVELS 64 -84');
  writeln (Game, 'move TROOPJETPACKILLVELS 192 -38');
  writeln (Game, 'move TROOPRUNVELS 108');
  writeln (Game, 'move TROOPSTOPPED');
  writeln (Game, 'move DONTGETUP');
  writeln (Game, 'move SHRUNKVELS 32');
  writeln (Game, '');
  writeln (Game, 'ai AITROOPSEEKENEMY  ATROOPWALKING   TROOPWALKVELS seekplayer');
  writeln (Game, 'ai AITROOPSEEKPLAYER ATROOPWALKING   TROOPWALKVELS seekplayer');
  writeln (Game, 'ai AITROOPFLEEING    ATROOPWALKING   TROOPWALKVELS fleeenemy');
  writeln (Game, 'ai AITROOPFLEEINGBACK ATROOPWALKINGBACK   TROOPWALKVELSBACK faceplayer');
  writeln (Game, 'ai AITROOPDODGE      ATROOPWALKING   TROOPRUNVELS  dodgebullet');
  writeln (Game, 'ai AITROOPSHOOTING   ATROOPSHOOT     TROOPSTOPPED  faceplayer');
  writeln (Game, 'ai AITROOPDUCKING    ATROOPDUCK      TROOPSTOPPED  faceplayer');
  writeln (Game, 'ai AITROOPJETPACK    ATROOPJETPACK   TROOPJETPACKVELS seekplayer');
  writeln (Game, 'ai AITROOPSHRUNK     ATROOPWALKING   SHRUNKVELS fleeenemy');
  writeln (Game, 'ai AITROOPHIDE       ATROOPABOUTHIDE TROOPSTOPPED faceplayer');
  writeln (Game, '');
  writeln (Game, 'state troophidestate');
  writeln (Game, '    ifaction ATROOPREAPPEAR');
  writeln (Game, '    {');
  writeln (Game, '        ifactioncount 2 { sound TELEPORTER ai AITROOPSHOOTING cstat 257 }');
  writeln (Game, '        else { sizeto 41 40 sizeto 41 40 sizeto 41 40 sizeto 41 40 spawn FRAMEEFFECT1 }');
  writeln (Game, '    }');
  writeln (Game, '    else ifaction ATROOPWALKING');
  writeln (Game, '    {');
  writeln (Game, '        ifpdistl 2448 ifpdistg 1024');
  writeln (Game, '        {');
  writeln (Game, '            ifceilingdistl 48 break');
  writeln (Game, '            ifp pfacing break');
  writeln (Game, '');
  writeln (Game, '            ifgapzl 64 { } else ifawayfromwall { spawn TRANSPORTERSTAR action ',
                 'ATROOPREAPPEAR move 0 break }');
  writeln (Game, '        }');
  writeln (Game, '    }');
  writeln (Game, '    else ifaction ATROOPHIDE');
  writeln (Game, '    {');
  writeln (Game, '        ifactioncount 2');
  writeln (Game, '        {');
  writeln (Game, '            spawn TRANSPORTERSTAR');
  writeln (Game, '            sound TELEPORTER');
  writeln (Game, '            action ATROOPWALKING move TROOPWALKVELS faceplayer');
  writeln (Game, '            cstat 32768');
  writeln (Game, '        }');
  writeln (Game, '        else');
  writeln (Game, '        {');
  writeln (Game, '            sizeto 0 40');
  writeln (Game, '            sizeto 0 40');
  writeln (Game, '            sizeto 0 40');
  writeln (Game, '            sizeto 0 40');
  writeln (Game, '            spawn FRAMEEFFECT1');
  writeln (Game, '        }');
  writeln (Game, '    }');
  writeln (Game, '    else ifaction ATROOPABOUTHIDE ifactioncount 2 { action ATROOPHIDE cstat 0 }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, '');
  writeln (Game, 'state troopgunnashoot');
  writeln (Game, '    ifp palive');
  writeln (Game, '    {');
  writeln (Game, '        ifpdistl 1024 ai AITROOPSHOOTING');
  writeln (Game, '        else ifactornotstayput');
  writeln (Game, '        {');
  writeln (Game, '            ifactioncount 12 ifrnd 16 ifcanshoottarget');
  writeln (Game, '            {');
  writeln (Game, '                ifspritepal 21 ifrnd 4 ifpdistg 4096 ai AITROOPHIDE');
  writeln (Game, '                else');
  writeln (Game, '                {');
  writeln (Game, '                    ifpdistl 1100 ai AITROOPFLEEING');
  writeln (Game, '                    else');
  writeln (Game, '                    {');
  writeln (Game, '                        ifpdistl 4096 ifcansee ifcanshoottarget ai AITROOPSHOOTING');
  writeln (Game, '                        else { move TROOPRUNVELS seekplayer action ATROOPRUNNING }');
  writeln (Game, '                    }');
  writeln (Game, '                }');
  writeln (Game, '            }');
  writeln (Game, '        }');
  writeln (Game, '        else ifcount 26 ifrnd 32 ai AITROOPSHOOTING');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state troopseekstate');
  writeln (Game, '    state troopgunnashoot');
  writeln (Game, '    ifinwater { ai AITROOPJETPACK break }');
  writeln (Game, '    ifcansee');
  writeln (Game, '    {');
  writeln (Game, '        ifmove TROOPRUNVELS ifpdistl 1596 ai AITROOPDUCKING');
  writeln (Game, '        ifp phigher { ifceilingdistl 128 { } else ifactornotstayput ai AITROOPJETPACK break }');
  writeln (Game, '        else ifrnd 2');
  writeln (Game, '        {');
  writeln (Game, '            ifspritepal 21 ifpdistg 1596 { ai AITROOPHIDE break }');
  writeln (Game, '            ifbulletnear { ifrnd 128 ai AITROOPDODGE else ai AITROOPDUCKING break }');
  writeln (Game, '        }');
  writeln (Game, '    }');
  writeln (Game, '    ifnotmoving { ifrnd 32 operate else ifcount 32 ifp palive ifcansee ifcanshoottarget',
                 ' ai AITROOPSHOOTING }');
  writeln (Game, '    ifrnd 1');
  writeln (Game, '    {');
  writeln (Game, '        ifrnd 128 soundonce PRED_ROAM');
  writeln (Game, '        else soundonce PRED_ROAM2');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state troopduckstate');
  writeln (Game, '    ifaction ATROOPDUCK');
  writeln (Game, '        { ifactioncount 8 { ifp palive { ifrnd 128 action ATROOPDUCKSHOOT } else ifmove ',
                 'DONTGETUP break else ai AITROOPSEEKPLAYER } }');
  writeln (Game, '    else ifaction ATROOPDUCKSHOOT');
  writeln (Game, '    {');
  writeln (Game, '        ifcount 64');
  writeln (Game, '        {');
  writeln (Game, '            ifmove DONTGETUP resetcount');
  writeln (Game, '            else');
  writeln (Game, '            {');
  writeln (Game, '                ifpdistl 1100');
  writeln (Game, '                    ai AITROOPFLEEING');
  writeln (Game, '                else ai AITROOPSEEKPLAYER');
  writeln (Game, '            }');
  writeln (Game, '        }');
  writeln (Game, '        else ifactioncount 2 { ifcanshoottarget { sound PRED_ATTACK resetactioncount ',
                 'shoot FIRELASER } else ai AITROOPSEEKPLAYER }');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state troopshootstate');
  writeln (Game, '    ifactioncount 2');
  writeln (Game, '    {');
  writeln (Game, '        ifcanshoottarget');
  writeln (Game, '        {');
  writeln (Game, '            shoot FIRELASER sound PRED_ATTACK resetactioncount');
  writeln (Game, '            ifrnd 128 ai AITROOPSEEKPLAYER');
  writeln (Game, '            ifcount 24');
  writeln (Game, '            {');
  writeln (Game, '                ifrnd 96 ifpdistg 2048 ai AITROOPSEEKPLAYER');
  writeln (Game, '                else');
  writeln (Game, '                {');
  writeln (Game, '                    ifpdistg 1596 ai AITROOPFLEEING');
  writeln (Game, '                    else ai AITROOPFLEEINGBACK');
  writeln (Game, '                }');
  writeln (Game, '            }');
  writeln (Game, '        }');
  writeln (Game, '        else ai AITROOPSEEKPLAYER');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state troopfleestate');
  writeln (Game, '    ifactioncount 7');
  writeln (Game, '    {');
  writeln (Game, '        ifpdistg 3084 { ai AITROOPSEEKPLAYER break }');
  writeln (Game, '        else ifrnd 32 ifp palive ifcansee ifcanshoottarget { ifrnd 128 ai AITROOPDUCKING ',
                 'else ai AITROOPSHOOTING break }');
  writeln (Game, '    }');
  writeln (Game, '    ifnotmoving');
  writeln (Game, '    {');
  writeln (Game, '        ifrnd 32 operate else ifcount 32 ifp palive ifcansee ifcanshoottarget');
  writeln (Game, '            { ifrnd 128 ai AITROOPSHOOTING else ai AITROOPDUCKING }');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state troopdying');
  writeln (Game, '    iffloordistl 32 { ifactioncount 5 { cstat 0 iffloordistl 8 sound THUD ifrnd 64 spawn BLOODPOOL ',
                 'state rf strength 0 move TROOPSTOPPED action ATROOPDEAD } break }');
  writeln (Game, '    else { state rf move 0 action ATROOPDYING }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state checktroophit');
  writeln (Game, '    ifaction ATROOPSUFFERING { stopsound LIZARD_BEG sound PRED_DYING cstat 0 strength 0 action ',
                 'ATROOPSUFFERDEAD break }');
  writeln (Game, '    ifdead');
  writeln (Game, '    {');
  writeln (Game, '        ifwasweapon FREEZEBLAST { sound SOMETHINGFROZE spritepal 1 move 0 action ',
                 'ATROOPFROZEN strength 0 break }');
  writeln (Game, '');
  writeln (Game, '        state drop_ammo');
  writeln (Game, '        state random_wall_jibs');
  writeln (Game, '        addkills 1');
  writeln (Game, '');
  writeln (Game, '        ifwasweapon RPG { sound SQUISHED state troop_body_jibs state standard_jibs state delete_enemy }');
  writeln (Game, '        else ifwasweapon RADIUSEXPLOSION { sound SQUISHED state troop_body_jibs state standard_jibs ',
                 'state delete_enemy }');
  writeln (Game, '        else { sound PRED_DYING ifrnd 32 iffloordistl 32 { sound LIZARD_BEG spawn BLOODPOOL strength ',
                 '0 move 0 action ATROOPSUFFERING ',
                 'break } action ATROOPDYING break }');
  writeln (Game, '    }');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        state random_wall_jibs');
  writeln (Game, '        sound PRED_PAIN');
  writeln (Game, '        ifwasweapon SHRINKSPARK { sound ACTOR_SHRINKING ai AITROOPSHRUNK }');
  writeln (Game, '        else iffloordistl 32 ifrnd 96 action ATROOPFLINTCH');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state troopjetpackstate');
  writeln (Game, '    ifaction ATROOPJETPACKILL');
  writeln (Game, '    {');
  writeln (Game, '        ifcansee ifactioncount 2');
  writeln (Game, '        {');
  writeln (Game, '            resetactioncount');
  writeln (Game, '            sound PRED_ATTACK');
  writeln (Game, '            shoot FIRELASER');
  writeln (Game, '        }');
  writeln (Game, '');
  writeln (Game, '        ifp phigher ai AITROOPJETPACK');
  writeln (Game, '        else ifinwater ai AITROOPJETPACK');
  writeln (Game, '        else ifcount 26 iffloordistl 32 ai AITROOPSEEKPLAYER');
  writeln (Game, '    }');
  writeln (Game, '    else ifcount 48 ifcansee');
  writeln (Game, '        { action ATROOPJETPACKILL move TROOPJETPACKILLVELS seekplayer }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state checksquished');
  writeln (Game, '    ifsquished { addkills 1 sound SQUISHED state standard_jibs spawn OOZ state delete_enemy }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state troopsufferingstate');
  writeln (Game, '    ifactioncount 2');
  writeln (Game, '    {');
  writeln (Game, '        ifrnd 16 spawn WATERDRIP');
  writeln (Game, '        ifactioncount 14 { stopsound LIZARD_BEG cstat 0 strength 0 action ATROOPSUFFERDEAD break }');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state troopshrunkstate');
  writeln (Game, '    ifcount SHRUNKDONECOUNT ai AITROOPSEEKENEMY');
  writeln (Game, '    else ifcount SHRUNKCOUNT sizeto 48 40');
  writeln (Game, '    else state genericshrunkcode');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state troopcode fall');
  writeln (Game, '    ifinwater ifrnd 1 spawn WATERBUBBLE');
  writeln (Game, '    ifaction ATROOPSTAND { ifrnd 192 ai AITROOPSHOOTING else ai AITROOPSEEKPLAYER }');
  writeln (Game, '    else ifaction ATROOPFROZEN');
  writeln (Game, '    {');
  writeln (Game, '        ifcount THAWTIME { ai AITROOPSEEKENEMY getlastpal }');
  writeln (Game, '        else ifcount FROZENDRIPTIME { ifactioncount 26 { spawn WATERDRIP resetactioncount } }');
  writeln (Game, '        ifhitweapon');
  writeln (Game, '        {');
  writeln (Game, '            ifwasweapon FREEZEBLAST { strength 0 break }');
  writeln (Game, '            addkills 1');
  writeln (Game, '');
  writeln (Game, '            ifrnd 84 spawn BLOODPOOL');
  writeln (Game, '            lotsofglass 30');
  writeln (Game, '            sound GLASS_BREAKING');
  writeln (Game, '            killit');
  writeln (Game, '        }');
  writeln (Game, '        ifp pfacing ifpdistl FROZENQUICKKICKDIST pkick');
  writeln (Game, '        break');
  writeln (Game, '    }');
  writeln (Game, '    else ifaction ATROOPPLAYDEAD');
  writeln (Game, '    {');
  writeln (Game, '        ifhitweapon');
  writeln (Game, '        {');
  writeln (Game, '            ifwasweapon RADIUSEXPLOSION { sound SQUISHED state troop_body_jibs state standard_jibs ',
                 'state delete_enemy }');

END;

{***********************************}
PROCEDURE GamePart8 (VAR Game : Text);
BEGIN
  writeln (Game, '            break');
  writeln (Game, '        }');
  writeln (Game, '        else state checksquished');
  writeln (Game, '');
  writeln (Game, '        ifcount PLAYDEADTIME { addkills -1 soundonce PRED_ROAM cstat 257 strength 1 ai AITROOPSHOOTING }');
  writeln (Game, '        else ifp pfacing resetcount');
  writeln (Game, '');
  writeln (Game, '        break');
  writeln (Game, '    }');
  writeln (Game, '    else ifaction ATROOPDEAD');
  writeln (Game, '    {');
  writeln (Game, '        strength 0');
  writeln (Game, '        ifrespawn ifcount RESPAWNACTORTIME { spawn TRANSPORTERSTAR cstat 257 strength TROOPSTRENGTH ai ',
                 'AITROOPSEEKENEMY }');
  writeln (Game, '        ifhitweapon');
  writeln (Game, '        {');
  writeln (Game, '            ifwasweapon RADIUSEXPLOSION { sound SQUISHED state troop_body_jibs state standard_jibs ',
                 'state delete_enemy }');
  writeln (Game, '            break');
  writeln (Game, '        }');
  writeln (Game, '        else state checksquished');
  writeln (Game, '        break');
  writeln (Game, '    }');
  writeln (Game, '    else ifaction ATROOPSUFFERDEAD');
  writeln (Game, '    {');
  writeln (Game, '        ifactioncount 2');
  writeln (Game, '        {');
  writeln (Game, '            ifrnd 64 { resetcount action ATROOPPLAYDEAD }');
  writeln (Game, '            else { soundonce PRED_DYING action ATROOPDEAD }');
  writeln (Game, '        }');
  writeln (Game, '    }');
  writeln (Game, '    else ifaction ATROOPDYING { state troopdying break }');
  writeln (Game, '    else ifaction ATROOPSUFFERING');
  writeln (Game, '        { state troopsufferingstate ifhitweapon state checktroophit break }');
  writeln (Game, '    else ifaction ATROOPFLINTCH { ifactioncount 4 ai AITROOPSEEKENEMY }');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        ifai AITROOPSEEKPLAYER state troopseekstate');
  writeln (Game, '        else ifai AITROOPJETPACK');
  writeln (Game, '        {');
  writeln (Game, '            state troopjetpackstate');
  writeln (Game, '            ifinwater { } else soundonce DUKE_JETPACK_IDLE');
  writeln (Game, '        }');
  writeln (Game, '        else ifai AITROOPSEEKENEMY state troopseekstate');
  writeln (Game, '        else ifai AITROOPSHOOTING state troopshootstate');
  writeln (Game, '        else ifai AITROOPFLEEING state troopfleestate');
  writeln (Game, '        else ifai AITROOPFLEEINGBACK state troopfleestate');
  writeln (Game, '        else ifai AITROOPDODGE state troopseekstate');
  writeln (Game, '        else ifai AITROOPDUCKING state troopduckstate');
  writeln (Game, '        else ifai AITROOPSHRUNK state troopshrunkstate');
  writeln (Game, '        else ifai AITROOPHIDE { state troophidestate break }');
  writeln (Game, '    }');
  writeln (Game, '');
  writeln (Game, '    ifhitweapon state checktroophit else state checksquished');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, '');
  writeln (Game, 'actor LIZTROOPJETPACK TROOPSTRENGTH ai AITROOPJETPACK cactor LIZTROOP enda');
  writeln (Game, 'actor LIZTROOPDUCKING TROOPSTRENGTH');
  writeln (Game, '    ai AITROOPDUCKING cactor LIZTROOP');
  writeln (Game, '    ifgapzl 48 move DONTGETUP');
  writeln (Game, 'enda');
  writeln (Game, '');
  writeln (Game, 'actor LIZTROOPSHOOT TROOPSTRENGTH ATROOPSTAND ai AITROOPSHOOTING cactor LIZTROOP enda');
  writeln (Game, 'actor LIZTROOPSTAYPUT TROOPSTRENGTH ATROOPSTAYSTAND ai AITROOPSEEKPLAYER cactor LIZTROOP enda');
  writeln (Game, 'actor LIZTROOPRUNNING TROOPSTRENGTH ATROOPSTAND ai AITROOPSEEKPLAYER cactor LIZTROOP enda');
  writeln (Game, 'actor LIZTROOPONTOILET TROOPSTRENGTH ifcount 24 { sound FLUSH_TOILET operate ai AITROOPSEEKPLAYER ',
                 'cactor LIZTROOP } enda');
  writeln (Game, 'actor LIZTROOP TROOPSTRENGTH ATROOPSTAND state troopcode enda');
  writeln (Game, '');
  writeln (Game, 'action ALIZWALKING       0     4    5    1    15');
  writeln (Game, 'action ALIZRUNNING       0     4    5    1    11');
  writeln (Game, 'action ALIZTHINK         20    2    5    1    40');
  writeln (Game, 'action ALIZSCREAM        30    1    5    1    2');
  writeln (Game, 'action ALIZJUMP          45    3    5    1    20');
  writeln (Game, 'action ALIZFALL          55');
  writeln (Game, 'action ALIZSHOOTING      70    2    5    1    7');
  writeln (Game, 'action ALIZDYING         60    6    1    1    15');
  writeln (Game, 'action ALIZLYINGDEAD     65    1');
  writeln (Game, 'action ALIZFROZEN         0    1    5');
  writeln (Game, '');
  writeln (Game, 'move LIZWALKVEL 72');
  writeln (Game, 'move LIZRUNVEL 192');
  writeln (Game, 'move LIZJUMPVEL 184');
  writeln (Game, 'move LIZSTOP');
  writeln (Game, '');
  writeln (Game, 'ai AILIZGETENEMY ALIZWALKING LIZWALKVEL seekplayer');
  writeln (Game, 'ai AILIZDODGE ALIZRUNNING LIZRUNVEL dodgebullet');
  writeln (Game, 'ai AILIZCHARGEENEMY ALIZRUNNING LIZRUNVEL seekplayer');
  writeln (Game, 'ai AILIZFLEENEMY ALIZWALKING LIZWALKVEL fleeenemy');
  writeln (Game, 'ai AILIZSHOOTENEMY ALIZSHOOTING LIZSTOP faceplayer');
  writeln (Game, 'ai AILIZJUMPENEMY ALIZJUMP LIZJUMPVEL jumptoplayer');
  writeln (Game, 'ai AILIZTHINK ALIZTHINK LIZSTOP faceplayerslow');
  writeln (Game, 'ai AILIZSHRUNK ALIZWALKING SHRUNKVELS fleeenemy');
  writeln (Game, 'ai AILIZSPIT ALIZSCREAM LIZSTOP faceplayerslow');
  writeln (Game, 'ai AILIZDYING ALIZDYING LIZSTOP faceplayer');
  writeln (Game, '');
  writeln (Game, 'state lizseekstate');
  writeln (Game, '');
  writeln (Game, '    ifactornotstayput');
  writeln (Game, '    {');
  writeln (Game, '        ifcansee ifp palive ifpdistl 2048 ifcount 16 ifcanshoottarget { ai AILIZSHOOTENEMY break }');
  writeln (Game, '        ifai AILIZCHARGEENEMY');
  writeln (Game, '        {');
  writeln (Game, '            ifcount 72 ifcanshoottarget { ai AILIZSHOOTENEMY break }');
  writeln (Game, '            ifp phigher ifpdistg 2048 ifrnd 6 { ai AILIZJUMPENEMY break }');
  writeln (Game, '        }');
  writeln (Game, '        else ifpdistg 4096 { ifrnd 92 { ifcount 48 ifcanshoottarget ai AILIZSHOOTENEMY } else ifcount ',
                 '24 { ai AILIZCHARGEENEMY break } }');
  writeln (Game, '');
  writeln (Game, '        iffloordistl 16 { ifcount 48 ifnotmoving ifcansee { ai AILIZJUMPENEMY break } }');
  writeln (Game, '        else { ifpdistg 1280 ai AILIZJUMPENEMY break }');
  writeln (Game, '');
  writeln (Game, '        ifrnd 4 ifnotmoving operate');
  writeln (Game, '        else ifrnd 1 ifbulletnear');
  writeln (Game, '        {');
  writeln (Game, '            ifgapzl 128 ai AILIZDODGE');
  writeln (Game, '            else ifactornotstayput { ifrnd 32 ai AILIZJUMPENEMY else ai AILIZDODGE }');
  writeln (Game, '        }');
  writeln (Game, '    }');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        ifactioncount 16 { ifp palive ifrnd 32 ifcansee ifcanshoottarget ai AILIZSHOOTENEMY }');
  writeln (Game, '        ifcount 16 ifrnd 32 move LIZWALKVEL randomangle geth');
  writeln (Game, '    }');
  writeln (Game, '');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state lizshrunkstate');
  writeln (Game, '    ifcount SHRUNKDONECOUNT ai AILIZGETENEMY');
  writeln (Game, '    else ifcount SHRUNKCOUNT sizeto 48 40');
  writeln (Game, '    else state genericshrunkcode');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state lizfleestate');
  writeln (Game, '    ifcount 16 { ifrnd 48 ifp palive ifcansee ai AILIZSPIT }');
  writeln (Game, '    else { iffloordistl 16 { } else ai AILIZGETENEMY break }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state lizthinkstate');
  writeln (Game, '    ifrnd 8 soundonce CAPT_ROAM');
  writeln (Game, '    ifactioncount 3');
  writeln (Game, '    {');
  writeln (Game, '        ifrnd 32 ifp palive ifcansee ai AILIZSPIT');
  writeln (Game, '        else ifrnd 96 ai AILIZGETENEMY');
  writeln (Game, '    }');
  writeln (Game, '    else ifactioncount 2 ifrnd 1 spawn FECES');
  writeln (Game, '    ifrnd 1 ifbulletnear');
  writeln (Game, '    {');
  writeln (Game, '        ifgapzl 96 ai AILIZDODGE');
  writeln (Game, '        else { ifrnd 128 ai AILIZJUMPENEMY else ai AILIZDODGE }');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state lizshootstate');
  writeln (Game, '    ifcount 20 ifrnd 8');
  writeln (Game, '    {');
  writeln (Game, '        ifcansee ifpdistl 2048 { ifrnd 128 ai AILIZFLEENEMY break }');
  writeln (Game, '        ifrnd 80 ai AILIZTHINK else ai AILIZGETENEMY');
  writeln (Game, '    }');
  writeln (Game, '    ifactioncount 2');
  writeln (Game, '    {');
  writeln (Game, '        ifcansee');
  writeln (Game, '        {');
  writeln (Game, '            ifcanshoottarget { sound CAPT_ATTACK shoot SHOTSPARK1 resetactioncount }');
  writeln (Game, '            else ai AILIZTHINK');
  writeln (Game, '        }');
  writeln (Game, '        else ai AILIZGETENEMY');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state checklizhit');
  writeln (Game, '    spawn BLOOD');
  writeln (Game, '    ifai AILIZSHRUNK');
  writeln (Game, '        { addkills 1 sound SQUISHED state standard_jibs state delete_enemy }');
  writeln (Game, '    ifdead');
  writeln (Game, '    {');
  writeln (Game, '        ifwasweapon FREEZEBLAST { sound SOMETHINGFROZE spritepal 1 move 0 action ALIZFROZEN strength ',
                 '0 break }');
  writeln (Game, '');
  writeln (Game, '        state drop_chaingun');
  writeln (Game, '        addkills 1');
  writeln (Game, '');
  writeln (Game, '        ifwasweapon RPG { sound SQUISHED state liz_body_jibs state standard_jibs state delete_enemy }');
  writeln (Game, '        else ifwasweapon RADIUSEXPLOSION { sound SQUISHED state liz_body_jibs state standard_jibs state ',
                 'delete_enemy }');
  writeln (Game, '        else { state rf ai AILIZDYING ifrnd 64 spawn BLOODPOOL }');
  writeln (Game, '        sound CAPT_DYING');
  writeln (Game, '    }');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        sound CAPT_PAIN');
  writeln (Game, '        ifwasweapon SHRINKSPARK { sound ACTOR_SHRINKING ai AILIZSHRUNK break }');
  writeln (Game, '        state random_wall_jibs');
  writeln (Game, '        ifp palive ifcansee ifcanshoottarget { ai AILIZSHOOTENEMY break }');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state lizjumpstate');
  writeln (Game, '    ifaction ALIZFALL { iffloordistl 16 ai AILIZGETENEMY }');
  writeln (Game, '    else ifactioncount 3 action ALIZFALL');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state lizdyingstate');
  writeln (Game, '    ifaction ALIZLYINGDEAD');
  writeln (Game, '    {');
  writeln (Game, '        strength 0');
  writeln (Game, '        ifhitweapon ifwasweapon RADIUSEXPLOSION { sound SQUISHED state standard_jibs state delete_enemy }');
  writeln (Game, '        ifcount RESPAWNACTORTIME ifrespawn');
  writeln (Game, '        {');
  writeln (Game, '            spawn TRANSPORTERSTAR cstat 257 strength LIZSTRENGTH ai AILIZGETENEMY');
  writeln (Game, '        }');
  writeln (Game, '    }');
  writeln (Game, '    else ifai AILIZDYING ifactioncount 6 { iffloordistl 8 sound THUD move LIZSTOP action ALIZLYINGDEAD }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state lizdodgestate');
  writeln (Game, '    ifcount 13 ai AILIZGETENEMY');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'actor LIZMANSTAYPUT LIZSTRENGTH ai AILIZGETENEMY cactor LIZMAN enda');
  writeln (Game, 'actor LIZMANSPITTING LIZSTRENGTH ai AILIZSPIT cactor LIZMAN enda');
  writeln (Game, 'actor LIZMANJUMP LIZSTRENGTH ai AILIZJUMPENEMY cactor LIZMAN enda');
  writeln (Game, '');
  writeln (Game, 'actor LIZMAN LIZSTRENGTH fall');
  writeln (Game, '    state checksquished');
  writeln (Game, '    ifai 0 ai AILIZGETENEMY');
  writeln (Game, '    else ifaction ALIZLYINGDEAD { fall state lizdyingstate break }');
  writeln (Game, '    else ifaction ALIZFROZEN');
  writeln (Game, '    {');
  writeln (Game, '        ifcount THAWTIME { ai AILIZGETENEMY getlastpal }');
  writeln (Game, '        else ifcount FROZENDRIPTIME { ifactioncount 26 { spawn WATERDRIP resetactioncount } }');
  writeln (Game, '');
  writeln (Game, '        ifhitweapon');
  writeln (Game, '        {');
  writeln (Game, '            ifwasweapon FREEZEBLAST { strength 0 break }');
  writeln (Game, '            addkills 1');
  writeln (Game, '');
  writeln (Game, '            ifrnd 84 spawn BLOODPOOL');
  writeln (Game, '            lotsofglass 30');
  writeln (Game, '            sound GLASS_BREAKING');
  writeln (Game, '            killit');
  writeln (Game, '        }');
  writeln (Game, '        ifp pfacing ifpdistl FROZENQUICKKICKDIST pkick');
  writeln (Game, '        break');
  writeln (Game, '    }');
  writeln (Game, '    else ifai AILIZJUMPENEMY state lizjumpstate');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        fall');
  writeln (Game, '        ifai AILIZGETENEMY state lizseekstate');
  writeln (Game, '        else ifai AILIZCHARGEENEMY state lizseekstate');
  writeln (Game, '        else ifai AILIZDODGE state lizdodgestate');
  writeln (Game, '        else ifai AILIZSHOOTENEMY state lizshootstate');
  writeln (Game, '        else ifai AILIZFLEENEMY state lizfleestate');
  writeln (Game, '        else ifai AILIZTHINK state lizthinkstate');
  writeln (Game, '        else ifai AILIZSHRUNK state lizshrunkstate');
  writeln (Game, '        else ifai AILIZDYING state lizdyingstate');
  writeln (Game, '        else ifai AILIZSPIT');
  writeln (Game, '            { ifcount 26 ai AILIZGETENEMY else ifcount 18 ifrnd 96 { shoot SPIT sound LIZARD_SPIT } }');
  writeln (Game, '    }');
  writeln (Game, '');
  writeln (Game, '    ifai AILIZSHRUNK break');
  writeln (Game, '    ifhitweapon state checklizhit');
  writeln (Game, 'enda');
  writeln (Game, '');
  writeln (Game, 'action DRONEFRAMES     0   1   7   1   1');
  writeln (Game, 'action DRONESCREAM     0   1   7   1   1');
  writeln (Game, 'move DRONERUNVELS 128 64');
  writeln (Game, 'move DRONERUNUPVELS 128 -64');
  writeln (Game, 'move DRONEBULLVELS 252 -64');
  writeln (Game, 'move DRONEBACKWARDS -64 -64');
  writeln (Game, 'move DRONERISE 32 -32');
  writeln (Game, 'move DRONESTOPPED -16');
  writeln (Game, '');
  writeln (Game, 'ai AIDRONEGETE DRONESCREAM DRONERUNVELS faceplayerslow getv');
  writeln (Game, 'ai AIDRONEWAIT DRONEFRAMES DRONESTOPPED faceplayerslow');
  writeln (Game, 'ai AIDRONEGETUP DRONESCREAM DRONERUNUPVELS faceplayer getv');
  writeln (Game, 'ai AIDRONEPULLBACK DRONEFRAMES DRONEBACKWARDS faceplayerslow');
  writeln (Game, 'ai AIDRONEHIT DRONESCREAM DRONEBACKWARDS faceplayer');
  writeln (Game, 'ai AIDRONESHRUNK DRONEFRAMES SHRUNKVELS fleeenemy');
  writeln (Game, 'ai AIDRONEDODGE DRONEFRAMES DRONEBULLVELS dodgebullet geth');
  writeln (Game, 'ai AIDRONEDODGEUP DRONEFRAMES DRONERISE getv geth');
  writeln (Game, '');
  writeln (Game, 'state checkdronehitstate');
  writeln (Game, '');
  writeln (Game, '    ifdead');
  writeln (Game, '    {');
  writeln (Game, '        addkills 1');
  writeln (Game, '        debris SCRAP1 8');
  writeln (Game, '        debris SCRAP2 4');
  writeln (Game, '        debris SCRAP3 7');
  writeln (Game, '        spawn EXPLOSION2');
  writeln (Game, '        sound RPG_EXPLODE');
  writeln (Game, '        hitradius 2048 15 20 25 30');
  writeln (Game, '        killit');
  writeln (Game, '    }');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        sound DRON_PAIN');
  writeln (Game, '        ifbulletnear');
  writeln (Game, '        {');
  writeln (Game, '            ifceilingdistl 64 ifrnd 48 ai AIDRONEDODGE');
  writeln (Game, '            ai AIDRONEDODGEUP');
  writeln (Game, '        }');
  writeln (Game, '        else ai AIDRONEGETE');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state droneshrunkstate');
  writeln (Game, '    ifcount 24 state delete_enemy');
  writeln (Game, '    else sizeto 1 1');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state checkdronenearplayer');
  writeln (Game, '');
  writeln (Game, '    ifp palive ifpdistl 1596');
  writeln (Game, '    {');
  writeln (Game, '        ifcount 8');
  writeln (Game, '        {');
  writeln (Game, '            addkills 1');
  writeln (Game, '            sound DRON_ATTACK2');
  writeln (Game, '            debris SCRAP1 8');
  writeln (Game, '            debris SCRAP2 4');
  writeln (Game, '            debris SCRAP3 7');
  writeln (Game, '            spawn EXPLOSION2');
  writeln (Game, '            sound RPG_EXPLODE');
  writeln (Game, '            hitradius 2048 15 20 25 30');
  writeln (Game, '            killit');
  writeln (Game, '        }');
  writeln (Game, '        else ifcount 3 { } else sound LASERTRIP_ARMING');
  writeln (Game, '    }');
  writeln (Game, '');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state dronegetstate');
  writeln (Game, '    ifrnd 192');
  writeln (Game, '    {');
  writeln (Game, '        ifcansee');
  writeln (Game, '        {');
  writeln (Game, '            ifbulletnear { ai AIDRONEDODGE break }');
  writeln (Game, '            ifmove DRONEBULLVELS');
  writeln (Game, '            {');
  writeln (Game, '                ifcount 64 ai AIDRONEPULLBACK');
  writeln (Game, '                else ifnotmoving ifcount 16 ai AIDRONEPULLBACK');
  writeln (Game, '            }');
  writeln (Game, '            else ifcount 32');
  writeln (Game, '            {');
  writeln (Game, '                ifp phigher move DRONEBULLVELS geth getv');
  writeln (Game, '                else move DRONEBULLVELS geth');
  writeln (Game, '            }');
  writeln (Game, '        }');
  writeln (Game, '        else ifrnd 1 operate');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state dronedodgestate');
  writeln (Game, '    ifai AIDRONEDODGEUP');
  writeln (Game, '    {');
  writeln (Game, '       ifcount 8 ai AIDRONEGETE');
  writeln (Game, '       else ifnotmoving ai AIDRONEGETE');
  writeln (Game, '    }');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        ifcount 8 ai AIDRONEGETE');
  writeln (Game, '        else ifnotmoving ai AIDRONEGETE');

END;

{***********************************}
PROCEDURE GamePart9 (VAR Game : Text);
BEGIN
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'actor DRONE DRONESTRENGTH');
  writeln (Game, '    state checksquished');
  writeln (Game, '    state checkdronenearplayer');
  writeln (Game, '');
  writeln (Game, '    ifrnd 2 fall');
  writeln (Game, '    else soundonce DRON_JETSND');
  writeln (Game, '');
  writeln (Game, '    ifaction 0 ai AIDRONEGETE');
  writeln (Game, '');
  writeln (Game, '    else ifai AIDRONEWAIT');
  writeln (Game, '    {');
  writeln (Game, '        ifactioncount 4 ifrnd 16');
  writeln (Game, '            ifcansee { sound DRON_ATTACK1 ifp phigher ai AIDRONEGETUP else ai AIDRONEGETE }');
  writeln (Game, '    }');
  writeln (Game, '    else ifai AIDRONEGETE state dronegetstate');
  writeln (Game, '    else ifai AIDRONEGETUP state dronegetstate');
  writeln (Game, '    else ifai AIDRONEPULLBACK { ifcount 32 ai AIDRONEWAIT }');
  writeln (Game, '    else ifai AIDRONEHIT { ifcount 8 ai AIDRONEWAIT }');
  writeln (Game, '    else ifai AIDRONESHRUNK state droneshrunkstate');
  writeln (Game, '    else ifai AIDRONEDODGE state dronedodgestate');
  writeln (Game, '    else ifai AIDRONEDODGEUP state dronedodgestate');
  writeln (Game, '');
  writeln (Game, '    ifhitweapon state checkdronehitstate');
  writeln (Game, '');
  writeln (Game, '    ifrnd 1 soundonce DRON_ROAM');
  writeln (Game, '');
  writeln (Game, 'enda');
  writeln (Game, '');
  writeln (Game, '');
  writeln (Game, '');
  writeln (Game, 'action AOCTAWALK        0   3   5   1   15');
  writeln (Game, 'action AOCTASTAND       0   1   5   1   15');
  writeln (Game, 'action AOCTASCRATCH     0   4   5   1   15');
  writeln (Game, 'action AOCTAHIT        30   1   1   1   10');
  writeln (Game, 'action AOCTASHOOT      20   1   5   1   10');
  writeln (Game, 'action AOCTADYING      30   8   1   1   17');
  writeln (Game, 'action AOCTADEAD       38   1   1   1    1');
  writeln (Game, 'action AOCTAFROZEN      0   1   5');
  writeln (Game, '');
  writeln (Game, 'move OCTAWALKVELS 96 -30');
  writeln (Game, 'move OCTAUPVELS 96 -70');
  writeln (Game, 'move OCTASTOPPED 0 -30');
  writeln (Game, 'move OCTAINWATER 96 24');
  writeln (Game, '');
  writeln (Game, 'ai AIOCTAGETENEMY AOCTAWALK OCTAWALKVELS seekplayer');
  writeln (Game, 'ai AIOCTASHOOTENEMY AOCTASHOOT OCTASTOPPED faceplayer');
  writeln (Game, 'ai AIOCTASCRATCHENEMY AOCTASCRATCH OCTASTOPPED faceplayer');
  writeln (Game, 'ai AIOCTAHIT AOCTAHIT OCTASTOPPED faceplayer');
  writeln (Game, 'ai AIOCTASHRUNK AOCTAWALK SHRUNKVELS faceplayer');
  writeln (Game, 'ai AIOCTADYING AOCTADYING OCTASTOPPED faceplayer');
  writeln (Game, '');
  writeln (Game, 'state octagetenemystate');
  writeln (Game, '');
  writeln (Game, '    ifcansee');
  writeln (Game, '    {');
  writeln (Game, '        ifactioncount 32 { ifrnd 48 ifcanshoottarget { sound OCTA_ATTACK1 ai AIOCTASHOOTENEMY break } }');
  writeln (Game, '        else ifpdistl 1280 ai AIOCTASCRATCHENEMY');
  writeln (Game, '    }');
  writeln (Game, '');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state octascratchenemystate');
  writeln (Game, '    ifpdistg 1280 ai AIOCTAGETENEMY');
  writeln (Game, '    else ifcount 32 { resetcount sound OCTA_ATTACK2 palfrom 8 32 addphealth OCTASCRATCHINGPLAYER }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state octashootenemystate');
  writeln (Game, '    ifcount 25 { ifcount 27 ai AIOCTAGETENEMY }');
  writeln (Game, '    else ifcount 24 shoot COOLEXPLOSION1');
  writeln (Game, '    else ifactioncount 6 resetactioncount');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state checkoctahitstate');
  writeln (Game, '    ifwasweapon SHRINKSPARK { sound ACTOR_SHRINKING ai AIOCTASHRUNK }');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        ifdead');
  writeln (Game, '        {');
  writeln (Game, '            ifwasweapon FREEZEBLAST { sound SOMETHINGFROZE spritepal 1 move 0 action AOCTAFROZEN ',
                 'strength 0 break }');
  writeln (Game, '');
  writeln (Game, '            addkills 1');
  writeln (Game, '            ifwasweapon RPG { sound SQUISHED state standard_jibs state delete_enemy }');
  writeln (Game, '            else ifwasweapon RADIUSEXPLOSION { sound SQUISHED state standard_jibs state delete_enemy }');
  writeln (Game, '            else { state rf ai AIOCTADYING }');
  writeln (Game, '            sound OCTA_DYING');
  writeln (Game, '        }');
  writeln (Game, '        else');
  writeln (Game, '        {');
  writeln (Game, '            ifwasweapon RPG');
  writeln (Game, '            {');
  writeln (Game, '                sound OCTA_DYING');
  writeln (Game, '                addkills 1');
  writeln (Game, '                state standard_jibs');
  writeln (Game, '                killit');
  writeln (Game, '            }');
  writeln (Game, '            sound OCTA_PAIN spawn BLOOD');
  writeln (Game, '            ifrnd 64 ai AIOCTAHIT');
  writeln (Game, '');
  writeln (Game, '        }');
  writeln (Game, '    }');
  writeln (Game, '    state random_wall_jibs');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state octashrunkstate');
  writeln (Game, '    ifcount SHRUNKDONECOUNT ai AILIZGETENEMY');
  writeln (Game, '    else ifcount SHRUNKCOUNT sizeto 48 40');
  writeln (Game, '    else state genericshrunkcode');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state octadyingstate');
  writeln (Game, '    ifactioncount 8 { ifrnd 64 spawn BLOODPOOL move OCTASTOPPED action AOCTADEAD break }');
  writeln (Game, '    else ifactioncount 5 { } else ifactioncount 4 iffloordistl 8 sound THUD');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'actor OCTABRAINSTAYPUT OCTASTRENGTH ai AIOCTAGETENEMY cactor OCTABRAIN enda');
  writeln (Game, '');
  writeln (Game, 'actor OCTABRAIN OCTASTRENGTH fall');
  writeln (Game, '');
  writeln (Game, '    state checksquished');
  writeln (Game, '');
  writeln (Game, '    ifai 0 ai AIOCTAGETENEMY');
  writeln (Game, '    else ifaction AOCTADEAD');
  writeln (Game, '    {');
  writeln (Game, '        strength 0');
  writeln (Game, '        ifcount RESPAWNACTORTIME ifrespawn');
  writeln (Game, '            { addkills -1 spawn TRANSPORTERSTAR cstat 257 strength OCTASTRENGTH ai AIOCTAGETENEMY }');
  writeln (Game, '        ifhitweapon ifwasweapon RADIUSEXPLOSION { state standard_jibs killit }');
  writeln (Game, '        break');
  writeln (Game, '    }');
  writeln (Game, '    else ifaction AOCTAFROZEN');
  writeln (Game, '    {');
  writeln (Game, '        ifcount THAWTIME { ai AIOCTAGETENEMY getlastpal }');
  writeln (Game, '        else ifcount FROZENDRIPTIME { ifactioncount 26 { spawn WATERDRIP resetactioncount } }');
  writeln (Game, '');
  writeln (Game, '        ifhitweapon');
  writeln (Game, '        {');
  writeln (Game, '            addkills 1');
  writeln (Game, '            ifwasweapon FREEZEBLAST { strength 0 break }');
  writeln (Game, '');
  writeln (Game, '            lotsofglass 30');
  writeln (Game, '            ifrnd 84 spawn BLOODPOOL');
  writeln (Game, '            sound GLASS_BREAKING');
  writeln (Game, '            killit');
  writeln (Game, '        }');
  writeln (Game, '        ifp pfacing ifpdistl FROZENQUICKKICKDIST pkick');
  writeln (Game, '        break');
  writeln (Game, '    }');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        ifrnd 1 soundonce OCTA_ROAM');
  writeln (Game, '');
  writeln (Game, '        ifai AIOCTAGETENEMY state octagetenemystate');
  writeln (Game, '        else ifai AIOCTAHIT { ifcount 8 ai AIOCTASHOOTENEMY }');
  writeln (Game, '        else ifai AIOCTADYING { state octadyingstate break }');
  writeln (Game, '        else ifai AIOCTASCRATCHENEMY state octascratchenemystate');
  writeln (Game, '        else ifai AIOCTASHOOTENEMY state octashootenemystate');
  writeln (Game, '        else ifai AIOCTASHRUNK state octashrunkstate');
  writeln (Game, '');
  writeln (Game, '        ifmove OCTAUPVELS { } else ifp phigher move OCTAUPVELS seekplayer');
  writeln (Game, '        else ifmove OCTAINWATER { } else ifinwater move OCTAINWATER seekplayer');
  writeln (Game, '');
  writeln (Game, '        ifhitweapon state checkoctahitstate');
  writeln (Game, '    }');
  writeln (Game, 'enda');
  writeln (Game, '');
  writeln (Game, 'action APIGWALK         0  4 5 1 20');
  writeln (Game, 'action APIGRUN          0  4 5 1 11');
  writeln (Game, 'action APIGSHOOT        30 2 5 1 58');
  writeln (Game, 'action APIGCOCK         25 1 5 1 16');
  writeln (Game, 'action APIGSTAND        30 1 5 1 1');
  writeln (Game, 'action APIGDIVE         40 2 5 1 40');
  writeln (Game, 'action APIGDIVESHOOT    45 2 5 1 58');
  writeln (Game, 'action APIGDYING        55 5 1 1 15');
  writeln (Game, 'action APIGHIT          55 1 1 1 10');
  writeln (Game, 'action APIGDEAD         60 1 1 1 1');
  writeln (Game, 'action APIGFROZEN        0 1 5');
  writeln (Game, '');
  writeln (Game, 'move PIGWALKVELS 72');
  writeln (Game, 'move PIGRUNVELS 108');
  writeln (Game, 'move PIGSTOPPED');
  writeln (Game, '');
  writeln (Game, 'ai AIPIGSEEKENEMY APIGWALK PIGWALKVELS seekplayer');
  writeln (Game, 'ai AIPIGSHOOTENEMY APIGSHOOT PIGSTOPPED faceplayer');
  writeln (Game, 'ai AIPIGFLEEENEMY APIGWALK PIGWALKVELS fleeenemy');
  writeln (Game, 'ai AIPIGSHOOT APIGSHOOT PIGSTOPPED faceplayer');
  writeln (Game, 'ai AIPIGDODGE APIGRUN PIGRUNVELS dodgebullet');
  writeln (Game, 'ai AIPIGCHARGE APIGRUN PIGRUNVELS seekplayer');
  writeln (Game, 'ai AIPIGDIVING APIGDIVE PIGSTOPPED faceplayer');
  writeln (Game, 'ai AIPIGDYING APIGDYING PIGSTOPPED faceplayer');
  writeln (Game, 'ai AIPIGSHRINK APIGWALK SHRUNKVELS fleeenemy');
  writeln (Game, 'ai AIPIGHIT APIGHIT PIGSTOPPED faceplayer');
  writeln (Game, '');
  writeln (Game, 'state pigseekenemystate');
  writeln (Game, '');
  writeln (Game, '    ifai AIPIGCHARGE');
  writeln (Game, '    {');
  writeln (Game, '        ifcansee ifpdistl 3084');
  writeln (Game, '        {');
  writeln (Game, '            ifnotmoving ai AIPIGSEEKENEMY');
  writeln (Game, '            else ai AIPIGDIVING');
  writeln (Game, '        }');
  writeln (Game, '        break');
  writeln (Game, '    }');
  writeln (Game, '    else iffloordistl 32');
  writeln (Game, '    {');
  writeln (Game, '        ifpdistg 4096 { ifactornotstayput ai AIPIGCHARGE }');
  writeln (Game, '        ifrnd 8 { ifbulletnear ai AIPIGDODGE }');
  writeln (Game, '    }');
  writeln (Game, '');
  writeln (Game, '    ifrnd 128 ifcansee');
  writeln (Game, '    {');
  writeln (Game, '        ifai AIPIGDODGE { ifcount 32 ai AIPIGCHARGE break }');
  writeln (Game, '        iffloordistl 32');
  writeln (Game, '        {');
  writeln (Game, '            ifpdistl 1024 ifp palive ifcanshoottarget');
  writeln (Game, '                { ai AIPIGSHOOTENEMY break }');
  writeln (Game, '            ifcount 48 { ifrnd 8 ifp palive ifcanshoottarget { ifrnd 192 ai AIPIGSHOOTENEMY else ai ',
                 'AIPIGDIVING break } }');
  writeln (Game, '        }');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, '');
  writeln (Game, 'state pigshootenemystate');
  writeln (Game, '//    ifcansee');
  writeln (Game, '    {');
  writeln (Game, '        ifcount 12 { } else ifcount 11');
  writeln (Game, '        {');
  writeln (Game, '            ifcanshoottarget { sound PIG_ATTACK shoot SHOTGUN shoot SHOTGUN shoot SHOTGUN shoot ',
                 'SHOTGUN shoot SHOTGUN }');
  writeln (Game, '            else ai AIPIGSEEKENEMY');
  writeln (Game, '        }');
  writeln (Game, '        ifcount 25 { } else ifcount 24 { action APIGCOCK sound SHOTGUN_COCK }');
  writeln (Game, '        ifcount 48 { } else ifcount 47');
  writeln (Game, '        {');
  writeln (Game, '            ifcanshoottarget { sound PIG_ATTACK shoot SHOTGUN shoot SHOTGUN shoot SHOTGUN shoot ',
                 'SHOTGUN shoot SHOTGUN }');
  writeln (Game, '            else ai AIPIGSEEKENEMY');
  writeln (Game, '        }');
  writeln (Game, '        ifcount 60 { } else ifcount 59 { action APIGCOCK sound SHOTGUN_COCK }');
  writeln (Game, '        ifcount 72');
  writeln (Game, '        {');
  writeln (Game, '            ifrnd 64 resetcount');
  writeln (Game, '            else');
  writeln (Game, '            {');
  writeln (Game, '                ifpdistl 768 ai AIPIGFLEEENEMY');
  writeln (Game, '                else ai AIPIGSEEKENEMY');
  writeln (Game, '            }');
  writeln (Game, '        }');
  writeln (Game, '        ifaction APIGCOCK ifactioncount 2 action APIGSHOOT');
  writeln (Game, '    }');
  writeln (Game, '    else ai AIPIGSEEKENEMY');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state pigfleeenemystate');
  writeln (Game, '    ifactioncount 8 ai AIPIGSEEKENEMY');
  writeln (Game, '    else ifnotmoving ai AIPIGSEEKENEMY');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state pigdivestate');
  writeln (Game, '    ifaction APIGDIVESHOOT');
  writeln (Game, '    {');
  writeln (Game, '        ifcansee');
  writeln (Game, '        {');
  writeln (Game, '            ifcount 12 { } else ifcount 11');
  writeln (Game, '            {');
  writeln (Game, '                ifcanshoottarget { sound PIG_ATTACK shoot SHOTGUN shoot SHOTGUN shoot SHOTGUN ',
                 'shoot SHOTGUN }');
  writeln (Game, '                else ai AIPIGSEEKENEMY');
  writeln (Game, '            }');
  writeln (Game, '            ifcount 25 { } else ifcount 24 { sound SHOTGUN_COCK }');
  writeln (Game, '            ifcount 48 { } else ifcount 47');
  writeln (Game, '            {');
  writeln (Game, '                ifcanshoottarget { sound PIG_ATTACK shoot SHOTGUN shoot SHOTGUN shoot SHOTGUN ',
                 'shoot SHOTGUN }');
  writeln (Game, '                else ai AIPIGSEEKENEMY');
  writeln (Game, '            }');
  writeln (Game, '            ifcount 60 { } else ifcount 59');
  writeln (Game, '            {');
  writeln (Game, '                sound SHOTGUN_COCK');
  writeln (Game, '                ifgapzl 32 ai AIPIGDIVING');
  writeln (Game, '                else');
  writeln (Game, '                {');
  writeln (Game, '                    ifpdistl 4096 ai AIPIGFLEEENEMY');
  writeln (Game, '                    else ai AIPIGSEEKENEMY');
  writeln (Game, '                }');
  writeln (Game, '            }');
  writeln (Game, '        }');
  writeln (Game, '        else ifgapzl 32 ai AIPIGDIVING else ai AIPIGSEEKENEMY');
  writeln (Game, '    }');
  writeln (Game, '    else ifactioncount 2 ifp palive { resetcount action APIGDIVESHOOT }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state checkpighitstate');
  writeln (Game, '    spawn BLOOD');
  writeln (Game, '    ifdead');
  writeln (Game, '    {');
  writeln (Game, '        state random_wall_jibs');
  writeln (Game, '        ifrnd 16 spawn SHIELD else state drop_shotgun');
  writeln (Game, '        ifwasweapon FREEZEBLAST { sound SOMETHINGFROZE spritepal 1 move 0 action APIGFROZEN ',
                 'strength 0 break }');
  writeln (Game, '');
  writeln (Game, '        addkills 1');
  writeln (Game, '        ifwasweapon RADIUSEXPLOSION { sound SQUISHED state standard_jibs state delete_enemy }');
  writeln (Game, '        else ifwasweapon RPG { sound SQUISHED state standard_jibs state delete_enemy }');
  writeln (Game, '        ai AIPIGDYING sound PIG_DYING');
  writeln (Game, '    }');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        sound PIG_PAIN');
  writeln (Game, '        state random_wall_jibs');
  writeln (Game, '');
  writeln (Game, '        ifwasweapon SHRINKSPARK { sound ACTOR_SHRINKING ai AIPIGSHRINK }');
  writeln (Game, '        else ifrnd 64 ai AIPIGHIT');
  writeln (Game, '        else ifrnd 64 ai AIPIGSHOOTENEMY');
  writeln (Game, '        else ifrnd 64 { ai AIPIGDIVING action APIGDIVESHOOT }');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state pigshrinkstate');
  writeln (Game, '    ifcount SHRUNKDONECOUNT ai AIPIGSEEKENEMY');
  writeln (Game, '    else ifcount SHRUNKCOUNT sizeto 48 40');
  writeln (Game, '    else state genericshrunkcode');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state pigdyingstate');
  writeln (Game, '    ifactioncount 5 { ifrnd 64 spawn BLOODPOOL state rf iffloordistl 8 sound THUD action APIGDEAD move ',
                 'PIGSTOPPED break }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, '');
  writeln (Game, '');
  writeln (Game, 'actor PIGCOPDIVE PIGCOPSTRENGTH ai AIPIGDIVING action APIGDIVESHOOT cactor PIGCOP enda');
  writeln (Game, 'actor PIGCOPSTAYPUT PIGCOPSTRENGTH ai AIPIGSEEKENEMY cactor PIGCOP enda');
  writeln (Game, 'actor PIGCOP PIGCOPSTRENGTH APIGSTAND fall');
  writeln (Game, '    state checksquished');
  writeln (Game, '    ifaction APIGSTAND ai AIPIGSEEKENEMY');
  writeln (Game, '    else ifaction APIGDEAD');
  writeln (Game, '    {');
  writeln (Game, '        ifrespawn ifcount RESPAWNACTORTIME');
  writeln (Game, '            { spawn TRANSPORTERSTAR cstat 257 strength PIGCOPSTRENGTH ai AIPIGSEEKENEMY }');
  writeln (Game, '        else { strength 0 ifhitweapon ifwasweapon RADIUSEXPLOSION { sound SQUISHED state standard_jibs ',
                 'state delete_enemy } break }');
  writeln (Game, '    }');
  writeln (Game, '    else ifaction APIGFROZEN');
  writeln (Game, '    {');
  writeln (Game, '        ifcount THAWTIME { ai AIPIGSEEKENEMY getlastpal }');
  writeln (Game, '        else ifcount FROZENDRIPTIME ifrnd 8 spawn WATERDRIP');
  writeln (Game, '');
  writeln (Game, '        ifhitweapon');
  writeln (Game, '        {');
  writeln (Game, '            ifwasweapon FREEZEBLAST { strength 0 break }');
  writeln (Game, '            addkills 1');
  writeln (Game, '');
  writeln (Game, '            lotsofglass 30');
  writeln (Game, '            ifrnd 84 spawn BLOODPOOL');
  writeln (Game, '            sound GLASS_BREAKING');
  writeln (Game, '            killit');
  writeln (Game, '        }');
  writeln (Game, '        ifp pfacing ifpdistl FROZENQUICKKICKDIST pkick');
  writeln (Game, '        break');
  writeln (Game, '    }');
  writeln (Game, '    else ifai AIPIGDYING state pigdyingstate');
  writeln (Game, '    else ifai AIPIGHIT { ifactioncount 3 ai AIPIGSEEKENEMY }');
  writeln (Game, '    else ifai AIPIGSHRINK state pigshrinkstate');

END;

{***********************************}

END.