program wall_hit;

uses crt;

const
  run_time = 500;
  hard     = 50;
  medium   = 100;
  easy     = 150;

var
  start,
  selec,
  chnge,
  speed,
  level  : char;
  time,
  s,
  x,
  y,
  dly        : integer;
  hit,
  up_down,
  left_right : boolean;

{****************************************************************************}
procedure wrtat (x,y : integer; str : string);
begin
  gotoXY (x,y);
  write (str);
end;
{****************************************************************************}
procedure screen_setup;
begin
  textbackground (1);
  clrscr;
  textbackground (0);
  window (2,2,79,24);
  clrscr;
  window (1,1,80,25);
  textcolor (15);
end;
{****************************************************************************}
procedure writeat (x,y : integer);
begin
  gotoXY (x,y);
  write ('');
  textcolor (0);
  gotoXY (x+1,y);
  write (' ');
  gotoXY (x+1,y);
  textcolor (15);
end;
{****************************************************************************}
procedure clear;
begin
  gotoXY (x,y);
  write (' ');
end;
{****************************************************************************}
procedure snd (s : integer);
begin
  sound (s);
  delay (1);
  nosound;
end;
{****************************************************************************}
procedure change_direction;
begin
  case x of
     3 : left_right := true;
    78 : left_right := false;
  end;
  case y of
     2 : up_down := true;
    24 : up_down := false;
  end;
end;
{****************************************************************************}
procedure move;
var
  dir : integer;
  direction : char;
begin
 direction := readkey;
 dir := ord(direction);
 case dir of
   72 : up_down := false;
   80 : up_down := true;
   77 : left_right := true;
   75 : left_right := false;
 end;
end;
{****************************************************************************}
procedure level_1;
begin
  hit := false;
  writeat (39,10);
  writeat (40,10);
  writeat (41,10);
  if (x = 2) or (x = 78) or (y = 2) or (y = 24) or (time = 0) or
  ((x = 40) and (y = 10)) or ((x = 42) and (y = 10)) or ((x = 39) and (y = 10))
    then hit := true;
  time := time - 1;
  if time = -1 then time := 0;
end;
{****************************************************************************}
procedure level_2;
begin
  hit := false;
  writeat (28,13);
  writeat (29,13);
  writeat (30,13);
  writeat (50,13);
  writeat (51,13);
  writeat (52,13);
  if (x = 2) or (x = 78) or (y = 2) or (y = 24) or (time = 0)
  or (((x = 28) or (x = 29) or (x = 30)) and (y = 13))
  or (((x = 50) or (x = 51) or (x = 52)) and (y = 13))
    then hit := true;
  time := time - 1;
  if time = -1 then time := 0;
end;
{****************************************************************************}
procedure level_3;
begin
  hit := false;
  writeat (16,18);
  writeat (17,18);
  writeat (18,18);
  writeat (39,7);
  writeat (40,7);
  writeat (41,7);
  writeat (62,18);
  writeat (63,18);
  writeat (64,18);
  if (x = 2) or (x = 78) or (y = 2) or (y = 24) or (time = 0)
  or (((x = 16) or (x = 17) or (x = 18)) and (y = 18))
  or (((x = 39) or (x = 40) or (x = 41)) and (y = 7))
  or (((x = 62) or (x = 63) or (x = 64)) and (y = 18))
    then hit := true;
  time := time - 1;
  if time = -1 then time := 0;
end;
{****************************************************************************}
procedure level_4;
begin
  hit := false;
  writeat (16,18);
  writeat (17,18);
  writeat (18,18);

  writeat (16,7);
  writeat (17,7);
  writeat (18,7);

  writeat (62,7);
  writeat (63,7);
  writeat (64,7);

  writeat (62,18);
  writeat (63,18);
  writeat (64,18);
  if (x = 2) or (x = 78) or (y = 2) or (y = 24) or (time = 0)
  or (((x = 16) or (x = 17) or (x = 18)) and ((y = 18) or (y = 7)))
  or (((x = 62) or (x = 63) or (x = 64)) and ((y = 18) or (y = 7)))
    then hit := true;
  time := time - 1;
  if time = -1 then time := 0;
end;
{****************************************************************************}
procedure level_5;
begin
  hit := false;
  writeat (16,18);
  writeat (17,18);
  writeat (18,18);

  writeat (16,7);
  writeat (17,7);
  writeat (18,7);

  writeat (39,12);
  writeat (40,12);
  writeat (41,12);

  writeat (62,7);
  writeat (63,7);
  writeat (64,7);

  writeat (62,18);
  writeat (63,18);
  writeat (64,18);
  if (x = 2) or (x = 78) or (y = 2) or (y = 24) or (time = 0)
  or (((x = 16) or (x = 17) or (x = 18)) and ((y = 18) or (y = 7)))
  or (((x = 39) or (x = 40) or (x = 41)) and (y = 12))
  or (((x = 62) or (x = 63) or (x = 64)) and ((y = 18) or (y = 7)))
    then hit := true;
  time := time - 1;
  if time = -1 then time := 0;
end;
{****************************************************************************}
procedure go;
begin
  delay (1400);
  textcolor (red);
  writeat (39, 10);
  sound (1000);
  delay (100);
  nosound;
  delay (1400);
  textcolor (yellow);
  writeat (39, 10);
  sound (1000);
  delay (100);
  nosound;
  delay (1400);
  textcolor (green);
  writeat (39,10);
  sound (1500);
  delay (1000);
  nosound;
  textcolor (15);
  gotoXY (39,10);
  write (' ');
end;
{****************************************************************************}
procedure ending;
begin
  if time = 0
    then
      begin
        clrscr;
        gotoXY (25,14);
        write ('Congratulations for freeing level ', level, '!!');
      end
    else
      begin
        clrscr;
        gotoXY (30,14);
        write ('Better luck next time.');
      end;
  readln;
end;
{****************************************************************************}
procedure initialize;
begin
  up_down := true;
  left_right := true;
  x := 3;
  y := 3;
  level := '1';
  speed := '2';
  start := 'Y';
  speed := '1';
  time := run_time;
  case level of
    '1' : level_1;
    '2' : level_2;
    '3' : level_3;
    '4' : level_4;
    '5' : level_5;
  end;
  case speed of
    '1' : dly := easy;
    '2' : dly := medium;
    '3' : dly := hard;
  end;
end;
{****************************************************************************}
procedure movement;
begin
  repeat
    gotoXY (2,1);
    write ('   ');
    gotoXY (2,1);
    write (time);
    change_direction;
    case up_down of
      true  : y := y + 1;
      false : y := y - 1;
    end;
    case left_right of
      true  : x := x + 1;
      false : x := x - 1;
    end;
    case level of
      '1' : level_1;
      '2' : level_2;
      '3' : level_3;
      '4' : level_4;
      '5' : level_5;
    end;
    writeat (x,y);
    if keypressed then
      move;
    delay (dly);
    clear;
  until hit = true;
end;
{****************************************************************************}
procedure run;
begin
  repeat
    initialize;
    if start = 'Y'
      then
        begin
          screen_setup;
          go;
          movement;
          ending;
        end;
  until start = 'N';
end;
{****************************************************************************}
begin
  run;
end.