{----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<} UNIT SELECT; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{----------------------------------------------------------------------------}



{----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{----------------------------------------------------------------------------}



USES CRT, UTILITY;

Procedure SELECTBAR (text, background, width, height : byte;
                     var cursor : byte; var choice : char);



{----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{----------------------------------------------------------------------------}



{============================================================================}

{****************** Moves about in a vertical selection bar *****************}

Procedure SELECTBAR (text, background, width, height : byte;
                     var cursor : byte; var choice : char);

Begin
  TCTB (text, background);
  WRTC (2, cursor, #16);
  WRTC ((width + 3), cursor, #17);
  repeat
    HIDECURSOR (1, cursor, background);
    choice := readkey;
    case choice of
      #80 : begin
              TCTB (background, background);
              WRTC (2, cursor, ' ');
              WRTC ((width + 3), cursor, ' ');
              if cursor = height
                then cursor := 1
                else inc(cursor);
              TCTB (text, background);
              WRTC (2, cursor, #16);
              WRTC ((width + 3), cursor, #17);
            end;
      #72 : begin
              TCTB (background, background);
              WRTC (2, cursor, ' ');
              WRTC ((width + 3), cursor, ' ');
              if cursor = 1
                then cursor := height
                else dec(cursor);
              TCTB (text, background);
              WRTC (2, cursor, #16);
              WRTC ((width + 3), cursor, #17);
            end;
    end;
  until (choice = #13) or (choice = #27);

End;

{============================================================================}

END. {*** UNIT SELECT ***}
