{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<} Unit OPTIONDM; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



Uses CRT, WIEDERDM, POPUPSDM, DOSDM;

var
  openwin : boolean;
  count   : byte;

procedure CLEANWIN   (x_position : byte; fix : string; choice : char);
procedure DOS        (var cursor, menupos : byte; var choice : char);
procedure EXIT       (var cursor, menupos : byte; var choice : char);
procedure HELP       (var cursor, menupos : byte; var choice : char);
procedure DOSMENUS;



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{=============================================================================}
procedure CLEANWIN (x_position : byte; fix : string; choice : char);

Begin
  if (choice = #27) or (choice = #75) or (choice = #77) or
     (choice = #32) or (choice = #45) or (choice = #35) or
     (choice = #59) or (choice = #60) or (choice = #61)
    then
      begin
        CLEAR (15,1,3,3,78,23);
        REGWIN;
        WRTS (x_position,2,fix);
        HIDECURSOR (1,1,7);
      end
    else HIDECURSOR (1,1,3);
End;

{=============================================================================}
procedure DOS (var cursor, menupos : byte; var choice : char);

Begin
  menupos := 1;
  openwin := true;
  DOSMENU;
  SELECTBAR (2,11,1,2,cursor,menupos,choice);
  CLEANWIN (4,'',choice);
End;

{=============================================================================}
procedure EXIT (var cursor, menupos : byte; var choice : char);

Begin
  menupos := 2;
  openwin := true;
  EXITMENU;
  SELECTBAR (2,9,1,2,cursor,menupos,choice);
  CLEANWIN (20,'',choice);
End;

{=============================================================================}
procedure HELP (var cursor, menupos : byte; var choice : char);

Begin
  menupos := 3;
  openwin := true;
  HELPMENU;
  SELECTBAR (2,8,1,2,cursor,menupos,choice);
  CLEANWIN (64,'',choice);
End;

{=============================================================================}
procedure DOSMENUS;

var
  choice   : char;
  menupos,
  cursor   : byte;


{#############################################################################}
procedure enter;

var
  exitoption : char;

Begin
  if openwin = true
    then
      begin
        case menupos of
          1 : DODOS (cursor);
          2 : choice := #27;
          3 : case cursor of
                1 : HELPWIN;
                2 : ABOUTWIN;
              end;
        end;  { case menupos }
        CLEAR (1,1,3,3,78,23);
        REGWIN;
        case menupos of
          1 : DOS (cursor,menupos,choice);
          2 : CLEANWIN (20,'',choice);
          3 : HELP (cursor,menupos,choice);
        end;
      end;  { then }
End;

{#############################################################################}
procedure escape;

Begin
  if openwin = false
    then
      begin
        choice := #13;
        cursor := 2;
        menupos := 2;
      end;
  if openwin = true then openwin := false;
End;

{#############################################################################}
procedure shift;

Begin
  if choice = #75 then dec(menupos);
  if choice = #77 then inc(menupos);
  if menupos = 0 then menupos := 3;
  if menupos = 4 then menupos := 1;
  case menupos of
    1 : DOS (cursor,menupos,choice);
    2 : EXIT (cursor,menupos,choice);
    3 : HELP (cursor,menupos,choice);
  end;
End;

{#############################################################################}

Begin
  openwin := false;
  BACKGROUND;
  OPENSCREEN;
  repeat
    if (choice = #32) or (choice = #45) or (choice = #35) or
       (choice = #59) or (choice = #60) or (choice = #61) or
       (choice = #75) or (choice = #77) or (choice = #27) or
       (openwin = false) then cursor := 1;
    if (openwin = false) then choice := readkey;
    case choice of
      #13 : ENTER;
      #27 : ESCAPE;
      #75 : if openwin = true then SHIFT;
      #77 : if openwin = true then SHIFT;
      #32 : DOS (cursor,menupos,choice);
      #45 : EXIT (cursor,menupos,choice);
      #35 : HELP (cursor,menupos,choice);
      #59 : DOS (cursor,menupos,choice);
      #60 : EXIT (cursor,menupos,choice);
      #61 : HELP (cursor,menupos,choice);
    end;
  until (choice = #13) and
        ((cursor = 2) and (menupos = 2));
End;

{=============================================================================}

END.  {** Unit OPTION **}