{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} UNIT MENUS; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



USES UTILITY, CRT;

Var
  chrc : char;

  Procedure HEADING      (MenuText, MenuBack, CutText, CutBack : byte);
  Procedure HEADER;
  Procedure BACKGROUND   (MenuText, MenuBack, CutText, CutBack,
                          MainBorder, MainBack,maintext,wintype : byte);
  Procedure FILEMENU     (MenuText, MenuBack, CutText, CutBack, SelecText,
                          SelecBack, MainText, MainBack, wincolor, wintext,
                          winborder, wintype : byte);
  Procedure PERIODMENU   (wincolor, wintext, winborder, wintype : byte);
  Procedure PRINTMENU    (wincolor, wintext, winborder, wintype : byte);
  Procedure NEWMENU      (wincolor, wintext, winborder, wintype : byte);
  Procedure ADDMENU      (MenuText, MenuBack, CutText, CutBack, SelecText,
                          SelecBack, MainText, MainBack, wincolor, wintext,
                          winborder, wintype : byte);
  Procedure SEARCHMENU   (MenuText, MenuBack, CutText, CutBack, SelecText,
                          SelecBack, MainText, MainBack, wincolor, wintext,
                          winborder, wintype : byte);
  Procedure VIEWMENU     (MenuText, MenuBack, CutText, CutBack, SelecText,
                          SelecBack, MainText, MainBack, wincolor, wintext,
                          winborder, wintype : byte);
  Procedure EDITMENU     (MenuText, MenuBack, CutText, CutBack, SelecText,
                          SelecBack, MainText, MainBack, wincolor, wintext,
                          winborder, wintype : byte);
  Procedure HELPMENU     (MenuText, MenuBack, CutText, CutBack, SelecText,
                          SelecBack, MainText, MainBack, wincolor, wintext,
                          winborder, wintype : byte);
  Procedure NOSTUDWIN    (wincolor, wintext, winborder, wintype : byte);
  Procedure NOGRADEWIN   (wincolor, wintext, winborder, wintype : byte);
  Procedure GRADEFULLWIN (wincolor, wintext, winborder, wintype : byte);
  Procedure DONE         (wincolor, wintext, winborder, wintype : byte);
  Procedure AYSURE       (wincolor, wintext, winborder, wintype : byte;
                          var chrc : char);
  Procedure EXITCHECK    (wincolor, wintext, winborder, wintype,
                          MainText, MainBack, MenuText, MenuBack,
                          CutText, CutBack : byte; var chrc : char);
  Procedure VABACKGROUND (gradepos, maxdgrades, MainBold, MainBack : byte;
                          var seed, seed2 : byte);



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{=============================================================================}

{***************** Creates the heading for the background ********************}

Procedure HEADING (MenuText, MenuBack, CutText, CutBack : byte);

Begin
  CLEAR (MenuText,MenuBack,1,1,80,1);
  write ('     ile     dd     earch     iew     dit ');
  WRTS (64,1,' elp');
  TCTB (14,0);
  WRTS (75,1,' WG2 ');
  TCTB (CutText,CutBack);
  WRTC (5,1,'F');
  WRTC (13,1,'A');
  WRTC (20,1,'S');
  WRTC (30,1,'V');
  WRTC (38,1,'E');
  WRTC (64,1,'H');
End;

{=============================================================================}

{*************** Creates the background for the main screen ******************}

Procedure BACKGROUND (MenuText,MenuBack,CutText,CutBack,MainBorder,
                      MainBack,maintext,wintype : byte);

Begin
  HEADING (MenuText, MenuBack, CutText, CutBack);
  CLEAR (MainBack,MainBack,1,2,80,25);
  MAKEWIN (false,true,MainBorder,wintype,maintext,MainBack,2,2,78,24);
  REGWIN;
  TCTB (MainBorder,MainBack);
  WRTS (61,25, ' WiederGrades 2.0');
  WRTS (4,2,' Teacher:');
  WRTS (4,25,' PERIOD 1 ');
End;

{=============================================================================}

{****************** Creates the header for the search option *****************}

Procedure HEADER;

Begin
  WRTS (10,1,'Name');
  WRTS (25,1,'ID Number');
  WRTS (40,1,'Daily Ave');
  WRTS (53,1,' Test Ave');
  WRTS (65,1,'Total Ave');
  writeln;
  writeln;
End;

{=============================================================================}

{************************ Creates the file menu ******************************}

Procedure FILEMENU (MenuText, MenuBack, CutText, CutBack, SelecText,
                    SelecBack, MainText, MainBack, wincolor, wintext,
                    winborder, wintype : byte);

Begin
  HEADING (MenuText, MenuBack, CutText, CutBack);
  TCTB (SelecText,SelecBack);
  WRTS (4,1,' File ');
  CLEAR (MainText,MainBack,3,3,78,24);
  MAKEWIN (true,true,winborder,wintype,wintext,wincolor,4,3,11,6);
  writeln ('  Load');
  writeln ('  Print');
  writeln ('  New');
  write   ('  Exit');
End;

{=============================================================================}

{************************ Creates the period menu ****************************}

Procedure PERIODMENU (wincolor, wintext, winborder, wintype : byte);

var
  count : byte;

Begin
  MAKEWIN (true,true,winborder,wintype,wintext,wincolor,33,6,14,9);
  for count := 1 to 6 do
  writeln ('  Period ', count);
  write ('  Period 7');
End;

{=============================================================================}

{*********************** Creates the print menu ******************************}

Procedure PRINTMENU (wincolor, wintext, winborder, wintype : byte);

Begin
  MAKEWIN (true,true,winborder,wintype,wintext,wincolor,29,9,17,5);
  writeln ('  ClassReport');
  writeln ('  OneStudent');
  write   ('  AllStudents');
End;

{=============================================================================}

{************************ Creates the new menu *******************************}

Procedure NEWMENU (wincolor, wintext, winborder, wintype : byte);

Begin
  MAKEWIN (true,true,winborder,wintype,wintext,wincolor,31,10,17,4);
  writeln ('  NewSixWeeks');
  write   ('  NewYear');
End;

{=============================================================================}

{************************ Creates the add menu *******************************}

Procedure ADDMENU (MenuText, MenuBack, CutText, CutBack, SelecText,
                   SelecBack, MainText, MainBack, wincolor, wintext,
                   winborder, wintype : byte);

Begin
  HEADING (MenuText, MenuBack, CutText, CutBack);
  TCTB (SelecText,SelecBack);
  WRTS (12,1,' Add ');
  CLEAR (MainText,MainBack,3,3,78,24);
  MAKEWIN (true,true,winborder,wintype,wintext,wincolor,12,3,17,7);
  writeln ('  Students');
  writeln ('  DailyNames');
  writeln ('  TestNames');
  writeln ('  DailyGrades');
  write   ('  TestGrades');
End;

{=============================================================================}

{*********************** Creates the search menu *****************************}

Procedure SEARCHMENU (MenuText, MenuBack, CutText, CutBack, SelecText,
                      SelecBack, MainText, MainBack, wincolor, wintext,
                      winborder, wintype : byte);

Begin
  HEADING (MenuText, MenuBack, CutText, CutBack);
  TCTB (SelecText,SelecBack);
  WRTS (19,1,' Search ');
  CLEAR (MainText,MainBack,3,3,78,24);
  MAKEWIN (true,true,winborder,wintype,wintext,wincolor,19,3,15,5);
  writeln ('  FirstName');
  writeln ('  LastName');
  write   ('  IDNumber');
End;

{=============================================================================}

{************************* Creates the view menu *****************************}

Procedure VIEWMENU (MenuText, MenuBack, CutText, CutBack, SelecText,
                    SelecBack, MainText, MainBack, wincolor, wintext,
                    winborder, wintype : byte);

Begin
  HEADING (MenuText, MenuBack, CutText, CutBack);
  TCTB (SelecText,SelecBack);
  WRTS (29,1,' View ');
  CLEAR (MainText,MainBack,3,3,78,24);
  MAKEWIN (true,true,winborder,wintype,wintext,wincolor,29,3,17,4);
  writeln ('  AllAverages');
  write   ('  ClassGrades');
End;

{=============================================================================}

{************************* Creates the edit menu *****************************}

Procedure EDITMENU (MenuText, MenuBack, CutText, CutBack, SelecText,
                    SelecBack, MainText, MainBack, wincolor, wintext,
                    winborder, wintype : byte);

Begin
  HEADING (MenuText, MenuBack, CutText, CutBack);
  TCTB (SelecText,SelecBack);
  WRTS (37,1,' Edit ');
  CLEAR (MainText,MainBack,3,3,78,24);
  MAKEWIN (true,true,winborder,wintype,wintext,wincolor,37,3,17,12);
  writeln ('  Name');
  writeln ('  IDNumber');
  writeln ('  DailyGrades');
  writeln ('  TestGrades');
  writeln ('  DailyNames');
  writeln ('  TestNames');
  writeln ('  CurveDaily');
  writeln ('  CurveTest');
  writeln ('  DropLowest');
  write   ('  ClassName');
End;

{=============================================================================}

{************************* Creates the help menu *****************************}

Procedure HELPMENU (MenuText, MenuBack, CutText, CutBack, SelecText,
                    SelecBack, MainText, MainBack, wincolor, wintext,
                    winborder, wintype : byte);

Begin
  HEADING (MenuText, MenuBack, CutText, CutBack);
  TCTB (SelecText,SelecBack);
  WRTS (63,1,' Help ');
  CLEAR (MainText,MainBack,3,3,78,24);
  MAKEWIN (true,true,winborder,wintype,wintext,wincolor,63,3,11,4);
  writeln ('  Help');
  write   ('  About');
End;

{=============================================================================}

{********************* Creates the no student window *************************}

Procedure NOSTUDWIN (wincolor, wintext, winborder, wintype : byte);

Begin
  MAKEWIN (true,true,winborder,wintype,wintext,wincolor,27,19,28,3);
  write (' No students! Press <Esc>');
  HIDECURSOR (1,1,wincolor);
  repeat
    chrc := readkey;
  until chrc = #27;
End;

{=============================================================================}

{********************** Creates the no grade window **************************}

Procedure NOGRADEWIN (wincolor, wintext, winborder, wintype : byte);

Begin
  MAKEWIN (true,true,winborder,wintype,wintext,wincolor,27,19,28,3);
  write ('  No grades! Press <Esc>');
  HIDECURSOR (1,1,wincolor);
  repeat
    chrc := readkey;
  until chrc = #27;
End;

{=============================================================================}

{******************** Creates the grade full window **************************}

Procedure GRADEFULLWIN (wincolor, wintext, winborder, wintype : byte);

Begin
  MAKEWIN (true,true,winborder,wintype,wintext,wincolor,24,19,34,3);
  write ('  All grades full! Press <Esc>');
  HIDECURSOR (1,1,wincolor);
  repeat
    chrc := readkey;
  until chrc = #27;
End;

{=============================================================================}

{*********************** Creates the done window *****************************}

Procedure DONE (wincolor, wintext, winborder, wintype : byte);

Begin
  MAKEWIN (true,true,winborder,wintype,wintext,wincolor,28,19,25,3);
  write ('   Done. Press <ESC>');
  HIDECURSOR (1,1,wincolor);
  repeat
    chrc := readkey;
  until chrc = #27;
End;

{=============================================================================}

{******************* Creates the are you sure window *************************}

Procedure AYSURE (wincolor, wintext, winborder, wintype : byte;
                  var chrc : char);

Begin
  MAKEWIN (true,true,winborder,wintype,wintext,wincolor,28,19,25,3);
  write ('  Are you sure? <Y/N>');
  HIDECURSOR (1,1,wincolor);
  repeat
    chrc := upcase(readkey);
  until (chrc = 'Y') or (chrc = 'N') or (chrc = #27);
End;

{=============================================================================}

{******************** Creates the check exit window **************************}

Procedure EXITCHECK (wincolor, wintext, winborder, wintype,
                     MainText, MainBack, MenuText, MenuBack,
                     CutText, CutBack: byte; var chrc : char);

Begin
  HEADING (MenuText, MenuBack, CutText, CutBack);
  CLEAR (MainText,MainBack,3,3,78,24);
  MAKEWIN (true,true,winborder,wintype,wintext,wincolor,23,12,33,3);
  write ('  Exit WiederGrades 2.0? <Y/N>');
  HIDECURSOR (1,1,wincolor);
  repeat
    chrc := upcase(readkey);
  until (chrc = 'Y') or (chrc = 'N') or (chrc = #27);
  if chrc = #27 then chrc := 'N';
End;

{=============================================================================}

{****************** Creates the view all background **************************}

Procedure VABACKGROUND (gradepos, maxdgrades, MainBold, MainBack : byte;
                        var seed, seed2 : byte);

var
  count : byte;

Begin
  case gradepos of
     1..10 : seed := 1;
    11..20 : seed := 11;
    21..30 : seed := 21;
    31..40 : seed := 31;
    41..45 : seed := 41;
  end;
  case gradepos of
     1..10 : seed2 := 10;
    11..20 : seed2 := 20;
    21..30 : seed2 := 30;
    31..40 : seed2 := 40;
    41..45 : seed2 := 45;
  end;
  CLEAR (MainBold,MainBack,3,3,78,24);
  if gradepos <= maxdgrades
    then writeln (' Current Daily Grade ==>')
    else writeln (' Current Test Grade  ==>');
  WRTS (57,1,'ClassAve ==> ');
  WRTS (2,2,'StudentAve ==> ');
  gotoXY (25,2);
  for count := seed to seed2 do
    if count <= maxdgrades
      then write ('  D',count:2)
      else write ('  T',count - maxdgrades:2);
  writeln;
End;

{=============================================================================}

END.  {*** UNIT MENUS ***}