                 {* Charlie Wiederhold - Gooty Wed. 3-4 *}
{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<} UNIT Prog4Data; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


USES
  ListADT,                       {* The ADT for the lists                  *}
  TreeADT;                       {* ADT for the Trees                      *}

CONST
  DOSText     = 7;               {* Colors for use within the program      *}
  DOSBack     = 0;               {* Allows quick and easy changes to the   *}
  BackColor   = 1;               {* look of the program                    *}
  WinColor    = 7;
  TextColor   = 0;
  SelectColor = 4;
  HeaderColor = 14;
  TitleHead   = ' Title  :  ';   {* Header for when printing a title       *}
  AuthorHead  = ' Author :  ';   {* Header for when printing authors       *}

  {* Break for within the file *}
  Break = '-----------------------------------------------------------------------';

  {* Break for on the screen *}
  Break2 = '------------------------------------------------------------------';

TYPE

  {* The two different types of trees you can have *}
  IndexType     = (Title, Author);

  {* Different methods of processing a book *}
  ProcessMethod = (PrintOut, Remove, Insert);

  {* How much info of a book a user gives *}
  InfoType      = (Both, One);

  {* The array of trees holding the search trees *}
  IndexTrees    = ARRAY [IndexType] OF TreeType;

  {* Array used for easy access to the names of authors in the books *}
  {* There would have to be an extreme case for over 10 authors... so *}
  {* I feel that this will work for almost EVERY example. *}
  AuthorArray   = ARRAY [1..10] OF STRING;


{---------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION{>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{---------------------------------------------------------------------------}


END. {* Prog4Data *}