UNIT GameCon3;

INTERFACE

PROCEDURE GamePart7 (VAR Game : Text);
PROCEDURE GamePart8 (VAR Game : Text);
PROCEDURE GamePart9 (VAR Game : Text);

IMPLEMENTATION

{***********************************}
PROCEDURE GamePart7 (VAR Game : Text);
BEGIN

  writeln (Game, '        addkills 1');
  writeln (Game, '');
  writeln (Game, '        ifwasweapon RPG { sound SQUISHED state liz_body_jibs state standard_jibs state delete_enemy }');
  writeln (Game, '        else ifwasweapon RADIUSEXPLOSION { sound SQUISHED state liz_body_jibs state standard_jibs state ',
                 'delete_enemy }');
  writeln (Game, '        else ifwasweapon THROWFLAME { spawn BURNING sound SQUISHED state liz_body_jibs state standard_jibs ',
                 'state delete_enemy }');
  writeln (Game, '        else { state rf ai AILIZDYING ifrnd 64 spawn BLOODPOOL }');
  writeln (Game, '        sound CAPT_DYING');
  writeln (Game, '    }');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        sound CAPT_PAIN');
  writeln (Game, '        ifwasweapon SHRINKSPARK { sound ACTOR_SHRINKING ai AILIZSHRUNK }');
  writeln (Game, '        else ifwasweapon THROWFLAME quote 14');
  writeln (Game, '        state random_wall_jibs');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state lizjumpstate');
  writeln (Game, '    ifactioncount 6');
  writeln (Game, '    {');
  writeln (Game, '        ifpdistl 1024');
  writeln (Game, '            hitradius 1024 WEAKEST WEAK MEDIUMSTRENGTH TOUGH');
  writeln (Game, '        else ai AILIZGETENEMY else ifactioncount 2 fall');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state lizdyingstate');
  writeln (Game, '    ifaction ALIZLYINGDEAD');
  writeln (Game, '    {');
  writeln (Game, '        strength 0');
  writeln (Game, '        ifhitweapon ifwasweapon RADIUSEXPLOSION { sound SQUISHED state standard_jibs state delete_enemy }');
  writeln (Game, '        ifcount RESPAWNACTORTIME ifrespawn');
  writeln (Game, '        {');
  writeln (Game, '            spawn TRANSPORTERSTAR cstat 257 strength LIZSTRENGTH ai AILIZGETENEMY');
  writeln (Game, '        }');
  writeln (Game, '    }');
  writeln (Game, '    else ifai AILIZDYING ifactioncount 6 { iffloordistl 8 sound THUD move LIZSTOP action ALIZLYINGDEAD }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state lizdodgestate');
  writeln (Game, '    ifcount 32 ai AILIZGETENEMY');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'actor LIZMANSTAYPUT LIZSTRENGTH ai AILIZGETENEMY cactor LIZMAN enda');
  writeln (Game, '');
  writeln (Game, 'actor LIZMAN LIZSTRENGTH');
  writeln (Game, '    state checksquished');
  writeln (Game, '    ifai 0 ai AILIZGETENEMY');
  writeln (Game, '    else ifaction ALIZLYINGDEAD { fall state lizdyingstate break }');
  writeln (Game, '    else ifai AILIZJUMPENEMY state lizjumpstate');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        fall');
  writeln (Game, '        ifai AILIZGETENEMY state lizseekstate');
  writeln (Game, '        else ifai AILIZCHARGEENEMY state lizseekstate');
  writeln (Game, '        else ifai AILIZDODGE state lizdodgestate');
  writeln (Game, '        else ifai AILIZSHOOTENEMY state lizshootstate');
  writeln (Game, '        else ifai AILIZFLEENEMY state lizfleestate');
  writeln (Game, '        else ifai AILIZTHINK state lizthinkstate');
  writeln (Game, '        else ifai AILIZSHRUNK state lizshrunkstate');
  writeln (Game, '        else ifai AILIZDYING state lizdyingstate');
  writeln (Game, '        else ifai AILIZSPIT');
  writeln (Game, '            { ifcount 26 ai AILIZGETENEMY else ifcount 18 ifrnd 96 { shoot SPIT sound LIZARD_SPIT } }');
  writeln (Game, '    }');
  writeln (Game, '    ifhitweapon state checklizhit');
  writeln (Game, 'enda');
  writeln (Game, '');
  writeln (Game, 'action SNAKEFRAMES     0   1   5   1   1');
  writeln (Game, 'action SNAKESCREAM     5   1   5   1   1');
  writeln (Game, 'move SNAKERUNVELS 244 256');
  writeln (Game, 'move SNAKERUNUPVELS 244 -256');
  writeln (Game, 'move SNAKEBACKWARDS -48 -64');
  writeln (Game, 'move SNAKEWALK 72');
  writeln (Game, 'move SNAKERISE 32 -16');
  writeln (Game, 'move SNAKESTOPPED');
  writeln (Game, 'ai AISNAKEGETE SNAKESCREAM SNAKERUNVELS seekplayer');
  writeln (Game, 'ai AISNAKEGETUP SNAKESCREAM SNAKERUNUPVELS seekplayer');
  writeln (Game, 'ai AISNAKEWALK SNAKEFRAMES SNAKEWALK seekplayer');
  writeln (Game, 'ai AISNAKELOOK SNAKEFRAMES SNAKESTOPPED looking');
  writeln (Game, 'ai AISNAKEPULLBACK SNAKEFRAMES SNAKEBACKWARDS face_player');
  writeln (Game, 'ai AISNAKEHIT SNAKESCREAM SNAKEBACKWARDS face_player');
  writeln (Game, 'ai AISNAKESHRUNK SNAKEFRAMES SHRUNKVELS fleeenemy');
  writeln (Game, '');
  writeln (Game, 'state checksnakehitstate');
  writeln (Game, '    state random_wall_jibs');
  writeln (Game, '    ifwasweapon SHRINKSPARK ai AISNAKESHRUNK');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        ifdead { addkills 1 sound SNAK_DYING state standard_jibs state delete_enemy }');
  writeln (Game, '        else { sound SNAK_PAIN ai AISNAKEHIT }');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state snakeshrunkstate');
  writeln (Game, '    ifcount 24 state delete_enemy');
  writeln (Game, '    else sizeto 1 1');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'actor SNAKEDRONE SNAKESTRENGTH');
  writeln (Game, '    ifaction 0 ai AISNAKELOOK');
  writeln (Game, '    ifrnd 8 spawn WATERDRIP');
  writeln (Game, '');
  writeln (Game, '    state checksquished');
  writeln (Game, '');
  writeln (Game, '    ifai AISNAKELOOK');
  writeln (Game, '    {');
  writeln (Game, '        ifrnd 1 soundonce SNAK_ROAM');
  writeln (Game, '        ifactioncount 8 ifrnd 2');
  writeln (Game, '        {');
  writeln (Game, '            ifcansee');
  writeln (Game, '            {');
  writeln (Game, '                ifcanshoottarget { sound SNAK_ATTACK1 ifp phigher ai AISNAKEGETUP else ai AISNAKEGETE }');
  writeln (Game, '                else ai AISNAKEWALK');
  writeln (Game, '            }');
  writeln (Game, '            else ai AISNAKEWALK');
  writeln (Game, '        }');
  writeln (Game, '    }');
  writeln (Game, '    else ifai AISNAKEWALK');
  writeln (Game, '    {');
  writeln (Game, '        ifcansee { }');
  writeln (Game, '        ifrnd 32 ifnotmoving move SNAKERISE seekplayer');
  writeln (Game, '');
  writeln (Game, '        ifcount 64');
  writeln (Game, '        {');
  writeln (Game, '            ifpdistl 4096 ifcanseetarget { ifp phigher ai AISNAKEGETUP else ai AISNAKEGETE }');
  writeln (Game, '            else resetcount');
  writeln (Game, '        }');
  writeln (Game, '    }');
  writeln (Game, '    else ifai AISNAKEGETE');
  writeln (Game, '    {');
  writeln (Game, '        ifcansee { }');
  writeln (Game, '        ifcount 64 ai AISNAKEPULLBACK');
  writeln (Game, '        ifpdistl 1024');
  writeln (Game, '        {');
  writeln (Game, '            sound SNAK_ATTACK2');
  writeln (Game, '            shoot SHOTSPARK1');
  writeln (Game, '            ai AISNAKEPULLBACK');
  writeln (Game, '        }');
  writeln (Game, '        ifnotmoving');
  writeln (Game, '            ifcount 16 ai AISNAKEPULLBACK');
  writeln (Game, '    }');
  writeln (Game, '    else ifai AISNAKEGETUP');
  writeln (Game, '    {');
  writeln (Game, '        ifcansee { }');
  writeln (Game, '        ifcount 64 ai AISNAKEPULLBACK');
  writeln (Game, '        ifpdistl 1024');
  writeln (Game, '        {');
  writeln (Game, '            sound SNAK_ATTACK2');
  writeln (Game, '            shoot SHOTSPARK1');
  writeln (Game, '            ai AISNAKEPULLBACK');
  writeln (Game, '        }');
  writeln (Game, '        ifnotmoving');
  writeln (Game, '            ifcount 16 ai AISNAKEPULLBACK');
  writeln (Game, '    }');
  writeln (Game, '    ifai AISNAKEPULLBACK { ifnotmoving ai AISNAKELOOK ifcount 32 ai AISNAKELOOK }');
  writeln (Game, '    else ifai AISNAKEHIT ifcount 8 ai AISNAKELOOK');
  writeln (Game, '    else ifai AISNAKESHRUNK state snakeshrunkstate');
  writeln (Game, '    ifhitweapon state checksnakehitstate');
  writeln (Game, 'enda');
  writeln (Game, '');
  writeln (Game, '');
  writeln (Game, '');
  writeln (Game, 'action AJELLYWALK        0   3   5   1   15');
  writeln (Game, 'action AJELLYSTAND       0   1   5   1   15');
  writeln (Game, 'action AJELLYSCRATCH     0   4   5   1   15');
  writeln (Game, 'action AJELLYHIT        30   1   1   1   10');
  writeln (Game, 'action AJELLYSHOOT      20   1   5   1   10');
  writeln (Game, 'action AJELLYDYING      30   8   1   1   17');
  writeln (Game, 'action AJELLYDEAD       38   1   1   1    1');
  writeln (Game, '');
  writeln (Game, 'move JELLYWALKVELS 96 -30');
  writeln (Game, 'move JELLYUPVELS 96 -70');
  writeln (Game, 'move JELLYSTOPPED 0 -30');
  writeln (Game, 'move JELLYINWATER 96 24');
  writeln (Game, '');
  writeln (Game, 'ai AIJELLYGETENEMY AJELLYWALK JELLYWALKVELS seekplayer');
  writeln (Game, 'ai AIJELLYSHOOTENEMY AJELLYSHOOT JELLYSTOPPED face_player');
  writeln (Game, 'ai AIJELLYSCRATCHENEMY AJELLYSCRATCH JELLYSTOPPED face_player');
  writeln (Game, 'ai AIJELLYHIT AJELLYHIT JELLYSTOPPED face_player');
  writeln (Game, 'ai AIJELLYSHRUNK AJELLYWALK SHRUNKVELS face_player');
  writeln (Game, 'ai AIJELLYDYING AJELLYDYING JELLYSTOPPED face_player');
  writeln (Game, '');
  writeln (Game, 'state jellygetenemystate');
  writeln (Game, '');
  writeln (Game, '    ifcansee');
  writeln (Game, '    {');
  writeln (Game, '        ifactioncount 32 { ifrnd 48 ifcansee ifcanshoottarget { sound OCTA_ATTACK1 ai ',
                 'AIJELLYSHOOTENEMY break } }');
  writeln (Game, '        else');
  writeln (Game, '        {');
  writeln (Game, '            ifpdistl 1024 ai AIJELLYSCRATCHENEMY');
  writeln (Game, '            sizeto 40 40');
  writeln (Game, '        }');
  writeln (Game, '    }');
  writeln (Game, '');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state jellyscratchenemystate');
  writeln (Game, '    ifpdistg 1280 ai AIJELLYGETENEMY');
  writeln (Game, '    else ifcount 32 { resetcount sound OCTA_ATTACK2 addphealth JELLYSCRATCHINGPLAYER }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state jellyshootenemystate');
  writeln (Game, '    ifcount 25 { ifcount 27 ai AIJELLYGETENEMY }');
  writeln (Game, '    else ifcount 24 shoot COOLEXPLOSION1');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        ifactioncount 6 resetactioncount');
  writeln (Game, '        else ifactioncount 3 { shadeto -127 shadeto -127 shadeto -127 shadeto -127 }');
  writeln (Game, '        else { shadeto 127 shadeto 127 shadeto 127 shadeto 127 }');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state checkjellyhitstate');
  writeln (Game, '    ifwasweapon SHRINKSPARK { sound ACTOR_SHRINKING ai AIJELLYSHRUNK }');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        ifdead');
  writeln (Game, '        {');
  writeln (Game, '            addkills 1');
  writeln (Game, '            ifwasweapon RPG { sound SQUISHED state standard_jibs state delete_enemy }');
  writeln (Game, '            else ifwasweapon THROWFLAME { sound SQUISHED spawn BURNING state standard_jibs state ',
                 'delete_enemy }');
  writeln (Game, '            else ifwasweapon RADIUSEXPLOSION { sound SQUISHED state standard_jibs state delete_enemy }');
  writeln (Game, '            else { state rf ai AIJELLYDYING }');
  writeln (Game, '            sound OCTA_DYING');
  writeln (Game, '        }');
  writeln (Game, '        else');
  writeln (Game, '        {');
  writeln (Game, '            ifwasweapon RPG');
  writeln (Game, '            {');
  writeln (Game, '                sound OCTA_DYING addkills 1');
  writeln (Game, '                state standard_jibs');
  writeln (Game, '                killit');
  writeln (Game, '            }');
  writeln (Game, '            ifwasweapon THROWFLAME quote 14');
  writeln (Game, '            sound OCTA_PAIN spawn BLOOD');
  writeln (Game, '            ifrnd 64 ai AIJELLYHIT');
  writeln (Game, '');
  writeln (Game, '        }');
  writeln (Game, '    }');
  writeln (Game, '    state random_wall_jibs');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state jellyshrunkstate');
  writeln (Game, '    ifcount SHRUNKDONECOUNT ai AILIZGETENEMY');
  writeln (Game, '    else ifcount SHRUNKCOUNT sizeto 48 40');
  writeln (Game, '    else state genericshrunkcode');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state jellydyingstate');
  writeln (Game, '    ifactioncount 8 { ifrnd 64 spawn BLOODPOOL move JELLYSTOPPED action AJELLYDEAD break }');
  writeln (Game, '    else ifactioncount 5 { } else ifactioncount 4 iffloordistl 8 sound THUD');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'actor JELLYFISHSTAYPUT JELLYSTRENGTH ai AIJELLYGETENEMY cactor JELLYFISH enda');
  writeln (Game, '');
  writeln (Game, 'actor JELLYFISH JELLYSTRENGTH fall');
  writeln (Game, '');
  writeln (Game, '    state checksquished');
  writeln (Game, '');
  writeln (Game, '    ifai 0 ai AIJELLYGETENEMY');
  writeln (Game, '    else ifaction AJELLYDEAD');
  writeln (Game, '    {');
  writeln (Game, '        strength 0');
  writeln (Game, '        ifcount RESPAWNACTORTIME ifrespawn');
  writeln (Game, '            { addkills -1 spawn TRANSPORTERSTAR cstat 257 strength JELLYSTRENGTH ai AIJELLYGETENEMY }');
  writeln (Game, '        ifhitweapon ifwasweapon RADIUSEXPLOSION { state standard_jibs killit }');
  writeln (Game, '        break');
  writeln (Game, '    }');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        ifrnd 1 soundonce OCTA_ROAM');
  writeln (Game, '');
  writeln (Game, '        ifai AIJELLYGETENEMY state jellygetenemystate');
  writeln (Game, '        else ifai AIJELLYHIT { ifcount 8 ai AIJELLYSHOOTENEMY }');
  writeln (Game, '        else ifai AIJELLYDYING { state jellydyingstate break }');
  writeln (Game, '        else ifai AIJELLYSCRATCHENEMY state jellyscratchenemystate');
  writeln (Game, '        else ifai AIJELLYSHOOTENEMY state jellyshootenemystate');
  writeln (Game, '        else ifai AIJELLYSHRUNK state jellyshrunkstate');
  writeln (Game, '');
  writeln (Game, '        ifmove JELLYUPVELS { } else ifp phigher move JELLYUPVELS seekplayer');
  writeln (Game, '        else ifmove JELLYINWATER { } else ifinwater move JELLYINWATER seekplayer');
  writeln (Game, '');
  writeln (Game, '        ifhitweapon state checkjellyhitstate');
  writeln (Game, '    }');
  writeln (Game, 'enda');
  writeln (Game, '');
  writeln (Game, 'action APIGWALK         0  4 5 1 20');
  writeln (Game, 'action APIGRUN          0  4 5 1 11');
  writeln (Game, 'action APIGSHOOT        30 2 5 1 58');
  writeln (Game, 'action APIGCOCK         25 1 5 1 16');
  writeln (Game, 'action APIGSTAND        30 1 5 1 1');
  writeln (Game, 'action APIGDIVE         40 2 5 1 40');
  writeln (Game, 'action APIGDIVESHOOT    45 2 5 1 58');
  writeln (Game, 'action APIGDYING        55 5 1 1 15');
  writeln (Game, 'action APIGHIT          55 1 1 1 10');
  writeln (Game, 'action APIGDEAD         60 1 1 1 1');
  writeln (Game, '');
  writeln (Game, 'move PIGWALKVELS 72');
  writeln (Game, 'move PIGRUNVELS 108');
  writeln (Game, 'move PIGSTOPPED');

END;

{***********************************}
PROCEDURE GamePart8 (VAR Game : Text);
BEGIN

  writeln (Game, '');
  writeln (Game, 'ai AIPIGSEEKENEMY APIGWALK PIGWALKVELS seekplayer');
  writeln (Game, 'ai AIPIGSHOOTENEMY APIGSHOOT PIGSTOPPED face_player');
  writeln (Game, 'ai AIPIGFLEEENEMY APIGWALK PIGWALKVELS fleeenemy');
  writeln (Game, 'ai AIPIGSHOOT APIGSHOOT PIGSTOPPED face_player');
  writeln (Game, 'ai AIPIGDODGE APIGRUN PIGRUNVELS dodgebullet');
  writeln (Game, 'ai AIPIGCHARGE APIGRUN PIGRUNVELS seekplayer');
  writeln (Game, 'ai AIPIGDIVING APIGDIVE PIGSTOPPED face_player');
  writeln (Game, 'ai AIPIGDYING APIGDYING PIGSTOPPED face_player');
  writeln (Game, 'ai AIPIGSHRINK APIGWALK SHRUNKVELS fleeenemy');
  writeln (Game, 'ai AIPIGHIT APIGHIT PIGSTOPPED face_player');
  writeln (Game, '');
  writeln (Game, 'state pigseekenemystate');
  writeln (Game, '');
  writeln (Game, '    ifai AIPIGCHARGE');
  writeln (Game, '    {');
  writeln (Game, '        ifcansee ifpdistl 3084');
  writeln (Game, '        {');
  writeln (Game, '            ifnotmoving ai AIPIGSEEKENEMY');
  writeln (Game, '            else ai AIPIGDIVING');
  writeln (Game, '        }');
  writeln (Game, '        break');
  writeln (Game, '    }');
  writeln (Game, '    else iffloordistl 32');
  writeln (Game, '    {');
  writeln (Game, '        ifpdistg 4096 { ifactornotstayput ai AIPIGCHARGE }');
  writeln (Game, '        ifrnd 8 { ifbulletnear ai AIPIGDODGE }');
  writeln (Game, '    }');
  writeln (Game, '');
  writeln (Game, '    ifrnd 128 ifcansee');
  writeln (Game, '    {');
  writeln (Game, '        ifai AIPIGDODGE { ifcount 32 ai AIPIGCHARGE break }');
  writeln (Game, '        iffloordistl 32');
  writeln (Game, '        {');
  writeln (Game, '            ifpdistl 1024 ifp palive ifcanshoottarget');
  writeln (Game, '                { ai AIPIGSHOOTENEMY break }');
  writeln (Game, '            ifcount 48 { ifrnd 8 ifp palive ifcanshoottarget { ifrnd 192 ai AIPIGSHOOTENEMY else ai ',
                 'AIPIGDIVING break } }');
  writeln (Game, '        }');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state pigshootenemystate');
  writeln (Game, '//    ifcansee');
  writeln (Game, '    {');
  writeln (Game, '        ifcount 12 { } else ifcount 11');
  writeln (Game, '        {');
  writeln (Game, '            ifcanshoottarget { sound PIG_ATTACK shoot SHOTGUN shoot SHOTGUN shoot SHOTGUN shoot SHOTGUN ',
                 'shoot SHOTGUN }');
  writeln (Game, '            else ai AIPIGSEEKENEMY');
  writeln (Game, '        }');
  writeln (Game, '        ifcount 25 { } else ifcount 24 { action APIGCOCK sound SHOTGUN_COCK }');
  writeln (Game, '        ifcount 48 { } else ifcount 47');
  writeln (Game, '        {');
  writeln (Game, '            ifcanshoottarget { sound PIG_ATTACK shoot SHOTGUN shoot SHOTGUN shoot SHOTGUN shoot SHOTGUN ',
                 'shoot SHOTGUN }');
  writeln (Game, '            else ai AIPIGSEEKENEMY');
  writeln (Game, '        }');
  writeln (Game, '        ifcount 60 { } else ifcount 59 { action APIGCOCK sound SHOTGUN_COCK }');
  writeln (Game, '        ifcount 72');
  writeln (Game, '        {');
  writeln (Game, '            ifrnd 64 resetcount');
  writeln (Game, '            else');
  writeln (Game, '            {');
  writeln (Game, '                ifpdistl 768 ai AIPIGFLEEENEMY');
  writeln (Game, '                else ai AIPIGSEEKENEMY');
  writeln (Game, '            }');
  writeln (Game, '        }');
  writeln (Game, '        ifaction APIGCOCK ifactioncount 2 action APIGSHOOT');
  writeln (Game, '    }');
  writeln (Game, '    else ai AIPIGSEEKENEMY');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state pigfleeenemystate');
  writeln (Game, '    ifactioncount 8 ai AIPIGSEEKENEMY');
  writeln (Game, '    else ifnotmoving ai AIPIGSEEKENEMY');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state pigdivestate');
  writeln (Game, '    ifaction APIGDIVESHOOT');
  writeln (Game, '    {');
  writeln (Game, '        ifcansee');
  writeln (Game, '        {');
  writeln (Game, '            ifcount 12 { } else ifcount 11');
  writeln (Game, '            {');
  writeln (Game, '                ifcanshoottarget { sound PIG_ATTACK shoot SHOTGUN shoot SHOTGUN shoot SHOTGUN ',
                 'shoot SHOTGUN }');
  writeln (Game, '                else ai AIPIGSEEKENEMY');
  writeln (Game, '            }');
  writeln (Game, '            ifcount 25 { } else ifcount 24 { sound SHOTGUN_COCK }');
  writeln (Game, '            ifcount 48 { } else ifcount 47');
  writeln (Game, '            {');
  writeln (Game, '                ifcanshoottarget { sound PIG_ATTACK shoot SHOTGUN shoot SHOTGUN shoot SHOTGUN ',
                 'shoot SHOTGUN }');
  writeln (Game, '                else ai AIPIGSEEKENEMY');
  writeln (Game, '            }');
  writeln (Game, '            ifcount 60 { } else ifcount 59');
  writeln (Game, '            {');
  writeln (Game, '                sound SHOTGUN_COCK');
  writeln (Game, '                ifgapzl 32 ai AIPIGDIVING');
  writeln (Game, '                else');
  writeln (Game, '                {');
  writeln (Game, '                    ifpdistl 4096 ai AIPIGFLEEENEMY');
  writeln (Game, '                    else ai AIPIGSEEKENEMY');
  writeln (Game, '                }');
  writeln (Game, '            }');
  writeln (Game, '        }');
  writeln (Game, '        else ifgapzl 32 ai AIPIGDIVING else ai AIPIGSEEKENEMY');
  writeln (Game, '    }');
  writeln (Game, '    else ifactioncount 2 ifp palive { resetcount action APIGDIVESHOOT }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state checkpighitstate');
  writeln (Game, '    spawn BLOOD');
  writeln (Game, '    ifdead');
  writeln (Game, '    {');
  writeln (Game, '        addkills 1');
  writeln (Game, '        state random_wall_jibs');
  writeln (Game, '        ifrnd 16 spawn SHIELD else state drop_shotgun');
  writeln (Game, '        ifwasweapon RADIUSEXPLOSION { sound SQUISHED state standard_jibs state delete_enemy }');
  writeln (Game, '        else ifwasweapon RPG { sound SQUISHED state standard_jibs state delete_enemy }');
  writeln (Game, '        else ifwasweapon THROWFLAME spawn BURNING');
  writeln (Game, '');
  writeln (Game, '        ai AIPIGDYING sound PIG_DYING');
  writeln (Game, '    }');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        sound PIG_PAIN');
  writeln (Game, '        state random_wall_jibs');
  writeln (Game, '        ifwasweapon SHRINKSPARK ai AIPIGSHRINK');
  writeln (Game, '        else ifwasweapon THROWFLAME quote 14');
  writeln (Game, '        else ifrnd 64 ai AIPIGHIT');
  writeln (Game, '        else ifrnd 64 ai AIPIGSHOOTENEMY');
  writeln (Game, '        else ifrnd 64 { ai AIPIGDIVING action APIGDIVESHOOT }');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state pigshrinkstate');
  writeln (Game, '    ifcount SHRUNKDONECOUNT { ifdead { addkills 1 sound SQUISHED state troop_body_jibs state standard_jibs ',
                 'state delete_enemy } ai AIPIGSEEKENEMY }');
  writeln (Game, '    else ifcount SHRUNKCOUNT sizeto 48 40');
  writeln (Game, '    else state genericshrunkcode');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state pigdyingstate');
  writeln (Game, '    ifactioncount 5 { ifrnd 64 spawn BLOODPOOL state rf iffloordistl 8 sound THUD action APIGDEAD move ',
                 'PIGSTOPPED break }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, '');
  writeln (Game, '');
  writeln (Game, 'actor PIGCOPDIVE PIGCOPSTRENGTH ai AIPIGDIVING action APIGDIVESHOOT cactor PIGCOP enda');
  writeln (Game, 'actor PIGCOPSTAYPUT PIGCOPSTRENGTH ai AIPIGSEEKENEMY cactor PIGCOP enda');
  writeln (Game, 'actor PIGCOP PIGCOPSTRENGTH APIGSTAND fall');
  writeln (Game, '    state checksquished');
  writeln (Game, '    ifaction APIGSTAND ai AIPIGSEEKENEMY');
  writeln (Game, '    else ifaction APIGDEAD');
  writeln (Game, '    {');
  writeln (Game, '        ifrespawn ifcount RESPAWNACTORTIME');
  writeln (Game, '            { spawn TRANSPORTERSTAR cstat 257 strength PIGCOPSTRENGTH ai AIPIGSEEKENEMY }');
  writeln (Game, '        else { strength 0 ifhitweapon ifwasweapon RADIUSEXPLOSION { sound SQUISHED state standard_jibs ',
                 'state delete_enemy } break }');
  writeln (Game, '    }');
  writeln (Game, '    else ifai AIPIGDYING state pigdyingstate');
  writeln (Game, '    else ifai AIPIGHIT { ifactioncount 3 ai AIPIGSEEKENEMY }');
  writeln (Game, '    else ifai AIPIGSHRINK state pigshrinkstate');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        ifai AIPIGSEEKENEMY state pigseekenemystate');
  writeln (Game, '        else ifai AIPIGDODGE state pigseekenemystate');
  writeln (Game, '        else ifai AIPIGSHOOTENEMY state pigshootenemystate');
  writeln (Game, '        else ifai AIPIGFLEEENEMY state pigfleeenemystate');
  writeln (Game, '        else ifai AIPIGDIVING state pigdivestate');
  writeln (Game, '        else ifai AIPIGCHARGE state pigseekenemystate');
  writeln (Game, '        ifhitweapon state checkpighitstate');
  writeln (Game, '        ifrnd 1');
  writeln (Game, '        {');
  writeln (Game, '            ifrnd 32 soundonce PIG_ROAM');
  writeln (Game, '            else ifrnd 64 soundonce PIG_ROAM2');
  writeln (Game, '            else soundonce PIG_ROAM3');
  writeln (Game, '        }');
  writeln (Game, '    }');
  writeln (Game, 'enda');
  writeln (Game, '');
  writeln (Game, 'action ABOSSWALK                0  6  5  1  12');
  writeln (Game, 'action ABOSSRUN                 0  6  5  1  5');
  writeln (Game, 'action ABOSSSHOOT               30 2  5  1  4');
  writeln (Game, 'action ABOSSLOB                 40 2  5  1  35');
  writeln (Game, 'action ABOSS1DYING              60 5  1  1  50');
  writeln (Game, 'action BOSS1FLINTCH             60 1  1  1  1');
  writeln (Game, 'action ABOSS1DEAD               65');
  writeln (Game, '');
  writeln (Game, 'move BOSSWALKVELS 208');
  writeln (Game, 'move BOSSRUNVELS 296');
  writeln (Game, 'move BOSSSTOPPED');
  writeln (Game, '');
  writeln (Game, 'ai AIBOSSSEEKENEMY ABOSSWALK BOSSWALKVELS seekplayer');
  writeln (Game, 'ai AIBOSSRUNENEMY ABOSSRUN BOSSRUNVELS face_player');
  writeln (Game, 'ai AIBOSSFLEEENEMY ABOSSWALK BOSSWALKVELS fleeenemy');
  writeln (Game, 'ai AIBOSSSHOOTENEMY ABOSSSHOOT BOSSSTOPPED face_player');
  writeln (Game, 'ai AIBOSSLOBBED ABOSSLOB BOSSSTOPPED face_player // face_player_smart');
  writeln (Game, 'ai AIBOSSDYING ABOSS1DYING BOSSSTOPPED face_player');
  writeln (Game, '');
  writeln (Game, 'state bossfleeenemy');
  writeln (Game, '    ifcount 16 ifpdistl 1024 ifp palive ifcansee ifcanshoottarget ai AIBOSSSHOOTENEMY');
  writeln (Game, '    ifcount 32 ai AIBOSSSEEKENEMY');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state bossrunenemystate');
  writeln (Game, '    ifpdistl 2048 { ifp palive ai AIBOSSSHOOTENEMY break }');
  writeln (Game, '    else ifcansee { ifactioncount 6 { ifcanshoottarget { resetactioncount sound BOS1_WALK } else ai ',
                 'AIBOSSSEEKENEMY } }');
  writeln (Game, '    else ai AIBOSSSEEKENEMY');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state bossseekenemystate');
  writeln (Game, '    ifrnd 2 { ifactor BOSS1 soundonce BOS1_ROAM else soundonce BOS3_ROAM }');
  writeln (Game, '    else ifactioncount 6 { resetactioncount sound BOS1_WALK }');
  writeln (Game, '');
  writeln (Game, '    ifpdistl 2548 ifp palive { ai AIBOSSSHOOTENEMY break }');
  writeln (Game, '');
  writeln (Game, '    ifcansee ifcount 32');
  writeln (Game, '    {');
  writeln (Game, '        ifrnd 32 { ifp palive ifcanshoottarget ai AIBOSSSHOOTENEMY }');
  writeln (Game, '        else ifpdistg 2548 ifrnd 192');
  writeln (Game, '            ifcanshoottarget');
  writeln (Game, '            {');
  writeln (Game, '                ifrnd 64 ai AIBOSSRUNENEMY');
  writeln (Game, '                else ai AIBOSSLOBBED');
  writeln (Game, '            }');
  writeln (Game, '    }');
  writeln (Game, '');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state bossdyingstate');
  writeln (Game, '  ifaction ABOSS1DEAD break');
  writeln (Game, '  ifactioncount 5 { iffloordistl 8 sound THUD action ABOSS1DEAD cstat 0 ifspritepal 19 break ',
                 'endoflevel 52 }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state bosslobbedstate');
  writeln (Game, '    ifcansee');
  writeln (Game, '    {');
  writeln (Game, '        ifactioncount 2');
  writeln (Game, '        {');
  writeln (Game, '            resetactioncount');
  writeln (Game, '            ifactor BOSS1 sound BOS1_ATTACK2');
  writeln (Game, '            else sound BOS3_ATTACK2');
  writeln (Game, '            shoot MORTER');
  writeln (Game, '        }');
  writeln (Game, '        else ifcount 64 ifrnd 16 ai AIBOSSSEEKENEMY');
  writeln (Game, '    }');
  writeln (Game, '    else ai AIBOSSSEEKENEMY');
  writeln (Game, '');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state bossshootenemy');
  writeln (Game, '    ifcount 72 ai AIBOSSSEEKENEMY');
  writeln (Game, '    else ifaction ABOSSSHOOT ifactioncount 2');
  writeln (Game, '    {');
  writeln (Game, '        ifactor BOSS1 sound BOS1_ATTACK1 else sound BOS3_ATTACK1');
  writeln (Game, '        shoot SHOTSPARK1 shoot SHOTSPARK1 shoot SHOTSPARK1 resetactioncount');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state checkbosshitstate');
  writeln (Game, '    ifrnd 8 spawn BLOODPOOL');
  writeln (Game, '    ifdead { addkills 1 ifactor BOSS1 globalsound DUKE_TALKTOBOSSFALL sound BOS1_DYING else sound ',
                 'BOS3_DYING ai AIBOSSDYING }');
  writeln (Game, '    else');
  writeln (Game, '    {');
  writeln (Game, '        ifactor BOSS1 sound BOS1_PAIN else sound BOS3_PAIN');
  writeln (Game, '');
  writeln (Game, '        debris SCRAP1 1');
  writeln (Game, '        guts JIBS6 1');
  writeln (Game, '        ifwasweapon THROWFLAME quote 14');
  writeln (Game, '        ifrnd 32 { action BOSS1FLINTCH move 0 }');
  writeln (Game, '    }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state bosscode');
  writeln (Game, '    ifai 0 ai AIBOSSRUNENEMY');
  writeln (Game, '    else ifaction BOSS1FLINTCH { ifactioncount 3 ai AIBOSSSHOOTENEMY }');
  writeln (Game, '    else ifai AIBOSSSEEKENEMY state bossseekenemystate');
  writeln (Game, '    else ifai AIBOSSRUNENEMY state bossrunenemystate');
  writeln (Game, '    else ifai AIBOSSFLEEENEMY state bossfleeenemy');
  writeln (Game, '    else ifai AIBOSSSHOOTENEMY state bossshootenemy');
  writeln (Game, '    else ifai AIBOSSLOBBED state bosslobbedstate');
  writeln (Game, '');
  writeln (Game, '    ifai AIBOSSDYING state bossdyingstate');
  writeln (Game, '');
  writeln (Game, '    ifhitweapon state checkbosshitstate');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'actor BOSS1STAYPUT BOSS1STRENGTH cactor BOSS1 enda');
  writeln (Game, 'actor BOSS1 BOSS1STRENGTH fall state bosscode enda');
  writeln (Game, 'actor BOSS3 BOSS3STRENGTH fall state bosscode enda');
  writeln (Game, '');
  writeln (Game, 'action AFATBREETH  0  3  5  1  40');
  writeln (Game, 'action AFATSPIN   25  3  1  1  10');
  writeln (Game, 'action AFATGET     0  3  5  1  30');
  writeln (Game, 'action AFATSHOOT  15  2  5  1  50');
  writeln (Game, 'action AFATDYING  30  8  1  1  12');
  writeln (Game, 'action AFATDEAD   38  1  1  1  1');
  writeln (Game, '');
  writeln (Game, 'move FATGETVELS 96');
  writeln (Game, 'move FATSTOPPED');
  writeln (Game, '');
  writeln (Game, 'ai AIFATWAIT AFATBREETH FATSTOPPED face_player');
  writeln (Game, 'ai AIFATGET AFATGET FATGETVELS face_player');
  writeln (Game, 'ai AIFATSHOOT AFATSHOOT FATSTOPPED face_player');

END;

{***********************************}
PROCEDURE GamePart9 (VAR Game : Text);
BEGIN

  writeln (Game, 'ai AIFATSPIN AFATSPIN FATGETVELS face_player');
  writeln (Game, 'ai AIFATDYING AFATDYING FATSTOPPED face_player');
  writeln (Game, '');
  writeln (Game, 'actor FATGUY FATGUYSTRENGTH');
  writeln (Game, '');
  writeln (Game, '    fall');
  writeln (Game, '    state checksquished');
  writeln (Game, '    ifai 0 ai AIFATWAIT');
  writeln (Game, '    else ifai AIFATWAIT { ifcount 64 { ifrnd 92 ai AIFATGET else ai AIFATSHOOT } }');
  writeln (Game, '    else ifai AIFATSHOOT');
  writeln (Game, '    {');
  writeln (Game, '        ifcount 32 { ifrnd 32 ai AIFATWAIT }');
  writeln (Game, '        else { ifactioncount 2 { sound COMM_ATTACK shoot RPG resetactioncount } }');
  writeln (Game, '    }');
  writeln (Game, '    else ifai AIFATDYING');
  writeln (Game, '    {');
  writeln (Game, '        ifhitweapon ifwasweapon RADIUSEXPLOSION');
  writeln (Game, '            { sound SQUISHED state standard_jibs state delete_enemy }');
  writeln (Game, '        ifaction AFATDEAD break');
  writeln (Game, '        strength 0');
  writeln (Game, '        ifactioncount 8 { iffloordistl 8 sound THUD cstat 0 action AFATDEAD }');
  writeln (Game, '        break');
  writeln (Game, '    }');
  writeln (Game, '    else ifai AIFATGET { ifnotmoving ifrnd 32 operate ifpdistl 1596 { sound COMM_SPIN ai AIFATSPIN } }');
  writeln (Game, '    else ifai AIFATSPIN');
  writeln (Game, '    {');
  writeln (Game, '        soundonce COMM_SPIN');
  writeln (Game, '        ifcount 16 ifpdistl 1024 { addphealth CAPTSPINNINGPLAYER sound DUKE_GRUNT ',
                 'palfrom 32 16 resetcount }');
  writeln (Game, '        ifactioncount 32 ai AIFATWAIT');
  writeln (Game, '        ifnotmoving ifrnd 32 operate');
  writeln (Game, '');
  writeln (Game, '    }');
  writeln (Game, '    ifhitweapon { ifdead { addkills 1 sound COMM_DYING ai AIFATDYING } else sound COMM_PAIN }');
  writeln (Game, '    ifrnd 1 soundonce COMM_ROAM');
  writeln (Game, 'enda');
  writeln (Game, '');
  writeln (Game, 'move DUMMYWALK 144');
  writeln (Game, 'move DUMMYSTOP');
  writeln (Game, 'action ADUMMYDUKEWALK    0    4    5    1    20');
  writeln (Game, 'action ADUMMYDUKESTAND -20    0    5    1    1');
  writeln (Game, 'action ADUMMYDUKESHOOT -20    1    5    1    10');
  writeln (Game, 'ai AIDUMMYFINDDUKE   ADUMMYDUKEWALK DUMMYWALK seekplayer');
  writeln (Game, 'ai AIDUMMYHIDEDUKE   ADUMMYDUKEWALK DUMMYWALK seekplayer');
  writeln (Game, 'ai AIDUMMYFLEEDUKE   ADUMMYDUKEWALK DUMMYWALK fleeplayer');
  writeln (Game, 'ai AIDUMMYSHOOTDUKE  ADUMMYDUKESHOOT DUMMYSTOP face_player');
  writeln (Game, '');
  writeln (Game, 'state dummyshootstate');
  writeln (Game, '    ifactioncount 2 { resetactioncount shoot CHAINGUN }');
  writeln (Game, '    ifcount 48 { ifcansee { ifrnd 128 { cstat 32768 spawn TRANSPORTERSTAR ai AIDUMMYHIDEDUKE } else ai ',
                 'AIDUMMYFINDDUKE } else ai 0 }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state dummyfindstate');
  writeln (Game, '    ifcansee ifpdistl 768 ai AIDUMMYSHOOTDUKE');
  writeln (Game, '    ifrnd 32 ifcount 64 ifcanseetarget ai AIDUMMYSHOOTDUKE');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state dummyfleestate');
  writeln (Game, '    ifcount 4 ifpdistl 1228 ifcanseetarget ai AIDUMMYSHOOTDUKE');
  writeln (Game, '    ifcount 32 ifcanseetarget ai AIDUMMYSHOOTDUKE else ai AIDUMMYFINDDUKE');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state dummyhidestate');
  writeln (Game, '    ifcount 4 ifpdistl 1228 ifcanseetarget { cstat 257 spawn TRANSPORTERBEAM ai AIDUMMYSHOOTDUKE }');
  writeln (Game, '    ifcount 32 ifcanseetarget { cstat 257 spawn TRANSPORTERBEAM ai AIDUMMYSHOOTDUKE }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'actor DUMMYDUKE BOSS2SMALLDUKESTRENGTH fall');
  writeln (Game, '    spritepal 7');
  writeln (Game, '    ifaction ADUMMYDUKESTAND');
  writeln (Game, '    {');
  writeln (Game, '        ifcount 64 ifcansee ai AIDUMMYFINDDUKE');
  writeln (Game, '        ifrnd 2 ifpdistl 2048 ifcanseetarget ai AIDUMMYSHOOTDUKE');
  writeln (Game, '    }');
  writeln (Game, '    else ifai 0 { ifmove 0 spawn TRANSPORTERBEAM action ADUMMYDUKESTAND move DUMMYSTOP looking }');
  writeln (Game, '    else ifai AIDUMMYFINDDUKE state dummyfindstate');
  writeln (Game, '    else ifai AIDUMMYHIDEDUKE state dummyhidestate');
  writeln (Game, '    else ifai AIDUMMYFLEEDUKE state dummyfleestate');
  writeln (Game, '    else ifai AIDUMMYSHOOTDUKE state dummyshootstate');
  writeln (Game, '    ifhitweapon { ifdead { addkills 1 sound SQUISHED state standard_jibs state delete_enemy break } ',
                 'else cstat 257 }');
  writeln (Game, 'enda');
  writeln (Game, '');
  writeln (Game, 'move BIGWALK 64');
  writeln (Game, 'move BIGSTOP');
  writeln (Game, 'action ABIGDUKEWALK   -5    4    5    1    40');
  writeln (Game, 'action ABIGDUKESTAND -25    0    5');
  writeln (Game, 'action ABIGDUKESHOOT -25    1    5');
  writeln (Game, 'ai AIBIGFINDDUKE   ABIGDUKEWALK BIGWALK seekplayer');
  writeln (Game, 'ai AIBIGFLEEDUKE   ABIGDUKEWALK BIGWALK fleeplayer');
  writeln (Game, 'ai AIBIGSHOOTDUKE  ABIGDUKESHOOT BIGSTOP face_player');
  writeln (Game, '');
  writeln (Game, 'state bigshootstate');
  writeln (Game, '    ifactioncount 2 { resetactioncount shoot CHAINGUN }');
  writeln (Game, '    ifcount 48 { ifcansee ai AIBIGFINDDUKE else ai 0 }');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state bigfindstate');
  writeln (Game, '    ifcansee ifpdistl 768 ai AIBIGSHOOTDUKE');
  writeln (Game, '    ifrnd 32 ifcount 64 ifcanseetarget ai AIBIGSHOOTDUKE');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'state bigfleestate');
  writeln (Game, '    ifcount 4 ifpdistl 1228 ifcanseetarget ai AIBIGSHOOTDUKE');
  writeln (Game, '    ifcount 32 ifcanseetarget ai AIBIGSHOOTDUKE else ai AIBIGFINDDUKE');
  writeln (Game, 'ends');
  writeln (Game, '');
  writeln (Game, 'actor BIGDUMMYDUKE BOSS2LARGEDUKESTRENGTH fall');
  writeln (Game, '    sizeto 96 96');
  writeln (Game, '    spritepal 7');
  writeln (Game, '    ifaction ABIGDUKESTAND');
  writeln (Game, '    {');
  writeln (Game, '        ifcount 64 ifcansee ai AIBIGFINDDUKE');
  writeln (Game, '        ifrnd 2 ifpdistl 2048 ifcanshoottarget ai AIBIGSHOOTDUKE');
  writeln (Game, '    }');
  writeln (Game, '    else ifai 0 { ifmove 0 spawn TRANSPORTERBEAM action ABIGDUKESTAND move BIGSTOP looking }');
  writeln (Game, '    else ifai AIBIGFINDDUKE state bigfindstate');
  writeln (Game, '    else ifai AIBIGFLEEDUKE state bigfleestate');
  writeln (Game, '    else ifai AIBIGSHOOTDUKE state bigshootstate');
  writeln (Game, '    ifhitweapon { sound SQUISHED state standard_jibs state delete_enemy break }');
  writeln (Game, 'enda');
  writeln (Game, '');

END;

{***********************************}

END.