UNIT DefsCon;

INTERFACE

PROCEDURE DefsPart1 (VAR Defs : Text);
PROCEDURE DefsPart2 (VAR Defs : Text);
PROCEDURE DefsPart3 (VAR Defs : Text);
PROCEDURE DefsPart4 (VAR Defs : Text);
PROCEDURE DefsPart5 (VAR Defs : Text);
PROCEDURE DefsPart6 (VAR Defs : Text);

IMPLEMENTATION

{*************************}
PROCEDURE DefsPart1 (VAR Defs : Text);

BEGIN
  writeln (Defs, '/* This .CON file edited using EditCON ver 2.0 by Charlie Wiederhold');
  writeln (Defs, '--------------------------------------------------------------------------------');
  writeln (Defs, 'Duke Nukem 3D .CON file.');
  writeln (Defs, 'By Todd Replogle');
  writeln (Defs, '(c) 1996 3D Realms Entertainment');
  writeln (Defs, '--------------------------------------------------------------------------------');
  writeln (Defs, '');
  writeln (Defs, 'IMPORTANT NOTICE IF YOU USE MODIFIED .CON FILES');
  writeln (Defs, '');
  writeln (Defs, 'If you are playing a MULTIPLAY game (Dukematch or Co-op) and you are');
  writeln (Defs, 'using *modified* .CON files (USER.CON, GAME.CON, DEFS.CON), then each');
  writeln (Defs, 'multiplayer must be using the EXACT SAME .CON files, or the game will');
  writeln (Defs, 'get out of sync and/or develop interesting problems.');
  writeln (Defs, '');
  writeln (Defs, '3D Realms encourages you to experiment freely with the parameters');
  writeln (Defs, 'contained in this file, and to share your discoveries with the rest');
  writeln (Defs, 'of the world.  However, BE ADVISED that 3D Realms does NOT offer ');
  writeln (Defs, 'any technical support on how to use this file or other user-modifiable ');
  writeln (Defs, 'features of this game.  Do NOT call 3D Realms or Apogee Software ');
  writeln (Defs, 'for advice or help with this subject.  ');
  writeln (Defs, '');
  writeln (Defs, 'You make modifications to this and other files at your own risk. ');
  writeln (Defs, 'It is recommended that you first make a backup copy of this, or');
  writeln (Defs, 'any .CON files before making any changes.');
  writeln (Defs, '');
  writeln (Defs, '--------------------------------------------------------------------------------');
  writeln (Defs, '');
  writeln (Defs, '*/');
  writeln (Defs, '');
  writeln (Defs, '');
  writeln (Defs, 'define SECTOREFFECTOR 1');
  writeln (Defs, 'define ACTIVATOR 2');
  writeln (Defs, 'define TOUCHPLATE 3');
  writeln (Defs, 'define ACTIVATORLOCKED 4');
  writeln (Defs, 'define MUSICANDSFX 5');
  writeln (Defs, 'define LOCATORS 6');
  writeln (Defs, 'define CYCLER 7');
  writeln (Defs, 'define MASTERSWITCH 8');
  writeln (Defs, 'define RESPAWN 9');
  writeln (Defs, 'define GPSPEED 10');
  writeln (Defs, 'define ARROW 20');
  writeln (Defs, 'define FIRSTGUNSPRITE 21');
  writeln (Defs, 'define CHAINGUNSPRITE 22');
  writeln (Defs, 'define RPGSPRITE 23');
  writeln (Defs, 'define FREEZESPRITE 24');
  writeln (Defs, 'define SHRINKERSPRITE 25');
  writeln (Defs, 'define HEAVYHBOMB 26');
  writeln (Defs, 'define TRIPBOMBSPRITE 27');
  writeln (Defs, 'define SHOTGUNSPRITE 28');
  writeln (Defs, 'define DEVISTATORSPRITE 29');
  writeln (Defs, 'define HEALTHBOX 30');
  writeln (Defs, 'define AMMOBOX 31');
  writeln (Defs, 'define INVENTORYBOX 33');
  writeln (Defs, 'define FREEZEAMMO 37');
  writeln (Defs, 'define AMMO 40');
  writeln (Defs, 'define BATTERYAMMO 41');
  writeln (Defs, 'define DEVISTATORAMMO 42');
  writeln (Defs, 'define RPGAMMO 44');
  writeln (Defs, 'define CRYSTALAMMO 46');
  writeln (Defs, 'define HBOMBAMMO 47');
  writeln (Defs, 'define AMMOLOTS 48');
  writeln (Defs, 'define SHOTGUNAMMO 49');
  writeln (Defs, 'define COLA 51');
  writeln (Defs, 'define SIXPAK 52');
  writeln (Defs, 'define FIRSTAID 53');
  writeln (Defs, 'define SHIELD 54');
  writeln (Defs, 'define STEROIDS 55');
  writeln (Defs, 'define AIRTANK 56');
  writeln (Defs, 'define JETPACK 57');
  writeln (Defs, 'define HEATSENSOR 59');
  writeln (Defs, 'define ACCESSCARD 60');
  writeln (Defs, 'define BOOTS 61');
  writeln (Defs, 'define MIRRORBROKE 70');
  writeln (Defs, 'define MOONSKY1 80');
  writeln (Defs, 'define MOONSKY2 81');
  writeln (Defs, 'define MOONSKY3 82');
  writeln (Defs, 'define MOONSKY4 83');
  writeln (Defs, 'define BIGORBIT1 84');
  writeln (Defs, 'define BIGORBIT2 85');
  writeln (Defs, 'define BIGORBIT3 86');
  writeln (Defs, 'define BIGORBIT4 87');
  writeln (Defs, 'define BIGORBIT5 88');
  writeln (Defs, 'define LA 89');
  writeln (Defs, 'define ATOMICHEALTH 100');
  writeln (Defs, 'define TECHLIGHT2 120');
  writeln (Defs, 'define TECHLIGHTBUST2 121');
  writeln (Defs, 'define TECHLIGHT4 122');
  writeln (Defs, 'define TECHLIGHTBUST4 123');
  writeln (Defs, 'define WALLLIGHT4 124');
  writeln (Defs, 'define WALLLIGHTBUST4 125');
  writeln (Defs, 'define ACCESSSWITCH 130');
  writeln (Defs, 'define SLOTDOOR 132');
  writeln (Defs, 'define LIGHTSWITCH 134');
  writeln (Defs, 'define SPACEDOORSWITCH 136');
  writeln (Defs, 'define SPACELIGHTSWITCH 138');
  writeln (Defs, 'define FRANKENSTINESWITCH 140');
  writeln (Defs, 'define NUKEBUTTON 142');
  writeln (Defs, 'define MULTISWITCH 146');
  writeln (Defs, 'define DOORTILE5 150');
  writeln (Defs, 'define DOORTILE6 151');
  writeln (Defs, 'define DOORTILE1 152');
  writeln (Defs, 'define DOORTILE2 153');
  writeln (Defs, 'define DOORTILE3 154');
  writeln (Defs, 'define DOORTILE4 155');
  writeln (Defs, 'define DOORTILE7 156');
  writeln (Defs, 'define DOORTILE8 157');
  writeln (Defs, 'define DOORTILE9 158');
  writeln (Defs, 'define DOORTILE10 159');
  writeln (Defs, 'define DOORSHOCK 160');
  writeln (Defs, 'define DIPSWITCH 162');
  writeln (Defs, 'define DIPSWITCH2 164');
  writeln (Defs, 'define TECHSWITCH 166');
  writeln (Defs, 'define DIPSWITCH3 168');
  writeln (Defs, 'define ACCESSSWITCH2 170');
  writeln (Defs, 'define REFLECTWATERTILE 180');
  writeln (Defs, 'define FLOORSLIME 200');
  writeln (Defs, 'define BIGFORCE 230');
  writeln (Defs, 'define EPISODE 247');
  writeln (Defs, 'define MASKWALL9 255');
  writeln (Defs, 'define W_LIGHT 260');
  writeln (Defs, 'define SCREENBREAK1 263');
  writeln (Defs, 'define SCREENBREAK2 264');
  writeln (Defs, 'define SCREENBREAK3 265');
  writeln (Defs, 'define SCREENBREAK4 266');
  writeln (Defs, 'define SCREENBREAK5 267');
  writeln (Defs, 'define SCREENBREAK6 268');
  writeln (Defs, 'define SCREENBREAK7 269');
  writeln (Defs, 'define SCREENBREAK8 270');
  writeln (Defs, 'define SCREENBREAK9 271');
  writeln (Defs, 'define SCREENBREAK10 272');
  writeln (Defs, 'define SCREENBREAK11 273');
  writeln (Defs, 'define SCREENBREAK12 274');
  writeln (Defs, 'define SCREENBREAK13 275');
  writeln (Defs, 'define MASKWALL1 285');
  writeln (Defs, 'define W_TECHWALL1 293');
  writeln (Defs, 'define W_TECHWALL2 297');
  writeln (Defs, 'define W_TECHWALL3 301');
  writeln (Defs, 'define W_TECHWALL4 305');
  writeln (Defs, 'define WATERTILE2 336');
  writeln (Defs, 'define BPANNEL1 341');
  writeln (Defs, 'define PANNEL1 342');
  writeln (Defs, 'define PANNEL2 343');
  writeln (Defs, 'define WATERTILE 344');
  writeln (Defs, 'define STATIC 351');
  writeln (Defs, 'define W_SCREENBREAK 357');
  writeln (Defs, 'define W_HITTECHWALL3 360');
  writeln (Defs, 'define W_HITTECHWALL4 361');
  writeln (Defs, 'define W_HITTECHWALL2 362');
  writeln (Defs, 'define W_HITTECHWALL1 363');
  writeln (Defs, 'define MASKWALL10 387');
  writeln (Defs, 'define MASKWALL11 391');
  writeln (Defs, 'define DOORTILE22 395');
  writeln (Defs, 'define FANSPRITE 407');
  writeln (Defs, 'define FANSPRITEBROKE 411');
  writeln (Defs, 'define FANSHADOW 412');
  writeln (Defs, 'define FANSHADOWBROKE 416');
  writeln (Defs, 'define DOORTILE18 447');
  writeln (Defs, 'define DOORTILE19 448');
  writeln (Defs, 'define DOORTILE20 449');
  writeln (Defs, 'define SPACESHUTTLE 487');
  writeln (Defs, 'define SATELLITE 489');
  writeln (Defs, 'define VIEWSCREEN2 499');
  writeln (Defs, 'define VIEWSCREENBROKE 501');
  writeln (Defs, 'define VIEWSCREEN 502');
  writeln (Defs, 'define GLASS 503');
  writeln (Defs, 'define GLASS2 504');
  writeln (Defs, 'define STAINGLASS1 510');
  writeln (Defs, 'define MASKWALL5 514');
  writeln (Defs, 'define SATELITE 516');
  writeln (Defs, 'define FUELPOD 517');
  writeln (Defs, 'define SLIMEPIPE 538');
  writeln (Defs, 'define CRACK1 546');
  writeln (Defs, 'define CRACK2 547');
  writeln (Defs, 'define CRACK3 548');
  writeln (Defs, 'define CRACK4 549');
  writeln (Defs, 'define FOOTPRINTS 550');
  writeln (Defs, 'define DOMELITE 551');
  writeln (Defs, 'define CAMERAPOLE 554');
  writeln (Defs, 'define CHAIR1 556');
  writeln (Defs, 'define CHAIR2 557');

END;

{*************************}
PROCEDURE DefsPart2 (VAR Defs : Text);

BEGIN
  writeln (Defs, 'define BROKENCHAIR 559');
  writeln (Defs, 'define MIRROR 560');
  writeln (Defs, 'define WATERFOUNTAIN 563');
  writeln (Defs, 'define WATERFOUNTAINBROKE 567');
  writeln (Defs, 'define FEMMAG1 568');
  writeln (Defs, 'define TOILET 569');
  writeln (Defs, 'define STALL 571');
  writeln (Defs, 'define STALLBROKE 573');
  writeln (Defs, 'define FEMMAG2 577');
  writeln (Defs, 'define REACTOR2 578');
  writeln (Defs, 'define REACTOR2BURNT 579');
  writeln (Defs, 'define REACTOR2SPARK 580');
  writeln (Defs, 'define GRATE1 595');
  writeln (Defs, 'define BGRATE1 596');
  writeln (Defs, 'define SOLARPANNEL 602');
  writeln (Defs, 'define NAKED1 603');
  writeln (Defs, 'define ANTENNA 607');
  writeln (Defs, 'define MASKWALL12 609');
  writeln (Defs, 'define TOILETBROKE 615');
  writeln (Defs, 'define PIPE2 616');
  writeln (Defs, 'define PIPE1B 617');
  writeln (Defs, 'define PIPE3 618');
  writeln (Defs, 'define PIPE1 619');
  writeln (Defs, 'define CAMERA1 621');
  writeln (Defs, 'define BRICK 626');
  writeln (Defs, 'define SPLINTERWOOD 630');
  writeln (Defs, 'define PIPE2B 633');
  writeln (Defs, 'define BOLT1 634');
  writeln (Defs, 'define W_NUMBERS 640');
  writeln (Defs, 'define WATERDRIP 660');
  writeln (Defs, 'define WATERBUBBLE 661');
  writeln (Defs, 'define WATERBUBBLEMAKER 662');
  writeln (Defs, 'define W_FORCEFIELD 663');
  writeln (Defs, 'define VACUUM 669');
  writeln (Defs, 'define FOOTPRINTS2 672');
  writeln (Defs, 'define FOOTPRINTS3 673');
  writeln (Defs, 'define FOOTPRINTS4 674');
  writeln (Defs, 'define EGG 675');
  writeln (Defs, 'define SCALE 678');
  writeln (Defs, 'define CHAIR3 680');
  writeln (Defs, 'define CAMERALIGHT 685');
  writeln (Defs, 'define MOVIECAMERA 686');
  writeln (Defs, 'define IVUNIT 689');
  writeln (Defs, 'define POT1 694');
  writeln (Defs, 'define POT2 695');
  writeln (Defs, 'define POT3 697');
  writeln (Defs, 'define PIPE3B 700');
  writeln (Defs, 'define WALLLIGHT3 701');
  writeln (Defs, 'define WALLLIGHTBUST3 702');
  writeln (Defs, 'define WALLLIGHT1 703');
  writeln (Defs, 'define WALLLIGHTBUST1 704');
  writeln (Defs, 'define WALLLIGHT2 705');
  writeln (Defs, 'define WALLLIGHTBUST2 706');
  writeln (Defs, 'define LIGHTSWITCH2 712');
  writeln (Defs, 'define WAITTOBESEATED 716');
  writeln (Defs, 'define DOORTILE14 717');
  writeln (Defs, 'define STATUE 753');
  writeln (Defs, 'define MIKE 762');
  writeln (Defs, 'define VASE 765');
  writeln (Defs, 'define SUSHIPLATE1 768');
  writeln (Defs, 'define SUSHIPLATE2 769');
  writeln (Defs, 'define SUSHIPLATE3 774');
  writeln (Defs, 'define SUSHIPLATE4 779');
  writeln (Defs, 'define DOORTILE16 781');
  writeln (Defs, 'define SUSHIPLATE5 792');
  writeln (Defs, 'define OJ 806');
  writeln (Defs, 'define MASKWALL13 830');
  writeln (Defs, 'define HURTRAIL 859');
  writeln (Defs, 'define POWERSWITCH1 860');
  writeln (Defs, 'define LOCKSWITCH1 862');
  writeln (Defs, 'define POWERSWITCH2 864');
  writeln (Defs, 'define ATM 867');
  writeln (Defs, 'define STATUEFLASH 869');
  writeln (Defs, 'define ATMBROKE 888');
  writeln (Defs, 'define BIGHOLE2 893');
  writeln (Defs, 'define STRIPEBALL 901');
  writeln (Defs, 'define QUEBALL 902');
  writeln (Defs, 'define POCKET 903');
  writeln (Defs, 'define WOODENHORSE 904');
  writeln (Defs, 'define TREE1 908');
  writeln (Defs, 'define TREE2 910');
  writeln (Defs, 'define CACTUS 911');
  writeln (Defs, 'define MASKWALL2 913');
  writeln (Defs, 'define MASKWALL3 914');
  writeln (Defs, 'define MASKWALL4 915');
  writeln (Defs, 'define FIREEXT 916');
  writeln (Defs, 'define TOILETWATER 921');
  writeln (Defs, 'define NEON1 925');
  writeln (Defs, 'define NEON2 926');
  writeln (Defs, 'define CACTUSBROKE 939');
  writeln (Defs, 'define BOUNCEMINE 940');
  writeln (Defs, 'define BROKEFIREHYDRENT 950');
  writeln (Defs, 'define BOX 951');
  writeln (Defs, 'define BULLETHOLE 952');
  writeln (Defs, 'define BOTTLE1 954');
  writeln (Defs, 'define BOTTLE2 955');
  writeln (Defs, 'define BOTTLE3 956');
  writeln (Defs, 'define BOTTLE4 957');
  writeln (Defs, 'define FEMPIC5 963');
  writeln (Defs, 'define FEMPIC6 964');
  writeln (Defs, 'define FEMPIC7 965');
  writeln (Defs, 'define HYDROPLANT 969');
  writeln (Defs, 'define OCEANSPRITE1 971');
  writeln (Defs, 'define OCEANSPRITE2 972');
  writeln (Defs, 'define OCEANSPRITE3 973');
  writeln (Defs, 'define OCEANSPRITE4 974');
  writeln (Defs, 'define OCEANSPRITE5 975');
  writeln (Defs, 'define GENERICPOLE 977');
  writeln (Defs, 'define CONE 978');
  writeln (Defs, 'define HANGLIGHT 979');
  writeln (Defs, 'define HYDRENT 981');
  writeln (Defs, 'define MASKWALL14 988');
  writeln (Defs, 'define TIRE 990');
  writeln (Defs, 'define PIPE5 994');
  writeln (Defs, 'define PIPE6 995');
  writeln (Defs, 'define PIPE4 996');
  writeln (Defs, 'define PIPE4B 997');
  writeln (Defs, 'define BROKEHYDROPLANT 1003');
  writeln (Defs, 'define PIPE5B 1005');
  writeln (Defs, 'define NEON3 1007');
  writeln (Defs, 'define NEON4 1008');
  writeln (Defs, 'define NEON5 1009');
  writeln (Defs, 'define BOTTLE5 1012');
  writeln (Defs, 'define BOTTLE6 1013');
  writeln (Defs, 'define BOTTLE8 1014');
  writeln (Defs, 'define SPOTLITE 1020');
  writeln (Defs, 'define HANGOOZ 1022');
  writeln (Defs, 'define MASKWALL15 1024');
  writeln (Defs, 'define BOTTLE7 1025');
  writeln (Defs, 'define HORSEONSIDE 1026');
  writeln (Defs, 'define GLASSPIECES 1031');
  writeln (Defs, 'define HORSELITE 1034');
  writeln (Defs, 'define NEON6 1046');
  writeln (Defs, 'define MASKWALL6 1059');
  writeln (Defs, 'define CLOCK 1060');
  writeln (Defs, 'define RUBBERCAN 1062');
  writeln (Defs, 'define BROKENCLOCK 1067');
  writeln (Defs, 'define PLUG 1069');
  writeln (Defs, 'define OOZFILTER 1079');
  writeln (Defs, 'define FLOORPLASMA 1082');
  writeln (Defs, 'define REACTOR 1088');
  writeln (Defs, 'define REACTORSPARK 1092');
  writeln (Defs, 'define REACTORBURNT 1096');
  writeln (Defs, 'define DOORTILE15 1102');
  writeln (Defs, 'define HANDSWITCH 1111');
  writeln (Defs, 'define CIRCLEPANNEL 1113');
  writeln (Defs, 'define CIRCLEPANNELBROKE 1114');
  writeln (Defs, 'define PULLSWITCH 1122');
  writeln (Defs, 'define MASKWALL8 1124');
  writeln (Defs, 'define BIGHOLE 1141');
  writeln (Defs, 'define ALIENSWITCH 1142');
  writeln (Defs, 'define DOORTILE21 1144');
  writeln (Defs, 'define HANDPRINTSWITCH 1155');
  writeln (Defs, 'define BOTTLE10 1157');
  writeln (Defs, 'define BOTTLE11 1158');
  writeln (Defs, 'define BOTTLE12 1159');
  writeln (Defs, 'define BOTTLE13 1160');
  writeln (Defs, 'define BOTTLE14 1161');
  writeln (Defs, 'define BOTTLE15 1162');
  writeln (Defs, 'define BOTTLE16 1163');
  writeln (Defs, 'define BOTTLE17 1164');
  writeln (Defs, 'define BOTTLE18 1165');
  writeln (Defs, 'define BOTTLE19 1166');
  writeln (Defs, 'define DOORTILE17 1169');
  writeln (Defs, 'define MASKWALL7 1174');
  writeln (Defs, 'define JAILBARBREAK 1175');
  writeln (Defs, 'define DOORTILE11 1178');
  writeln (Defs, 'define DOORTILE12 1179');
  writeln (Defs, 'define VENDMACHINE 1212');
  writeln (Defs, 'define VENDMACHINEBROKE 1214');
  writeln (Defs, 'define COLAMACHINE 1215');
  writeln (Defs, 'define COLAMACHINEBROKE 1217');
  writeln (Defs, 'define CRANEPOLE 1221');
  writeln (Defs, 'define CRANE 1222');
  writeln (Defs, 'define BARBROKE 1225');
  writeln (Defs, 'define BLOODPOOL 1226');
  writeln (Defs, 'define NUKEBARREL 1227');
  writeln (Defs, 'define NUKEBARRELDENTED 1228');
  writeln (Defs, 'define NUKEBARRELLEAKED 1229');
  writeln (Defs, 'define CANWITHSOMETHING 1232');
END;

{*************************}
PROCEDURE DefsPart3 (VAR Defs : Text);

BEGIN
  writeln (Defs, 'define MONEY 1233');
  writeln (Defs, 'define BANNER 1236');
  writeln (Defs, 'define EXPLODINGBARREL 1238');
  writeln (Defs, 'define EXPLODINGBARREL2 1239');
  writeln (Defs, 'define FIREBARREL 1240');
  writeln (Defs, 'define SEENINE 1247');
  writeln (Defs, 'define SEENINEDEAD 1248');
  writeln (Defs, 'define STEAM 1250');
  writeln (Defs, 'define CEILINGSTEAM 1255');
  writeln (Defs, 'define PIPE6B 1260');
  writeln (Defs, 'define TRANSPORTERBEAM 1261');
  writeln (Defs, 'define RAT 1267');
  writeln (Defs, 'define TRASH 1272');
  writeln (Defs, 'define FEMPIC1 1280');
  writeln (Defs, 'define FEMPIC2 1289');
  writeln (Defs, 'define BLANKSCREEN 1293');
  writeln (Defs, 'define PODFEM1 1294');
  writeln (Defs, 'define FEMPIC3 1298');
  writeln (Defs, 'define FEMPIC4 1306');
  writeln (Defs, 'define FEM1 1312');
  writeln (Defs, 'define FEM2 1317');
  writeln (Defs, 'define FEM3 1321');
  writeln (Defs, 'define FEM5 1323');
  writeln (Defs, 'define BLOODYPOLE 1324');
  writeln (Defs, 'define FEM4 1325');
  writeln (Defs, 'define FEM6 1334');
  writeln (Defs, 'define FEM6PAD 1335');
  writeln (Defs, 'define FEM8 1336');
  writeln (Defs, 'define HELECOPT 1346');
  writeln (Defs, 'define FETUSJIB 1347');
  writeln (Defs, 'define HOLODUKE 1348');
  writeln (Defs, 'define SPACEMARINE 1353');
  writeln (Defs, 'define INDY 1355');
  writeln (Defs, 'define FETUS 1358');
  writeln (Defs, 'define FETUSBROKE 1359');
  writeln (Defs, 'define MONK 1352');
  writeln (Defs, 'define LUKE 1354');
  writeln (Defs, 'define COOLEXPLOSION1 1360');
  writeln (Defs, 'define WATERSPLASH2 1380');
  writeln (Defs, 'define FIREVASE 1390');
  writeln (Defs, 'define SCRATCH 1393');
  writeln (Defs, 'define FEM7 1395');
  writeln (Defs, 'define APLAYERTOP 1400');
  writeln (Defs, 'define APLAYER 1405');
  writeln (Defs, 'define PLAYERONWATER 1420');
  writeln (Defs, 'define DUKELYINGDEAD 1518');
  writeln (Defs, 'define DUKETORSO 1520');
  writeln (Defs, 'define DUKEGUN 1528');
  writeln (Defs, 'define DUKELEG 1536');
  writeln (Defs, 'define SHARK 1550');
  writeln (Defs, 'define BLOOD 1620');
  writeln (Defs, 'define FIRELASER 1625');
  writeln (Defs, 'define TRANSPORTERSTAR 1630');
  writeln (Defs, 'define SPIT 1636');
  writeln (Defs, 'define LOOGIE 1637');
  writeln (Defs, 'define FIST 1640');
  writeln (Defs, 'define FREEZEBLAST 1641');
  writeln (Defs, 'define DEVISTATORBLAST 1642');
  writeln (Defs, 'define SHRINKSPARK 1646');
  writeln (Defs, 'define TONGUE 1647');
  writeln (Defs, 'define MORTER 1650');
  writeln (Defs, 'define SHRINKEREXPLOSION 1656');
  writeln (Defs, 'define RADIUSEXPLOSION 1670');
  writeln (Defs, 'define FORCERIPPLE 1671');
  writeln (Defs, 'define LIZTROOP 1680');
  writeln (Defs, 'define LIZTROOPRUNNING 1681');
  writeln (Defs, 'define LIZTROOPSTAYPUT 1682');
  writeln (Defs, 'define LIZTOP 1705');
  writeln (Defs, 'define LIZTROOPSHOOT 1715');
  writeln (Defs, 'define LIZTROOPJETPACK 1725');
  writeln (Defs, 'define LIZTROOPDSPRITE 1734');
  writeln (Defs, 'define LIZTROOPONTOILET 1741');
  writeln (Defs, 'define LIZTROOPDUCKING 1744');
  writeln (Defs, 'define HEADJIB1 1768');
  writeln (Defs, 'define ARMJIB1 1772');
  writeln (Defs, 'define LEGJIB1 1776');
  writeln (Defs, 'define OCTABRAIN 1820');
  writeln (Defs, 'define OCTABRAINSTAYPUT 1821');
  writeln (Defs, 'define OCTATOP 1845');
  writeln (Defs, 'define OCTADEADSPRITE 1855');
  writeln (Defs, 'define INNERJAW 1860');
  writeln (Defs, 'define DRONE 1880');
  writeln (Defs, 'define EXPLOSION2 1890');
  writeln (Defs, 'define COMMANDER 1920');
  writeln (Defs, 'define COMMANDERSTAYPUT 1921');
  writeln (Defs, 'define RECON 1960');
  writeln (Defs, 'define PIGCOP 2000');
  writeln (Defs, 'define PIGCOPSTAYPUT 2001');
  writeln (Defs, 'define PIGCOPDIVE 2045');
  writeln (Defs, 'define PIGCOPDEADSPRITE 2060');
  writeln (Defs, 'define PIGTOP 2061');
  writeln (Defs, 'define LIZMAN 2120');
  writeln (Defs, 'define LIZMANSTAYPUT 2121');
  writeln (Defs, 'define LIZMANSPITTING 2150');
  writeln (Defs, 'define LIZMANFEEDING 2160');
  writeln (Defs, 'define LIZMANJUMP 2165');
  writeln (Defs, 'define LIZMANDEADSPRITE 2185');
  writeln (Defs, 'define FECES 2200');
  writeln (Defs, 'define LIZMANHEAD1 2201');
  writeln (Defs, 'define LIZMANARM1 2205');
  writeln (Defs, 'define LIZMANLEG1 2209');
  writeln (Defs, 'define EXPLOSION2BOT 2219');
  writeln (Defs, 'define USERWEAPON 2235');
  writeln (Defs, 'define HEADERBAR 2242');
  writeln (Defs, 'define JIBS1 2245');
  writeln (Defs, 'define JIBS2 2250');
  writeln (Defs, 'define JIBS3 2255');
  writeln (Defs, 'define JIBS4 2260');
  writeln (Defs, 'define JIBS5 2265');
  writeln (Defs, 'define BURNING 2270');
  writeln (Defs, 'define FIRE 2271');
  writeln (Defs, 'define JIBS6 2286');
  writeln (Defs, 'define BLOODSPLAT1 2296');
  writeln (Defs, 'define BLOODSPLAT3 2297');
  writeln (Defs, 'define BLOODSPLAT2 2298');
  writeln (Defs, 'define BLOODSPLAT4 2299');
  writeln (Defs, 'define OOZ 2300');
  writeln (Defs, 'define WALLBLOOD1 2301');
  writeln (Defs, 'define WALLBLOOD2 2302');
  writeln (Defs, 'define WALLBLOOD3 2303');
  writeln (Defs, 'define WALLBLOOD4 2304');
  writeln (Defs, 'define WALLBLOOD5 2305');
  writeln (Defs, 'define WALLBLOOD6 2306');
  writeln (Defs, 'define WALLBLOOD7 2307');
  writeln (Defs, 'define WALLBLOOD8 2308');
  writeln (Defs, 'define BURNING2 2310');
  writeln (Defs, 'define FIRE2 2311');
  writeln (Defs, 'define CRACKKNUCKLES 2324');
  writeln (Defs, 'define SMALLSMOKE 2329');
  writeln (Defs, 'define SMALLSMOKEMAKER 2330');
  writeln (Defs, 'define FLOORFLAME 2333');
  writeln (Defs, 'define ROTATEGUN 2360');
  writeln (Defs, 'define GREENSLIME 2370');
  writeln (Defs, 'define WATERDRIPSPLASH 2380');
  writeln (Defs, 'define SCRAP6 2390');
  writeln (Defs, 'define SCRAP1 2400');
  writeln (Defs, 'define SCRAP2 2404');
  writeln (Defs, 'define SCRAP3 2408');
  writeln (Defs, 'define SCRAP4 2412');
  writeln (Defs, 'define SCRAP5 2416');
  writeln (Defs, 'define ORGANTIC 2420');
  writeln (Defs, 'define BETAVERSION 2440');
  writeln (Defs, 'define PLAYERISHERE 2442');
  writeln (Defs, 'define PLAYERWASHERE 2443');
  writeln (Defs, 'define SELECTDIR 2444');
  writeln (Defs, 'define F1HELP 2445');
  writeln (Defs, 'define NOTCHON 2446');
  writeln (Defs, 'define NOTCHOFF 2447');
  writeln (Defs, 'define BACKGROUNDSCREEN 2448');
  writeln (Defs, 'define DUKEICON 2452');
  writeln (Defs, 'define BADGUYICON 2453');
  writeln (Defs, 'define FOODICON 2454');
  writeln (Defs, 'define GETICON 2455');
  writeln (Defs, 'define MENUSCREEN 2456');
  writeln (Defs, 'define MENUBAR 2457');
  writeln (Defs, 'define KILLSICON 2458');
  writeln (Defs, 'define FIRSTAID_ICON 2460');
  writeln (Defs, 'define HEAT_ICON 2461');
  writeln (Defs, 'define BOTTOMSTATUSBAR 2462');
  writeln (Defs, 'define BOOT_ICON 2463');
  writeln (Defs, 'define FRAGBAR 2465');
  writeln (Defs, 'define JETPACK_ICON 2467');
  writeln (Defs, 'define AIRTANK_ICON 2468');
  writeln (Defs, 'define STEROIDS_ICON 2469');
  writeln (Defs, 'define HOLODUKE_ICON 2470');
  writeln (Defs, 'define ACCESS_ICON 2471');
  writeln (Defs, 'define DIGITALNUM 2472');
  writeln (Defs, 'define DUKECAR 2491');
  writeln (Defs, 'define CAMCORNER 2482');
  writeln (Defs, 'define CAMLIGHT 2484');
  writeln (Defs, 'define LOGO 2485');
  writeln (Defs, 'define TITLE 2486');
  writeln (Defs, 'define NUKEWARNINGICON 2487');
  writeln (Defs, 'define MOUSECURSOR 2488');
  writeln (Defs, 'define SLIDEBAR 2489');
  writeln (Defs, 'define DREALMS 2492');
  writeln (Defs, 'define BETASCREEN 2493');
  writeln (Defs, 'define WINDOWBORDER1 2494');
  writeln (Defs, 'define TEXTBOX 2495');
  writeln (Defs, 'define WINDOWBORDER2 2496');
END;

{*************************}
PROCEDURE DefsPart4 (VAR Defs : Text);

BEGIN
  writeln (Defs, 'define DUKENUKEM 2497');
  writeln (Defs, 'define THREEDEE 2498');
  writeln (Defs, 'define INGAMEDUKETHREEDEE 2499');
  writeln (Defs, 'define DEVISTATOR 2510');
  writeln (Defs, 'define KNEE 2521');
  writeln (Defs, 'define CROSSHAIR 2523');
  writeln (Defs, 'define FIRSTGUN 2524');
  writeln (Defs, 'define FIRSTGUNRELOAD 2528');
  writeln (Defs, 'define FALLINGCLIP 2530');
  writeln (Defs, 'define CLIPINHAND 2531');
  writeln (Defs, 'define HAND 2532');
  writeln (Defs, 'define SHELL 2533');
  writeln (Defs, 'define SHOTGUNSHELL 2535');
  writeln (Defs, 'define CHAINGUN 2536');
  writeln (Defs, 'define RPGGUN 2544');
  writeln (Defs, 'define RPGMUZZLEFLASH 2545');
  writeln (Defs, 'define FREEZE 2548');
  writeln (Defs, 'define CATLITE 2552');
  writeln (Defs, 'define SHRINKER 2556');
  writeln (Defs, 'define HANDHOLDINGLASER 2563');
  writeln (Defs, 'define TRIPBOMB 2566');
  writeln (Defs, 'define LASERLINE 2567');
  writeln (Defs, 'define HANDHOLDINGACCESS 2568');
  writeln (Defs, 'define HANDREMOTE 2570');
  writeln (Defs, 'define HANDTHROW 2573');
  writeln (Defs, 'define TIP 2576');
  writeln (Defs, 'define GLAIR 2578');
  writeln (Defs, 'define SCUBAMASK 2581');
  writeln (Defs, 'define SPACEMASK 2584');
  writeln (Defs, 'define FORCESPHERE 2590');
  writeln (Defs, 'define SHOTSPARK1 2595');
  writeln (Defs, 'define RPG 2605');
  writeln (Defs, 'define LASERSITE 2612');
  writeln (Defs, 'define SHOTGUN 2613');
  writeln (Defs, 'define BOSS1 2630');
  writeln (Defs, 'define BOSS1STAYPUT 2631');
  writeln (Defs, 'define BOSS1SHOOT 2660');
  writeln (Defs, 'define BOSS1LOB 2670');
  writeln (Defs, 'define BOSSTOP 2696');
  writeln (Defs, 'define BOSS2 2710');
  writeln (Defs, 'define BOSS3 2760');
  writeln (Defs, 'define SPINNINGNUKEICON 2813');
  writeln (Defs, 'define BIGFNTCURSOR 2820');
  writeln (Defs, 'define SMALLFNTCURSOR 2821');
  writeln (Defs, 'define STARTALPHANUM 2822');
  writeln (Defs, 'define ENDALPHANUM 2915');
  writeln (Defs, 'define BIGALPHANUM 2940');
  writeln (Defs, 'define BIGPERIOD 3002');
  writeln (Defs, 'define BIGCOMMA 3003');
  writeln (Defs, 'define BIGX 3004');
  writeln (Defs, 'define BIGQ 3005');
  writeln (Defs, 'define BIGSEMI 3006');
  writeln (Defs, 'define BIGCOLIN 3007');
  writeln (Defs, 'define THREEBYFIVE 3010');
  writeln (Defs, 'define BIGAPPOS 3022');
  writeln (Defs, 'define BLANK 3026');
  writeln (Defs, 'define MINIFONT 3072');
  writeln (Defs, 'define BUTTON1 3164');
  writeln (Defs, 'define GLASS3 3187');
  writeln (Defs, 'define RESPAWNMARKERRED 3190');
  writeln (Defs, 'define RESPAWNMARKERYELLOW 3200');
  writeln (Defs, 'define RESPAWNMARKERGREEN 3210');
  writeln (Defs, 'define BONUSSCREEN 3240');
  writeln (Defs, 'define VIEWBORDER 3250');
  writeln (Defs, 'define VICTORY1 3260');
  writeln (Defs, 'define ORDERING 3270');
  writeln (Defs, 'define TEXTSTORY 3280');
  writeln (Defs, 'define BORNTOBEWILDSCREEN 3370');
  writeln (Defs, 'define BLIMP 3400');
  writeln (Defs, 'define FEM9 3450');
  writeln (Defs, 'define FOOTPRINT 3701');
  writeln (Defs, 'define POOP 3998');
  writeln (Defs, 'define FRAMEEFFECT1 3999');
  writeln (Defs, '');
  writeln (Defs, '');
  writeln (Defs, 'define KNEE_WEAPON         0');
  writeln (Defs, 'define PISTOL_WEAPON       1');
  writeln (Defs, 'define SHOTGUN_WEAPON      2');
  writeln (Defs, 'define CHAINGUN_WEAPON     3');
  writeln (Defs, 'define RPG_WEAPON          4');
  writeln (Defs, 'define HANDBOMB_WEAPON     5');
  writeln (Defs, 'define SHRINKER_WEAPON     6');
  writeln (Defs, 'define DEVISTATOR_WEAPON   7');
  writeln (Defs, 'define TRIPBOMB_WEAPON     8');
  writeln (Defs, 'define FREEZE_WEAPON       9');
  writeln (Defs, '');
  writeln (Defs, '');
  writeln (Defs, 'define faceplayer 1');
  writeln (Defs, 'define geth 2');
  writeln (Defs, 'define getv 4');
  writeln (Defs, 'define randomangle 8');
  writeln (Defs, 'define faceplayerslow 16');
  writeln (Defs, 'define spin 32');
  writeln (Defs, 'define faceplayersmart 64');
  writeln (Defs, 'define fleeenemy 128');
  writeln (Defs, 'define jumptoplayer 257');
  writeln (Defs, 'define seekplayer 512');
  writeln (Defs, 'define furthestdir 1024');
  writeln (Defs, 'define dodgebullet 4096');
  writeln (Defs, '');
  writeln (Defs, '');
  writeln (Defs, 'define NO       0');
  writeln (Defs, 'define YES      1');
  writeln (Defs, '');
  writeln (Defs, '');
  writeln (Defs, 'define pstanding 1');
  writeln (Defs, 'define pwalking 2');
  writeln (Defs, 'define prunning 4');
  writeln (Defs, 'define pducking 8');
  writeln (Defs, 'define pfalling 16');
  writeln (Defs, 'define pjumping 32');
  writeln (Defs, 'define phigher 64');
  writeln (Defs, 'define pwalkingback 128');
  writeln (Defs, 'define prunningback 256');
  writeln (Defs, 'define pkicking 512');
  writeln (Defs, 'define pshrunk 1024');
  writeln (Defs, 'define pjetpack 2048');
  writeln (Defs, 'define ponsteroids 4096');
  writeln (Defs, 'define ponground 8192');
  writeln (Defs, 'define palive 16384');
  writeln (Defs, 'define pdead 32768');
  writeln (Defs, 'define pfacing 65536');
  writeln (Defs, '');
  writeln (Defs, '');
  writeln (Defs, 'define GET_STEROIDS     0');
  writeln (Defs, 'define GET_SHIELD       1');
  writeln (Defs, 'define GET_SCUBA        2');
  writeln (Defs, 'define GET_HOLODUKE     3');
  writeln (Defs, 'define GET_JETPACK      4');
  writeln (Defs, 'define GET_ACCESS       6');
  writeln (Defs, 'define GET_HEATS        7');
  writeln (Defs, 'define GET_FIRSTAID     9');
  writeln (Defs, 'define GET_BOOTS       10');
  writeln (Defs, '');
  writeln (Defs, '');
  writeln (Defs, 'define KICK_HIT                         0');
  writeln (Defs, 'define PISTOL_RICOCHET                  1');
  writeln (Defs, 'define PISTOL_BODYHIT                   2');
  writeln (Defs, 'define PISTOL_FIRE                      3');
  writeln (Defs, 'define EJECT_CLIP                       4');
  writeln (Defs, 'define INSERT_CLIP                      5');
  writeln (Defs, 'define CHAINGUN_FIRE                    6');
  writeln (Defs, 'define RPG_SHOOT                        7');
  writeln (Defs, 'define POOLBALLHIT                      8');
  writeln (Defs, 'define RPG_EXPLODE                      9');
  writeln (Defs, 'define CAT_FIRE                        10');
  writeln (Defs, 'define SHRINKER_FIRE                   11');
  writeln (Defs, 'define ACTOR_SHRINKING                 12');
  writeln (Defs, 'define PIPEBOMB_BOUNCE                 13');
  writeln (Defs, 'define PIPEBOMB_EXPLODE                14');
  writeln (Defs, 'define LASERTRIP_ONWALL                15');
  writeln (Defs, 'define LASERTRIP_ARMING                16');
  writeln (Defs, 'define LASERTRIP_EXPLODE               17');
  writeln (Defs, 'define VENT_BUST                       18');
  writeln (Defs, 'define GLASS_BREAKING                  19');
  writeln (Defs, 'define GLASS_HEAVYBREAK                20');
  writeln (Defs, 'define SHORT_CIRCUIT                   21');
  writeln (Defs, 'define ITEM_SPLASH                     22');
  writeln (Defs, 'define DUKE_BREATHING                  23');
  writeln (Defs, 'define DUKE_EXHALING                   24');
  writeln (Defs, 'define DUKE_GASP                       25');
  writeln (Defs, 'define SLIM_RECOG                      26');
  writeln (Defs, 'define ENDSEQVOL3SND1                  27');
  writeln (Defs, 'define DUKE_URINATE                    28');
  writeln (Defs, 'define ENDSEQVOL3SND2                  29');
  writeln (Defs, 'define ENDSEQVOL3SND3                  30');
  writeln (Defs, 'define DUKE_PASSWIND                   32');
  writeln (Defs, 'define DUKE_CRACK                      33');
  writeln (Defs, 'define SLIM_ATTACK                     34');
  writeln (Defs, 'define SOMETHINGHITFORCE               35');
  writeln (Defs, 'define DUKE_DRINKING                   36');
  writeln (Defs, 'define DUKE_KILLED1                    37');
  writeln (Defs, 'define DUKE_GRUNT                      38');
  writeln (Defs, 'define DUKE_HARTBEAT                   39');
  writeln (Defs, 'define DUKE_ONWATER                    40');
  writeln (Defs, 'define DUKE_DEAD                       41');
  writeln (Defs, 'define DUKE_LAND                       42');
  writeln (Defs, 'define DUKE_WALKINDUCTS                43');
  writeln (Defs, 'define DUKE_GLAD                       44');
  writeln (Defs, 'define DUKE_YES                        45');

END;

{*************************}
PROCEDURE DefsPart5 (VAR Defs : Text);

BEGIN
  writeln (Defs, 'define DUKE_HEHE                       46');
  writeln (Defs, 'define DUKE_SHUCKS                     47');
  writeln (Defs, 'define DUKE_UNDERWATER                 48');
  writeln (Defs, 'define DUKE_JETPACK_ON                 49');
  writeln (Defs, 'define DUKE_JETPACK_IDLE               50');
  writeln (Defs, 'define DUKE_JETPACK_OFF                51');
  writeln (Defs, 'define LIZTROOP_GROWL                  52');
  writeln (Defs, 'define LIZTROOP_TALK1                  53');
  writeln (Defs, 'define LIZTROOP_TALK2                  54');
  writeln (Defs, 'define LIZTROOP_TALK3                  55');
  writeln (Defs, 'define DUKETALKTOBOSS                  56');
  writeln (Defs, 'define LIZCAPT_GROWL                   57');
  writeln (Defs, 'define LIZCAPT_TALK1                   58');
  writeln (Defs, 'define LIZCAPT_TALK2                   59');
  writeln (Defs, 'define LIZCAPT_TALK3                   60');
  writeln (Defs, 'define LIZARD_BEG                      61');
  writeln (Defs, 'define LIZARD_PAIN                     62');
  writeln (Defs, 'define LIZARD_DEATH                    63');
  writeln (Defs, 'define LIZARD_SPIT                     64');
  writeln (Defs, 'define DRONE1_HISSRATTLE               65');
  writeln (Defs, 'define DRONE1_HISSSCREECH              66');
  writeln (Defs, 'define DUKE_TIP2                       67');
  writeln (Defs, 'define FLESH_BURNING                   68');
  writeln (Defs, 'define SQUISHED                        69');
  writeln (Defs, 'define TELEPORTER                      70');
  writeln (Defs, 'define ELEVATOR_ON                     71');
  writeln (Defs, 'define DUKE_KILLED3                    72');
  writeln (Defs, 'define ELEVATOR_OFF                    73');
  writeln (Defs, 'define DOOR_OPERATE1                   74');
  writeln (Defs, 'define SUBWAY                          75');
  writeln (Defs, 'define SWITCH_ON                       76');
  writeln (Defs, 'define FAN                             77');
  writeln (Defs, 'define DUKE_GETWEAPON3                 78');
  writeln (Defs, 'define FLUSH_TOILET                    79');
  writeln (Defs, 'define HOVER_CRAFT                     80');
  writeln (Defs, 'define EARTHQUAKE                      81');
  writeln (Defs, 'define INTRUDER_ALERT                  82');
  writeln (Defs, 'define END_OF_LEVEL_WARN               83');
  writeln (Defs, 'define ENGINE_OPERATING                84');
  writeln (Defs, 'define REACTOR_ON                      85');
  writeln (Defs, 'define COMPUTER_AMBIENCE               86');
  writeln (Defs, 'define GEARS_GRINDING                  87');
  writeln (Defs, 'define BUBBLE_AMBIENCE                 88');
  writeln (Defs, 'define MACHINE_AMBIENCE                89');
  writeln (Defs, 'define SEWER_AMBIENCE                  90');
  writeln (Defs, 'define WIND_AMBIENCE                   91');
  writeln (Defs, 'define SOMETHING_DRIPPING              92');
  writeln (Defs, 'define STEAM_HISSING                   93');
  writeln (Defs, 'define THEATER_BREATH                  94');
  writeln (Defs, 'define BAR_MUSIC                       95');
  writeln (Defs, 'define BOS1_ROAM                       96');
  writeln (Defs, 'define BOS1_RECOG                      97');
  writeln (Defs, 'define BOS1_ATTACK1                    98');
  writeln (Defs, 'define BOS1_PAIN                       99');
  writeln (Defs, 'define BOS1_DYING                     100');
  writeln (Defs, 'define BOS2_ROAM                      101');
  writeln (Defs, 'define BOS2_RECOG                     102');
  writeln (Defs, 'define BOS2_ATTACK                    103');
  writeln (Defs, 'define BOS2_PAIN                      104');
  writeln (Defs, 'define BOS2_DYING                     105');
  writeln (Defs, 'define GETATOMICHEALTH                106');
  writeln (Defs, 'define DUKE_GETWEAPON2                107');
  writeln (Defs, 'define BOS3_DYING                     108');
  writeln (Defs, 'define SHOTGUN_FIRE                   109');
  writeln (Defs, 'define PRED_ROAM                      110');
  writeln (Defs, 'define PRED_RECOG                     111');
  writeln (Defs, 'define PRED_ATTACK                    112');
  writeln (Defs, 'define PRED_PAIN                      113');
  writeln (Defs, 'define PRED_DYING                     114');
  writeln (Defs, 'define CAPT_ROAM                      115');
  writeln (Defs, 'define CAPT_ATTACK                    116');
  writeln (Defs, 'define CAPT_RECOG                     117');
  writeln (Defs, 'define CAPT_PAIN                      118');
  writeln (Defs, 'define CAPT_DYING                     119');
  writeln (Defs, 'define PIG_ROAM                       120');
  writeln (Defs, 'define PIG_RECOG                      121');
  writeln (Defs, 'define PIG_ATTACK                     122');
  writeln (Defs, 'define PIG_PAIN                       123');
  writeln (Defs, 'define PIG_DYING                      124');
  writeln (Defs, 'define RECO_ROAM                      125');
  writeln (Defs, 'define RECO_RECOG                     126');
  writeln (Defs, 'define RECO_ATTACK                    127');
  writeln (Defs, 'define RECO_PAIN                      128');
  writeln (Defs, 'define RECO_DYING                     129');
  writeln (Defs, 'define DRON_ROAM                      130');
  writeln (Defs, 'define DRON_RECOG                     131');
  writeln (Defs, 'define DRON_ATTACK1                   132');
  writeln (Defs, 'define DRON_PAIN                      133');
  writeln (Defs, 'define DRON_DYING                     134');
  writeln (Defs, 'define COMM_ROAM                      135');
  writeln (Defs, 'define COMM_RECOG                     136');
  writeln (Defs, 'define COMM_ATTACK                    137');
  writeln (Defs, 'define COMM_PAIN                      138');
  writeln (Defs, 'define COMM_DYING                     139');
  writeln (Defs, 'define OCTA_ROAM                      140');
  writeln (Defs, 'define OCTA_RECOG                     141');
  writeln (Defs, 'define OCTA_ATTACK1                   142');
  writeln (Defs, 'define OCTA_PAIN                      143');
  writeln (Defs, 'define OCTA_DYING                     144');
  writeln (Defs, 'define TURR_ROAM                      145');
  writeln (Defs, 'define TURR_RECOG                     146');
  writeln (Defs, 'define TURR_ATTACK                    147');
  writeln (Defs, 'define DUMPSTER_MOVE                  148');
  writeln (Defs, 'define SLIM_DYING                     149');
  writeln (Defs, 'define BOS3_ROAM                      150');
  writeln (Defs, 'define BOS3_RECOG                     151');
  writeln (Defs, 'define BOS3_ATTACK1                   152');
  writeln (Defs, 'define BOS3_PAIN                      153');
  writeln (Defs, 'define BOS1_ATTACK2                   154');
  writeln (Defs, 'define COMM_SPIN                      155');
  writeln (Defs, 'define BOS1_WALK                      156');
  writeln (Defs, 'define DRON_ATTACK2                   157');
  writeln (Defs, 'define THUD                           158');
  writeln (Defs, 'define OCTA_ATTACK2                   159');
  writeln (Defs, 'define WIERDSHOT_FLY                  160');
  writeln (Defs, 'define TURR_PAIN                      161');
  writeln (Defs, 'define TURR_DYING                     162');
  writeln (Defs, 'define SLIM_ROAM                      163');
  writeln (Defs, 'define LADY_SCREAM                    164');
  writeln (Defs, 'define DOOR_OPERATE2                  165');
  writeln (Defs, 'define DOOR_OPERATE3                  166');
  writeln (Defs, 'define DOOR_OPERATE4                  167');
  writeln (Defs, 'define BORNTOBEWILDSND                168');
  writeln (Defs, 'define SHOTGUN_COCK                   169');
  writeln (Defs, 'define GENERIC_AMBIENCE1              170');
  writeln (Defs, 'define GENERIC_AMBIENCE2              171');
  writeln (Defs, 'define GENERIC_AMBIENCE3              172');
  writeln (Defs, 'define GENERIC_AMBIENCE4              173');
  writeln (Defs, 'define GENERIC_AMBIENCE5              174');
  writeln (Defs, 'define GENERIC_AMBIENCE6              175');
  writeln (Defs, 'define BOS3_ATTACK2                   176');
  writeln (Defs, 'define GENERIC_AMBIENCE17             177');
  writeln (Defs, 'define GENERIC_AMBIENCE18             178');
  writeln (Defs, 'define GENERIC_AMBIENCE19             179');
  writeln (Defs, 'define GENERIC_AMBIENCE20             180');
  writeln (Defs, 'define GENERIC_AMBIENCE21             181');
  writeln (Defs, 'define GENERIC_AMBIENCE22             182');
  writeln (Defs, 'define SECRETLEVELSND                 183');
  writeln (Defs, 'define GENERIC_AMBIENCE8              184');
  writeln (Defs, 'define GENERIC_AMBIENCE9              185');
  writeln (Defs, 'define GENERIC_AMBIENCE10             186');
  writeln (Defs, 'define GENERIC_AMBIENCE11             187');
  writeln (Defs, 'define GENERIC_AMBIENCE12             188');
  writeln (Defs, 'define GENERIC_AMBIENCE13             189');
  writeln (Defs, 'define GENERIC_AMBIENCE14             190');
  writeln (Defs, 'define GENERIC_AMBIENCE15             192');
  writeln (Defs, 'define GENERIC_AMBIENCE16             193');
  writeln (Defs, 'define FIRE_CRACKLE                   194');
  writeln (Defs, 'define BONUS_SPEECH1                  195');
  writeln (Defs, 'define BONUS_SPEECH2                  196');
  writeln (Defs, 'define BONUS_SPEECH3                  197');
  writeln (Defs, 'define PIG_CAPTURE_DUKE               198');
  writeln (Defs, 'define BONUS_SPEECH4                  199');
  writeln (Defs, 'define DUKE_LAND_HURT                 200');
  writeln (Defs, 'define DUKE_HIT_STRIPPER1             201');
  writeln (Defs, 'define DUKE_TIP1                      202');
  writeln (Defs, 'define DUKE_KILLED2                   203');
  writeln (Defs, 'define PRED_ROAM2                     204');
  writeln (Defs, 'define PIG_ROAM2                      205');
  writeln (Defs, 'define DUKE_GETWEAPON1                206');
  writeln (Defs, 'define DUKE_SEARCH2                   207');
  writeln (Defs, 'define DUKE_CRACK2                    208');
  writeln (Defs, 'define DUKE_SEARCH                    209');
  writeln (Defs, 'define DUKE_GET                       210');
  writeln (Defs, 'define DUKE_LONGTERM_PAIN             211');
  writeln (Defs, 'define MONITOR_ACTIVE                 212');
  writeln (Defs, 'define NITEVISION_ONOFF               213');
  writeln (Defs, 'define DUKE_HIT_STRIPPER2             214');
  writeln (Defs, 'define DUKE_CRACK_FIRST               215');
  writeln (Defs, 'define DUKE_USEMEDKIT                 216');
  writeln (Defs, 'define DUKE_TAKEPILLS                 217');
  writeln (Defs, 'define DUKE_PISSRELIEF                218');
  writeln (Defs, 'define SELECT_WEAPON                  219');
  writeln (Defs, 'define WATER_GURGLE                   220');
  writeln (Defs, 'define DUKE_GETWEAPON4                221');
  writeln (Defs, 'define JIBBED_ACTOR1                  222');
  writeln (Defs, 'define JIBBED_ACTOR2                  223');
  writeln (Defs, 'define JIBBED_ACTOR3                  224');
  writeln (Defs, 'define JIBBED_ACTOR4                  225');
  writeln (Defs, 'define JIBBED_ACTOR5                  226');

END;

{*************************}
PROCEDURE DefsPart6 (VAR Defs : Text);

BEGIN
  writeln (Defs, 'define JIBBED_ACTOR6                  227');
  writeln (Defs, 'define JIBBED_ACTOR7                  228');
  writeln (Defs, 'define DUKE_GOTHEALTHATLOW            229');
  writeln (Defs, 'define BOSSTALKTODUKE                 230');
  writeln (Defs, 'define WAR_AMBIENCE1                  231');
  writeln (Defs, 'define WAR_AMBIENCE2                  232');
  writeln (Defs, 'define WAR_AMBIENCE3                  233');
  writeln (Defs, 'define WAR_AMBIENCE4                  234');
  writeln (Defs, 'define WAR_AMBIENCE5                  235');
  writeln (Defs, 'define WAR_AMBIENCE6                  236');
  writeln (Defs, 'define WAR_AMBIENCE7                  237');
  writeln (Defs, 'define WAR_AMBIENCE8                  238');
  writeln (Defs, 'define WAR_AMBIENCE9                  239');
  writeln (Defs, 'define WAR_AMBIENCE10                 240');
  writeln (Defs, 'define ALIEN_TALK1                    241');
  writeln (Defs, 'define ALIEN_TALK2                    242');
  writeln (Defs, 'define EXITMENUSOUND                  243');
  writeln (Defs, 'define FLY_BY                         244');
  writeln (Defs, 'define DUKE_SCREAM                    245');
  writeln (Defs, 'define SHRINKER_HIT                   246');
  writeln (Defs, 'define RATTY                          247');
  writeln (Defs, 'define INTO_MENU                      248');
  writeln (Defs, 'define BONUSMUSIC                     249');
  writeln (Defs, 'define DUKE_BOOBY                     250');
  writeln (Defs, 'define DUKE_TALKTOBOSSFALL            251');
  writeln (Defs, 'define DUKE_LOOKINTOMIRROR            252');
  writeln (Defs, 'define PIG_ROAM3                      253');
  writeln (Defs, 'define KILLME                         254');
  writeln (Defs, 'define DRON_JETSND                    255');
  writeln (Defs, 'define SPACE_DOOR1                    256');
  writeln (Defs, 'define SPACE_DOOR2                    257');
  writeln (Defs, 'define SPACE_DOOR3                    258');
  writeln (Defs, 'define SPACE_DOOR4                    259');
  writeln (Defs, 'define SPACE_DOOR5                    260');
  writeln (Defs, 'define ALIEN_ELEVATOR1                261');
  writeln (Defs, 'define VAULT_DOOR                     262');
  writeln (Defs, 'define JIBBED_ACTOR13                 263');
  writeln (Defs, 'define DUKE_GETWEAPON6                264');
  writeln (Defs, 'define JIBBED_ACTOR8                  265');
  writeln (Defs, 'define JIBBED_ACTOR9                  266');
  writeln (Defs, 'define JIBBED_ACTOR10                 267');
  writeln (Defs, 'define JIBBED_ACTOR11                 268');
  writeln (Defs, 'define JIBBED_ACTOR12                 269');
  writeln (Defs, 'define DUKE_KILLED4                   270');
  writeln (Defs, 'define DUKE_KILLED5                   271');
  writeln (Defs, 'define ALIEN_SWITCH1                  272');
  writeln (Defs, 'define DUKE_STEPONFECES               273');
  writeln (Defs, 'define DUKE_LONGTERM_PAIN2            274');
  writeln (Defs, 'define DUKE_LONGTERM_PAIN3            275');
  writeln (Defs, 'define DUKE_LONGTERM_PAIN4            276');
  writeln (Defs, 'define COMPANB2                       277');
  writeln (Defs, 'define KTIT                           278');
  writeln (Defs, 'define HELICOP_IDLE                   279');
  writeln (Defs, 'define STEPNIT                        280');
  writeln (Defs, 'define SPACE_AMBIENCE1                281');
  writeln (Defs, 'define SPACE_AMBIENCE2                282');
  writeln (Defs, 'define SLIM_HATCH                     283');
  writeln (Defs, 'define RIPHEADNECK                    284');
  writeln (Defs, 'define FOUNDJONES                     285');
  writeln (Defs, 'define ALIEN_DOOR1                    286');
  writeln (Defs, 'define ALIEN_DOOR2                    287');
  writeln (Defs, 'define ENDSEQVOL3SND4                 288');
  writeln (Defs, 'define ENDSEQVOL3SND5                 289');
  writeln (Defs, 'define ENDSEQVOL3SND6                 290');
  writeln (Defs, 'define ENDSEQVOL3SND7                 291');
  writeln (Defs, 'define ENDSEQVOL3SND8                 292');
  writeln (Defs, 'define ENDSEQVOL3SND9                 293');
  writeln (Defs, 'define WHIPYOURASS                    294');
  writeln (Defs, 'define ENDSEQVOL2SND1                 295');
  writeln (Defs, 'define ENDSEQVOL2SND2                 296');
  writeln (Defs, 'define ENDSEQVOL2SND3                 297');
  writeln (Defs, 'define ENDSEQVOL2SND4                 298');
  writeln (Defs, 'define ENDSEQVOL2SND5                 299');
  writeln (Defs, 'define ENDSEQVOL2SND6                 300');
  writeln (Defs, 'define ENDSEQVOL2SND7                 301');
  writeln (Defs, 'define GENERIC_AMBIENCE23             302');
  writeln (Defs, 'define SOMETHINGFROZE                 303');
  writeln (Defs, 'define DUKE_LONGTERM_PAIN5            304');
  writeln (Defs, 'define DUKE_LONGTERM_PAIN6            305');
  writeln (Defs, 'define DUKE_LONGTERM_PAIN7            306');
  writeln (Defs, 'define DUKE_LONGTERM_PAIN8            307');
  writeln (Defs, 'define WIND_REPEAT                    308');
  writeln (Defs, '');
END;

{*************************}

END.