UNIT EditData;

INTERFACE

USES
  Crt,
  ECData,
  Utility;

VAR
  Count : Byte;

PROCEDURE EditPlayer (VAR Player : PlayerR);
PROCEDURE EditWeapons (VAR Ammo : AmmoR;
                       VAR Box : BoxR;
                       VAR Strength : StrengthR;
                       VAR Radius : RadiusR);
PROCEDURE EditEnemy (VAR Enemy : EnemyR);

IMPLEMENTATION

{***************************************************************************}
PROCEDURE UserEnter (StartX, StartY : Byte; VAR Value : STRING; MaxLength : Byte; Prompt : STRING);

VAR
  Charac : Char;
  Count  : Byte;
  Exit   : Boolean;
  Temp   : STRING;

BEGIN

  MakeWin (TextColor,BackColor,StartX,StartY,(length(Prompt) + 4),4,True,True);
  WrtS (2,1,Prompt);
  WrtS (2,2,'==> ');
  TcTb (15,3);
  FOR Count := 1 TO MaxLength + 2 DO write (' ');
  gotoXY (7,2);
  FOR Count := 1 TO MaxLength DO Temp[Count] := ' ';
  Exit := False;
  Count := 0;
  WHILE NOT Exit DO
     BEGIN
       Charac := Readkey;
       IF (Charac IN ['0'..'9']) AND (Count IN [0..(MaxLength - 1)]) THEN
           BEGIN
             inc(Count);
             Temp[Count] := Charac;
             WrtS (Count + 6,2,Temp[Count]);
             IF Count = MaxLength THEN GotoXY (Count + 6,2);
           END
         ELSE
           IF (Charac = #8) AND (Count >= 1) THEN
               BEGIN
                 Temp[Count] := ' ';
                 WrtS (Count + 6,2,Temp[Count]);
                 GotoXY (Count + 6,2);
                 dec(Count);
               END
             ELSE
               IF (Charac = #13) OR (Charac = #27) THEN
                   Exit := True
                 ELSE
                   IF (Charac = #0) THEN
                     ELSE Beep (700,50);
     END;
  IF (Temp[1] <> ' ') AND (Charac <> #27) THEN
      FOR Count := 1 TO MaxLength DO Value[Count] := Temp[Count]
    ELSE FOR Count := 1 TO MaxLength DO Temp[Count] := Value[Count];
  Clear (HeaderColor,MainBackColor,StartX,StartY,(StartX + 5 + length(Prompt)),(StartY + 4))
END;

{***************************************************************************}
PROCEDURE EditString3A (VAR Value : String3);

VAR
  Temp   : STRING;
  Choice : Char;
  Cursor : Byte;
  Menu   : MenuType;

BEGIN
  MakeWin (TextColor,BackColor,49,2,9,12,True,True);

  Menu[1] := ' 100 ';
  Menu[2] := ' 200 ';
  Menu[3] := ' 300 ';
  Menu[4] := ' 400 ';
  Menu[5] := ' 500 ';
  Menu[6] := ' 600 ';
  Menu[7] := ' 700 ';
  Menu[8] := ' 800 ';
  Menu[9] := ' 900 ';
  Menu[10] := ' UDC ';

  FOR Count := 1 TO 10 DO
    WrtS (2,Count,Menu[Count]);
  Cursor := 1;

  Select (TextColor,BackColor,SelectText,SelectBack,2,1,10,Cursor,Choice,Menu);
  IF Choice = #13 THEN
      CASE Cursor OF
        1..9 : Value := Menu[Cursor][2] + Menu[Cursor][3] + Menu[Cursor][4];
        10 : BEGIN
               Temp := Value;
               UserEnter (34,17,Temp,3,'Enter new value (0-999)');
               Value[1] := Temp[1];
               Value[2] := Temp[2];
               Value[3] := Temp[3];
             END;
      END;
  CLEAR (HeaderColor,MainBackColor,49,2,65,15);
END;

{***************************************************************************}
PROCEDURE EditString3B (VAR Value : String3);

VAR
  Temp   : STRING;
  Choice : Char;
  Cursor : Byte;
  Menu   : MenuType;

BEGIN
  MakeWin (TextColor,BackColor,67,2,9,13,True,True);

  Menu[1] := ' 50 ';
  Menu[2] := ' 100 ';
  Menu[3] := ' 200 ';
  Menu[4] := ' 300 ';
  Menu[5] := ' 400 ';
  Menu[6] := ' 500 ';
  Menu[7] := ' 600 ';
  Menu[8] := ' 700 ';
  Menu[9] := ' 800 ';
  Menu[10] := ' 900 ';
  Menu[11] := ' UDC ';

  FOR Count := 1 TO 11 DO
    WrtS (2,Count,Menu[Count]);
  Cursor := 1;

  Select (TextColor,BackColor,SelectText,SelectBack,2,1,11,Cursor,Choice,Menu);
  IF Choice = #13 THEN
      CASE Cursor OF
        1..10 : Value := Menu[Cursor][2] + Menu[Cursor][3] + Menu[Cursor][4];
        11 : BEGIN
               Temp := Value;
               UserEnter (30,15,Temp,3,'Enter new value (0-999)');
               Value[1] := Temp[1];
               Value[2] := Temp[2];
               Value[3] := Temp[3];
             END;
      END;
  CLEAR (HeaderColor,MainBackColor,67,2,77,16);
END;

{***************************************************************************}
PROCEDURE EditString4A (VAR Value : String4; Opt1, Opt2, Opt3, Opt4, Opt5 : String4);


VAR
  Temp   : STRING;
  Choice : Char;
  Cursor : Byte;
  Menu   : MenuType;

BEGIN
  MakeWin (TextColor,BackColor,49,2,10,8,True,True);

  Menu[1] := '   0% ';
  Menu[2] := '  25% ';
  Menu[3] := '  50% ';
  Menu[4] := '  75% ';
  Menu[5] := ' 100% ';
  Menu[6] := '  UDC ';

  FOR Count := 1 TO 6 DO
    WrtS (2,Count,Menu[Count]);
  Cursor := 1;

  Select (TextColor,BackColor,SelectText,SelectBack,2,1,6,Cursor,Choice,Menu);
  IF Choice = #13 THEN
      CASE Cursor OF
        1 : Value := Opt1;
        2 : Value := Opt2;
        3 : Value := Opt3;
        4 : Value := Opt4;
        5 : Value := Opt5;
        6 : BEGIN
              Temp := Value;
              UserEnter (34,17,Temp,4,'Enter new value (0-9999)');
              Value[1] := Temp[1];
              Value[2] := Temp[2];
              Value[3] := Temp[3];
              Value[4] := Temp[4];
            END;
      END;
  CLEAR (HeaderColor,MainBackColor,49,2,76,11);
END;

{***************************************************************************}
PROCEDURE EditString4B (VAR Value : String4; Opt1, Opt2, Opt3, Opt4, Opt5, Opt6 : String4);

VAR
  Temp   : STRING;
  Choice : Char;
  Cursor : Byte;
  Menu   : MenuType;

BEGIN
  MakeWin (TextColor,BackColor,67,2,11,9,True,True);

  Menu[1] := '   25% ';
  Menu[2] := '   50% ';
  Menu[3] := '  100% ';
  Menu[4] := '  500% ';
  Menu[5] := ' 1000% ';
  Menu[6] := ' 5000% ';
  Menu[7] := '   UDC ';

  FOR Count := 1 TO 7 DO
    WrtS (2,Count,Menu[Count]);
  Cursor := 1;

  Select (TextColor,BackColor,SelectText,SelectBack,2,1,7,Cursor,Choice,Menu);
  IF Choice = #13 THEN
      CASE Cursor OF
        1 : Value := Opt1;
        2 : Value := Opt2;
        3 : Value := Opt3;
        4 : Value := Opt4;
        5 : Value := Opt5;
        6 : Value := Opt6;
        7 : BEGIN
              Temp := Value;
              UserEnter (41,14,Temp,4,'Enter new value (0-9999)');
              Value[1] := Temp[1];
              Value[2] := Temp[2];
              Value[3] := Temp[3];
              Value[4] := Temp[4];
            END;
      END;
  Clear (HeaderColor,MainBackColor,67,2,79,12);
END;

{***************************************************************************}
PROCEDURE EditString4C (VAR Value : String4; Opt1, Opt2, Opt3, Opt4, Opt5 : String4);

VAR
  Temp   : STRING;
  Choice : Char;
  Cursor : Byte;
  Menu   : MenuType;

BEGIN
  MakeWin (TextColor,BackColor,46,2,11,8,True,True);

  Menu[1] := '   25% ';
  Menu[2] := '   50% ';
  Menu[3] := '  100% ';
  Menu[4] := '  500% ';
  Menu[5] := ' 1000% ';
  Menu[6] := '   UDC ';

  FOR Count := 1 TO 6 DO
    WrtS (2,Count,Menu[Count]);
  Cursor := 1;

  Select (TextColor,BackColor,SelectText,SelectBack,2,1,6,Cursor,Choice,Menu);
  IF Choice = #13 THEN
      CASE Cursor OF
        1 : Value := Opt1;
        2 : Value := Opt2;
        3 : Value := Opt3;
        4 : Value := Opt4;
        5 : Value := Opt5;
        6 : BEGIN
              Temp := Value;
              UserEnter (46,12,Temp,4,'Enter new value (0-9999)');
              Value[1] := Temp[1];
              Value[2] := Temp[2];
              Value[3] := Temp[3];
              Value[4] := Temp[4];
            END;
      END;
  CLEAR (HeaderColor,MainBackColor,46,2,64,10);
END;

{***************************************************************************}
PROCEDURE EditString5 (StartX, Starty : Byte;
                       VAR Value : String5; Opt1, Opt2, Opt3, Opt4, Opt5 : String5);

VAR
  Temp   : STRING;
  Choice : Char;
  Cursor : Byte;
  Menu   : MenuType;

BEGIN
  MakeWin (TextColor,BackColor,StartX,StartY,10,8,True,True);

  Menu[1] := '  25% ';
  Menu[2] := '  50% ';
  Menu[3] := ' 100% ';
  Menu[4] := ' 250% ';
  Menu[5] := ' 500% ';
  Menu[6] := '  UDC ';

  FOR Count := 1 TO 6 DO
    WrtS (2,Count,Menu[Count]);
  Cursor := 1;

  Select (TextColor,BackColor,SelectText,SelectBack,2,1,6,Cursor,Choice,Menu);
  IF Choice = #13 THEN
      CASE Cursor OF
        1 : Value := Opt1;
        2 : Value := Opt2;
        3 : Value := Opt3;
        4 : Value := Opt4;
        5 : Value := OPt5;
        6 : BEGIN
              Temp := Value;
              UserEnter (46,12,Temp,5,'Enter new value (0-99999)');
              Value[1] := Temp[1];
              Value[2] := Temp[2];
              Value[3] := Temp[3];
              Value[4] := Temp[4];
              Value[5] := Temp[5];
            END;
      END;
  Clear (HeaderColor,MainBackColor,StartX,StartY,(StartX + 11),(StartY + 8));
END;

{***************************************************************************}

PROCEDURE EditPlayer (VAR Player : PlayerR);

VAR
  Exit   : Boolean;
  Choice : Char;
  Cursor : Byte;
  Menu   : MenuType;

BEGIN
  Exit := False;
  Cursor := 1;
  WHILE NOT Exit DO
    BEGIN
      MakeWin (TextColor,BackColor,21,2,24,13,True,True);

      Menu[1] := ' Max Regular Health ';
      Menu[2] := ' Max Atomic Health ';
      Menu[3] := ' Max Armor Amount ';
      Menu[4] := ' Armor Start Amount ';
      Menu[5] := ' Steroid Bottle ';
      Menu[6] := ' Scuba Gear Tank ';
      Menu[7] := ' Holoduke Amount ';
      Menu[8] := ' Jetpack Fuel ';
      Menu[9] := ' Boot Amount ';
      Menu[10] := ' Night Vision ';
      Menu[11] := ' Medkit Amount ';

      FOR Count := 1 TO 11 DO
        WrtS (2,Count,Menu[Count]);

      Select (TextColor,BackColor,SelectText,SelectBack,2,1,11,Cursor,Choice,Menu);
      IF Choice = #13 THEN
          CASE Cursor OF
             1 : EditString3A (Player.MaxHealth1);
             2 : EditString3A (Player.MaxHealth2);
             3 : EditString3A (Player.MaxArmor);
             4 : EditString3A (Player.StartArmor);
             5 : EditString4A (Player.Steroids,'0','100','200','300','400');
             6 : EditString4A (Player.Scuba,'0','1600','3200','4800','6400');
             7 : EditString4A (Player.Holoduke,'0','600','1200','1800','2400');
             8 : EditString4A (Player.Jetpack,'0','400','800','1200','1600');
             9 : EditString4A (Player.Boots,'0','50','100','150','200');
            10 : EditString4A (Player.Vision,'0','300','600','900','1200');
            11 : EditString3A (Player.Medkit);
          END
        ELSE Exit := True;
    END;
END;

{***************************************************************************}
PROCEDURE EditMaxAmmo (VAR Ammo : AmmoR);

VAR
  Exit   : Boolean;
  Choice : Char;
  Cursor : Byte;
  Menu   : MenuType;

BEGIN
  Exit := False;
  Cursor := 1;
  WHILE NOT Exit DO
    BEGIN
      MakeWin (TextColor,BackColor,47,2,16,11,True,True);

      Menu[1] := ' Pistol ';
      Menu[2] := ' Shotgun ';
      Menu[3] := ' Chaingun ';
      Menu[4] := ' RPG ';
      Menu[5] := ' Pipebomb ';
      Menu[6] := ' Shrinker ';
      Menu[7] := ' Devastator ';
      Menu[8] := ' Tripbomb ';
      Menu[9] := ' Freezer ';

      FOR Count := 1 TO 9 DO
        WrtS (2,Count,Menu[Count]);

      Select (TextColor,BackColor,SelectText,SelectBack,2,1,9,Cursor,Choice,Menu);
      IF Choice = #13 THEN
          CASE Cursor OF
            1 : EditString3B (Ammo.Pistol);
            2 : EditString3B (Ammo.Shotgun);
            3 : EditString3B (Ammo.Chaingun);
            4 : EditString3B (Ammo.RPG);
            5 : EditString3B (Ammo.Pipebomb);
            6 : EditString3B (Ammo.Shrinker);
            7 : EditString3B (Ammo.Devastator);
            8 : EditString3B (Ammo.Tripbomb);
            9 : EditString3B (Ammo.Freezer);
          END
        ELSE Exit := True;
    END;
  Clear (HeaderColor,MainBackColor,47,2,70,14);
END;

{***************************************************************************}
PROCEDURE EditBoxAmmo (VAR Box : BoxR);

VAR
  Exit   : Boolean;
  Choice : Char;
  Cursor : Byte;
  Menu   : MenuType;

BEGIN
  Exit := False;
  Cursor := 1;
  WHILE NOT Exit DO
    BEGIN
      MakeWin (TextColor,BackColor,47,2,16,10,True,True);

      Menu[1] := ' Pistol ';
      Menu[2] := ' Shotgun ';
      Menu[3] := ' Chaingun ';
      Menu[4] := ' RPG ';
      Menu[5] := ' Pipebomb ';
      Menu[6] := ' Shrinker ';
      Menu[7] := ' Devastator ';
      Menu[8] := ' Freezer ';

      FOR Count := 1 TO 8 DO
        WrtS (2,Count,Menu[Count]);

      Select (TextColor,BackColor,SelectText,SelectBack,2,1,8,Cursor,Choice,Menu);
      IF Choice = #13 THEN
          CASE Cursor OF
            1 : EditString3B (Box.Pistol);
            2 : EditString3B (Box.Shotgun);
            3 : EditString3B (Box.Chaingun);
            4 : EditString3B (Box.RPG);
            5 : EditString3B (Box.Pipebomb);
            6 : EditString3B (Box.Shrinker);
            7 : EditString3B (Box.Devastator);
            8 : EditString3B (Box.Freezer);
          END
        ELSE Exit := True;
    END;
  Clear (HeaderColor,MainBackColor,47,2,70,13);
END;

{***************************************************************************}
PROCEDURE EditWeaponStrength (VAR Strength : StrengthR);

VAR
  Exit   : Boolean;
  Choice : Char;
  Cursor : Byte;
  Menu   : MenuType;

BEGIN
  Exit := False;
  Cursor := 1;
  WHILE NOT Exit DO
    BEGIN
      MakeWin (TextColor,BackColor,47,2,16,10,True,True);

      Menu[1] := ' Kicking ';
      Menu[2] := ' Pistol ';
      Menu[3] := ' Shotgun ';
      Menu[4] := ' Chaingun ';
      Menu[5] := ' RPG ';
      Menu[6] := ' Pipebomb ';
      Menu[7] := ' Tripbomb ';
      Menu[8] := ' Freezer ';

      FOR Count := 1 TO 8 DO
        WrtS (2,Count,Menu[Count]);

      Select (TextColor,BackColor,SelectText,SelectBack,2,1,8,Cursor,Choice,Menu);
      IF Choice = #13 THEN
          CASE Cursor OF
            1 : EditString4B (Strength.Kick,'2','5','10','50','100','500');
            2 : EditString4B (Strength.Pistol,'1','3','6','30','60','300');
            3 : EditString4B (Strength.Shotgun,'2','5','10','50','100','500');
            4 : EditString4B (Strength.Chaingun,'2','4','9','45','90','450');
            5 : EditString4B (Strength.RPG,'35','70','140','700','1400','7000');
            6 : EditString4B (Strength.Pipebomb,'35','70','140','700','1400','7000');
            7 : EditString4B (Strength.Tripbomb,'25','50','100','500','1000','5000');
            8 : EditString4B (Strength.Freezer,'4','8','16','80','160','800');
          END
        ELSE Exit := True;
    END;
  Clear (HeaderColor,MainBackColor,47,2,70,13);
END;

{***************************************************************************}
PROCEDURE EditBlastRadius (VAR Radius : RadiusR);

VAR
  Exit   : Boolean;
  Choice : Char;
  Cursor : Byte;
  Menu   : MenuType;

BEGIN
  Exit := False;
  Cursor := 1;
  WHILE NOT Exit DO
    BEGIN
      MakeWin (TextColor,BackColor,47,2,14,6,True,True);

      Menu[1] := ' RPG ';
      Menu[2] := ' Pipebomb ';
      Menu[3] := ' Shrinker ';
      Menu[4] := ' Tripbomb ';

      FOR Count := 1 TO 4 DO
        WrtS (2,Count,Menu[Count]);

      Select (TextColor,BackColor,SelectText,SelectBack,2,1,4,Cursor,Choice,Menu);
      IF Choice = #13 THEN
          CASE Cursor OF
            1 : EditString5 (65,2,Radius.RPG,'445','890','1780','4450','8900');
            2 : EditString5 (65,2,Radius.Pipebomb,'625','1250','2500','6250','12500');
            3 : EditString5 (65,2,Radius.Shrinker,'162','325','650','1620','3250');
            4 : EditString5 (65,2,Radius.Tripbomb,'950','1900','3800','9500','19000');
          END
        ELSE Exit := True;
    END;
  Clear (HeaderColor,MainBackColor,47,2,68,8);
END;

{***************************************************************************}
PROCEDURE EditWeapons (VAR Ammo : AmmoR;
                       VAR Box : BoxR;
                       VAR Strength : StrengthR;
                       VAR Radius : RadiusR);

VAR
  Exit   : Boolean;
  Choice : Char;
  Cursor : Byte;
  Menu   : MenuType;

BEGIN
  Exit := False;
  Cursor := 1;
  WHILE NOT Exit DO
    BEGIN
      MakeWin (TextColor,BackColor,21,2,22,6,True,True);

      Menu[1] := ' Max Weapon Ammo ';
      Menu[2] := ' Box Ammo Amount ';
      Menu[3] := ' Weapon Strength ';
      Menu[4] := ' Blast Radius ';

      FOR Count := 1 TO 4 DO
        WrtS (2,Count,Menu[Count]);

      Select (TextColor,BackColor,SelectText,SelectBack,2,1,4,Cursor,Choice,Menu);
      IF Choice = #13 THEN
          CASE Cursor OF
            1 : EditMaxAmmo (Ammo);
            2 : EditBoxAmmo (Box);
            3 : EditWeaponStrength (Strength);
            4 : EditBlastRadius (Radius);
          END
        ELSE Exit := True;
    END;
END;

{***************************************************************************}
PROCEDURE EditEnemy (VAR Enemy : EnemyR);

VAR
  Exit   : Boolean;
  Choice : Char;
  Cursor : Byte;
  Menu   : MenuType;

BEGIN
  Exit := False;
  Cursor := 1;
  WHILE NOT Exit DO
    BEGIN
      MakeWin (TextColor,BackColor,21,2,21,18,True,True);

      Menu[1] := ' Trooper ';
      Menu[2] := ' Pig Cop ';
      Menu[3] := ' Pig Cop Armor 1 ';
      Menu[4] := ' Pig Cop Armor 2 ';
      Menu[5] := ' Recon Car ';
      Menu[6] := ' Octabrain ';
      Menu[7] := ' Regular Turret ';
      Menu[8] := ' Rotating Turret ';
      Menu[9] := ' Sentry Drone ';
      Menu[10] := ' Lizard Enforcer ';
      Menu[11] := ' Shark ';
      Menu[12] := ' Fat Commander ';
      Menu[13] := ' Mini Boss ';
      Menu[14] := ' Episode 1 Boss ';
      Menu[15] := ' Episode 2 Boss ';
      Menu[16] := ' Episode 3 Boss ';

      FOR Count := 1 TO 16 DO
        WrtS (2,Count,Menu[Count]);

      Select (TextColor,BackColor,SelectText,SelectBack,2,1,16,Cursor,Choice,Menu);
      IF Choice = #13 THEN
          CASE Cursor OF
             1 : EditString4C (Enemy.Trooper,'7','15','30','150','300');
             2 : EditString4C (Enemy.PigCop,'25','50','100','500','1000');
             3 : EditString4C (Enemy.PigCopShield1,'18','37','75','375','750');
             4 : EditString4C (Enemy.PigCopShield2,'12','25','50','250','500');
             5 : EditString4C (Enemy.Recon,'12','25','50','250','500');
             6 : EditString4C (Enemy.Octabrain,'41','82','175','875','1750');
             7 : EditString4C (Enemy.Turret,'10','20','40','200','400');
             8 : EditString4C (Enemy.RotTurret,'10','20','40','200','400');
             9 : EditString4C (Enemy.Drone,'37','75','150','750','1500');
            10 : EditString4C (Enemy.Lizard,'25','50','100','500','1000');
            11 : EditString4C (Enemy.Shark,'8','17','35','170','350');
            12 : EditString4C (Enemy.Commander,'87','175','350','1750','3500');
            13 : EditString5 (46,2,Enemy.MiniBoss1,'250','500','1000','5000','10000');
            14 : EditString5 (46,2,Enemy.Boss1,'1125','2250','4500','11250','22500');
            15 : EditString5 (46,2,Enemy.Boss2,'1125','2250','4500','11250','22500');
            16 : EditString5 (46,2,Enemy.Boss3,'1125','2250','4500','11250','22500');
          END
        ELSE Exit := True;
    END;
END;

{***************************************************************************}

END.