PROGRAM MakeIMG;

USES
  NewDelay,
  Crt,
  Dos,
  Menus,
  Utility,
  GrubData,
  ImgData;

VAR
  OrigMode   : Integer;
  ImageData  : Text;
  Pixel      : PixelType;
  Count,
  Counter,
  Width,
  Height     : Byte;
  Image      : FILE;
  NumRead,
  NumWritten : Integer;
  Root       : FileName;
  TempChar   : Char;

BEGIN
  Root := GetRoot;

  assign (ImageData, Root + '\images\' + ParamStr(1) + '.txt');
  reset (ImageData);
  assign (Image, Root + '\images\' + ParamStr(1) + ImageExtention);
  rewrite (Image,1);

  NumWritten := 0;
  readln (ImageData, Width, Height);
  blockwrite (Image, Width, sizeof(Width), NumWritten);
  blockwrite (Image, Height, sizeof(Height), NumWritten);
  FOR Count := 1 TO Height DO
    BEGIN
      FOR Counter := 1 TO Width DO
        BEGIN
          read (ImageData,Pixel.Character,Pixel.Color);
          blockwrite (Image, Pixel, sizeof(Pixel), NumWritten);
          read (ImageData,TempChar);
        END;
      readln (ImageData);
    END;

  close (ImageData);
  close (Image);

  OrigMode := LastMode;
  TextMode (C80 + Font8x8);
  HighIntensity;
  CursorOff;

  DrawImage (ParamStr(1),1,1);
  REPEAT UNTIL KeyPressed;

  CursorOn;
  TextMode (OrigMode);

END.