program eco2;

uses crt;

type
  week_range    = 1..15;
  comp_array    = array [1..10] of integer;
  selec_array   = array [1..4] of string;
  week_array    = array [week_range] of integer;
  date_array    = array [week_range] of string;
  close_array   = array [week_range] of real;
  change_array  = array [week_range] of real;


var
  choice1       : selec_array;
  date          : date_array;
  close         : close_array;
  change        : change_array;

  user,
  period,
  datenow,
  compname,
  compabb,
  market,
  datepurch     : string;

  selection,
  review,
  choice,
  cont,
  makemon       : char;

  numweek,
  j,
  cursor,
  seleccon,
  r,
  compnum,
  snd,
  t,
  s,
  dly,
  numpurch      : integer;

  priceps,
  pricetot,
  mon,
  pricesold,
  commsold,
  prolos,
  pricesoldtot,
  stockbro      : real;

{***************************************************************************}
procedure writeat (x,y : integer; strng : string);
begin
  gotoXY (x,y);
  write (strng);
end;
{***************************************************************************}
procedure linex (f,l,x,y : integer; strng : string);
begin
  for j := f to l do
    writeat ((x + j),y,strng);
end;
{***************************************************************************}
procedure liney (f,l,x,y : integer; strng : string);
begin
  for j := f to l do
    writeat (x,(y + j),strng);
end;
{***************************************************************************}
procedure assgn;
begin
  for j := 1 to numweek do
    begin
     close[j]  := 0;
     change[j] := 0;
    end;
end;
{***************************************************************************}
procedure tctb (tc,tb : integer);
begin
  textcolor (tc);
  textbackground (tb);
end;
{***************************************************************************}
procedure calcchange;
begin
  if j = 1
    then
      change[1] := 0
    else
      change[j] := close[j] - close[j - 1];
end;
{***************************************************************************}
procedure closeprice;
begin
  for j := 2 to (numweek - 1) do
    readln (close[j]);
end;
{***************************************************************************}
procedure bar;
begin
  tctb (0,0);
  clrscr;
  window (1,1,79,25);
  tctb (0,7);
  clrscr;
  choice1[1] := 'File';
  choice1[2] := 'Edit';
  choice1[3] := 'Print';
  choice1[4] := 'Exit';
  window (1,1,79,3);
  textbackground (1);
  clrscr;
  window (80,1,80,25);
  tctb (0,0);
  clrscr;
  window (1,1,1,25);
  tctb (0,0);
  clrscr;
  window (1,1,80,25);
  tctb (0,7);
  writeat (6,2,choice1[1]);
  cursor := 6;
  for j := 2 to 4 do
    begin
      tctb (7,1);
      writeat (cursor + 10,2,choice1[j]);
      cursor := cursor + 10;
    end;
  writeat (2,1,'');
  writeat (79,1,'');
  writeat (2,2,'');
  writeat (79,2,'');
  writeat (2,3,'');
  writeat (79,3,'');
  for j := 3 to 78 do
    writeat (j,3,'');
  for j := 3 to 78 do
    writeat (j,1,'');
  cursor := 6;
  tctb (1,1);
  writeat (cursor + 5,2,' ');
  gotoXY (cursor + 5,2);
end;
{***************************************************************************}
procedure move;
begin
  selection := readkey;
  seleccon := ord(selection);
  case seleccon of
    77 : case cursor of
           6 : begin
                 tctb (7,1);
                 writeat (cursor,2,choice1[1]);
                 cursor := cursor + 10;
                 tctb (0,7);
                 writeat (cursor,2,choice1[2]);
               end;
          16 : begin
                 tctb (7,1);
                 writeat (cursor,2,choice1[2]);
                 cursor := cursor + 10;
                 tctb (0,7);
                 writeat (cursor,2,choice1[3]);
               end;
          26 : begin
                 tctb (7,1);
                 writeat (cursor,2,choice1[3]);
                 cursor := cursor + 10;
                 tctb (0,7);
                 writeat (cursor,2,choice1[4]);
               end;
          36 : begin
                 tctb (7,1);
                 writeat (cursor,2,choice1[4]);
                 tctb (0,7);
                 cursor := 6;
                 writeat (cursor,2,choice1[1]);
               end;
         end;
    75 : case cursor of
           6 : begin
                 tctb (7,1);
                 writeat (cursor,2,choice1[1]);
                 cursor := 36;
                 tctb (0,7);
                 writeat (cursor,2,choice1[4]);
               end;
          16 : begin
                 tctb (7,1);
                 writeat (cursor,2,choice1[2]);
                 cursor := cursor - 10;
                 tctb (0,7);
                 writeat (cursor,2,choice1[1]);
               end;
          26 : begin
                 tctb (7,1);
                 writeat (cursor,2,choice1[3]);
                 cursor := cursor - 10;
                 tctb (0,7);
                 writeat (cursor,2,choice1[2]);
               end;
          36 : begin
                 tctb (7,1);
                 writeat (cursor,2,choice1[4]);
                 tctb (0,7);
                 cursor := cursor - 10;
                 writeat (cursor,2,choice1[3]);
               end;
         end;
  end;
  tctb (1,1);
  writeat (cursor + 5,2,' ');
  gotoXY (cursor + 5,2);
end;
{***************************************************************************}

procedure explain;

begin

  tctb (0,7);
  window (2,4,79,25);
  clrscr;
  writeln;
  writeln (' Welcome to your personal printout program',
           ' for your economics project.');
  writeln;
  writeln (' Please enter the requested information for the title sheet.');
  writeln;
  writeln (' Name:');
  writeln (' Period:');
  writeln (' Date:');
  tctb (1,7);
  gotoXY (10,6);
  readln (user);
  gotoXY (10,7);
  readln (period);
  gotoXY (10,8);
  readln (datenow);
  clrscr;
  tctb (0,7);
  writeln (' Thank you ', user, '. Now we can begin.');
  clrscr;
  tctb (0,7);
  writeln;
  writeln (' Now we will begin entering the information on your companies.');
  writeln;
  writeln (' If you would like to print out the information');
  writeln (' about your company, press the <Print Screen>');
  writeln (' button before you continue to the next sheet.');
  writeln;
  writeln (' Press <Enter>');
  readln;
  clrscr;
end;

{ ************************************************************************* }
procedure totreport;

begin
  tctb (0,0);
  linex (1,70,5,21,'');
  liney (1,18,74,2,'');
  window (5,5,74,23);
  tctb (7,1);
  clrscr;
  linex (1,66,2,1,'');
  linex (1,66,2,3,'');
  linex (1,66,2,19,'');
  liney (1,17,2,1,'');
  liney (1,17,16,1,'');
  liney (1,17,36,1,'');
  liney (1,17,54,1,'');
  liney (1,17,69,1,'');
  writeat (2,1,'');
  writeat (69,1,'');
  writeat (2,19,'');
  writeat (69,19,'');
  writeat (16,1,'');
  writeat (36,1,'');
  writeat (54,1,'');
  writeat (16,19,'');
  writeat (36,19,'');
  writeat (54,19,'');
  writeat (16,3,'');
  writeat (36,3,'');
  writeat (54,3,'');
  writeat (2,3,'');
  writeat (69,3,'');
  writeat (4,2,'Week Number');
  writeat (23,2,'Date');
  writeat (44,2,'Close');
  writeat (60,2,'Change');
  r := 2;
  for j := 1 to numweek do
    begin
      r := r + 1;
      gotoXY (9,j + r);
      write (j);
    end;
  r := 2;
  for j := 1 to numweek do
    begin
      r := r + 1;
      writeat (18,j + r,date[j]);
    end;
  r := 2;
  for j := 1 to numweek do
    begin
      r := r + 1;
      gotoXY (45,j + r);
      write (close[j]:0:3);
    end;
  r := 2;
  for j := 1 to numweek do
    begin
      r := r + 1;
      gotoXY (61,j + r);
      write (change[j]:0:3);
    end;
end;

{ ************************************************************************* }
procedure company;

begin

  clrscr;
  tctb (0,7);
  writeln;
  write (' How many weeks are to be inputed? ');
  readln (numweek);
  assgn;
  clrscr;
  writeln;
  writeln ('Company Name:                    Market:');
  writeln;
  writeln ('Company Abbreviation:');
  for j := 1 to 3 do
    writeln;
  writeln ('Date Purchased:                       Price Paid: Per Share =');
  writeln;
  writeln ('Number Purchased:                                 Total     =');
  writeln;
  writeln ('Date sold:                            Price sold: Per Share =');
  writeln;
  writeln ('Profit / Loss :                                   Total     =');
  writeln;
  writeln ('Amount paid on commission to the stock broker:');
  writeln;
  writeln ('Did you make money after all commisions were paid? ');
  tctb (1,7);
  gotoXY (15,2);
  readln (compname);
  gotoXY (23,4);
  readln (compabb);
  gotoXY (42,2);
  readln (market);
  gotoXY (17,8);
  readln (date[1]);
  gotoXY (19,10);
  readln (numpurch);
  gotoXY (63,8);
  readln (close[1]);
  pricetot := numpurch * close[1];
  gotoXY (63,10);
  write (pricetot:5:3);
  gotoXY (12,12);
  readln (date[numweek]);
  gotoXY (63,12);
  readln (close[numweek]);
  pricesoldtot := numpurch * close[numweek];
  gotoXY (63,14);
  write (pricesoldtot:5:3);
  prolos := pricesold * numpurch;
  mon := pricesoldtot - pricetot;
  gotoXY (17,14);
  if prolos < pricetot
    then
      write ('Loss of ');
  if prolos > pricetot
    then
      write ('Profit of ');
  if prolos = pricetot
    then
      write ('No profit or loss');
  if (prolos < pricetot) or (prolos > pricetot)
    then
      write (mon:0:3);
  gotoXY (49,16);
  writeln ('10.00');
  stockbro := mon - 10;
  gotoXY (55,18);
  if stockbro > 0
    then
      writeln ('Yes')
    else
      writeln ('No');
  readln;
  textcolor (2);
  writeln;
  writeln (' Press <Enter> to continue.');
  readln;
  tctb (10,7);
  clrscr;
  writeln (' This section is to gather the days that you checked your stock');
  writeln (' prices on. Beginning with week two on the chart, enter the');
  writeln (' month, date and then the year. Do this until week seven. The');
  writeln (' first and last dates have already been entered earlier when you');
  writeln (' filled out the first chart.');
  writeln;
  for j := 2 to numweek - 1 do
    writeln (' Week ', j, ': ');
  tctb (1,7);
  for j := 2 to (numweek - 1) do
    begin
      gotoXY (11,j + 5);
      readln (date[j]);
    end;
  closeprice;
  for j := 1 to numweek do
    calcchange;
  tctb (0,7);
  clrscr;
  totreport;
  readln;
end;
{***************************************************************************}
procedure frontcover;
begin

  clrscr;
  for r:= 1 to 9 do
    begin
      writeln;
    end;
  writeln (' ':33, user);
  writeln (' ':33, period);
  writeln (' ':33, datenow);
  readln;

end;

{ ************************************************************************* }

begin

  bar;
  repeat
  move;
  until seleccon = 27;
  explain;
  company;
  frontcover;

end.

