program wall_hit;
uses
  crt;
const
  run_time = 500;
  max_char = 5;
type

  win_loss_array   = array [1..5,1..3] of integer;
  character_record = record
                       name  : string[10];
                       head_color : integer;
                     end;

var
  win_record,
  loss_record : win_loss_array;
  character : character_record;
  start,
  selec,
  chnge,
  speed,
  level  : char;
  time,
  easy,
  medium,
  hard,
  r,
  j,
  s,
  x,
  y,
  dly : integer;
  hit,
  up_down,
  left_right : boolean;
{****************************************************************************}
procedure wrtat (x,y : integer; str : string);
begin
  gotoXY (x,y);
  write (str);
end;
{****************************************************************************}
procedure writeat (x,y : integer);
begin
  textcolor (character.head_color);
  gotoXY (x,y);
  write ('');
  gotoXY (x,y);
  textcolor (7);
end;
{****************************************************************************}
procedure clear;
begin
  gotoXY (x,y);
  write (' ');
end;
{****************************************************************************}
procedure move;
var
  dir : integer;
  direction : char;
begin
 direction := readkey;
 dir := ord(direction);
 case dir of
   72 : up_down := false;
   80 : up_down := true;
   77 : left_right := true;
   75 : left_right := false;
 end;
end;
{****************************************************************************}
procedure level_1;
begin
  hit := false;
  if (x = 1) or (x = 80) or (y = 1) or (y = 25) or (time = 0) or
  ((x = 40) and (y = 10)) or ((x = 42) and (y = 10)) or ((x = 39) and (y = 10))
    then hit := true;
  time := time - 1;
  if time = -1 then time := 0;
end;
{****************************************************************************}
procedure level_2;
begin
  hit := false;
  if (x = 1) or (x = 80) or (y = 1) or (y = 25) or (time = 0)
  or (((x = 28) or (x = 29) or (x = 30)) and (y = 13))
  or (((x = 50) or (x = 51) or (x = 52)) and (y = 13))
    then hit := true;
  time := time - 1;
  if time = -1 then time := 0;
end;
{****************************************************************************}
procedure level_3;
begin
  hit := false;
  if (x = 1) or (x = 80) or (y = 1) or (y = 25) or (time = 0)
  or (((x = 16) or (x = 17) or (x = 18)) and (y = 18))
  or (((x = 39) or (x = 40) or (x = 41)) and (y = 7))
  or (((x = 62) or (x = 63) or (x = 64)) and (y = 18))
    then hit := true;
  time := time - 1;
  if time = -1 then time := 0;
end;
{****************************************************************************}
procedure level_4;
begin
  hit := false;
  if (x = 1) or (x = 80) or (y = 1) or (y = 25) or (time = 0)
  or (((x = 16) or (x = 17) or (x = 18)) and ((y = 18) or (y = 7)))
  or (((x = 62) or (x = 63) or (x = 64)) and ((y = 18) or (y = 7)))
    then hit := true;
  time := time - 1;
  if time = -1 then time := 0;
end;
{****************************************************************************}
procedure level_5;
begin
  hit := false;
  if (x = 1) or (x = 80) or (y = 1) or (y = 25) or (time = 0)
  or (((x = 16) or (x = 17) or (x = 18)) and ((y = 18) or (y = 7)))
  or (((x = 39) or (x = 40) or (x = 41)) and (y = 12))
  or (((x = 62) or (x = 63) or (x = 64)) and ((y = 18) or (y = 7)))
    then hit := true;
  time := time - 1;
  if time = -1 then time := 0;
end;
{****************************************************************************}
procedure screen_setup;
begin
  textbackground (1);
  clrscr;
  textbackground (0);
  window (2,2,79,24);
  clrscr;
  window (1,1,80,25);
  textcolor (11);
  textbackground (5);
  gotoXY (2,25);
  write (' Name: ', character.name, ' ');
  textcolor (15);
  textbackground (0);
end;
{}
procedure draw (left,down : integer);
begin
  for j := left to left + 2 do
    begin
      gotoXY (j,down);
      write (chr(2));
    end;
end;
{}
procedure go;
{}
procedure light (color,snd,del : integer);
begin
  delay (1400);
  textcolor (color);
  gotoXY (41, 10);
  write (chr(15));
  sound (snd);
  delay (del);
  nosound;
end;
{}
begin
  light (red,1000,100);
  light (yellow,1000,100);
  light (green,1500,1000);
  textcolor (15);
  gotoXY (39,10);
  write (' ');
end;
{****************************************************************************}
procedure keep_score;
begin
  if (hit = true) and (time = 0)
    then
      case level of
        '1' : case speed of
                '1' : inc(win_record[1,1]);
                '2' : inc(win_record[1,2]);
                '3' : inc(win_record[1,3]);
              end;
        '2' : case speed of
                '1' : inc(win_record[2,1]);
                '2' : inc(win_record[2,2]);
                '3' : inc(win_record[2,3]);
              end;
        '3' : case speed of
                '1' : inc(win_record[3,1]);
                '2' : inc(win_record[3,2]);
                '3' : inc(win_record[3,3]);
              end;
        '4' : case speed of
                '1' : inc(win_record[4,1]);
                '2' : inc(win_record[4,2]);
                '3' : inc(win_record[4,3]);
              end;
        '5' : case speed of
                '1' : inc(win_record[5,1]);
                '2' : inc(win_record[5,2]);
                '3' : inc(win_record[5,3]);
              end;
      end
    else if (hit = true) and (time <> 0) then
      case level of
        '1' : case speed of
                '1' : inc(loss_record[1,1]);
                '2' : inc(loss_record[1,2]);
                '3' : inc(loss_record[1,3]);
              end;
        '2' : case speed of
                '1' : inc(loss_record[2,1]);
                '2' : inc(loss_record[2,2]);
                '3' : inc(loss_record[2,3]);
              end;
        '3' : case speed of
                '1' : inc(loss_record[3,1]);
                '2' : inc(loss_record[3,2]);
                '3' : inc(loss_record[3,3]);
              end;
        '4' : case speed of
                '1' : inc(loss_record[4,1]);
                '2' : inc(loss_record[4,2]);
                '3' : inc(loss_record[4,3]);
              end;
        '5' : case speed of
                '1' : inc(loss_record[5,1]);
                '2' : inc(loss_record[5,2]);
                '3' : inc(loss_record[5,3]);
              end;
      end
end;
{****************************************************************************}
procedure start_up;
var
  change_choice : char;
{}
procedure totrecord;
begin
  window (1,1,80,25);
  textbackground (8);
  clrscr;
  textcolor (4);
  wrtat (27,1,'Record for: ');
  textcolor (character.head_color);
  write (character.name, '  ');
  textcolor (3);
  for r := 0 to 7 do
    begin
      for j := 1 to 26 do
        wrtat (j + 10,r + 8, '-');
      r := r + 1;
    end;
  for r := 0 to 7 do
    begin
      for j := 1 to 26 do
        wrtat (j + 46,r + 8, '-');
      r := r + 1;
    end;
  textcolor (5);
  wrtat (18,4,'Rescued Record');
  wrtat (53,4,'Unrescued Record');
  textcolor (yellow);
  wrtat (22,6,'Level');
  wrtat (58,6,'Level');
  wrtat (4,11,'Speed');
  wrtat (40,11,'Speed');
  textcolor (9);
  r := 1;
  for j := 14 to 38 do
    begin
      gotoXY (j,7);
      write (r);
      r := r + 1;
      j := j + 4;
    end;
  r := 1;
  for j := 50 to 74 do
    begin
      gotoXY (j,7);
      write (r);
      r := r + 1;
      j := j + 4;
    end;
  wrtat (10,9,'1');
  wrtat (10,11,'2');
  wrtat (10,13,'3');
  wrtat (46,9,'1');
  wrtat (46,11,'2');
  wrtat (46,13,'3');
  textcolor (15);
  j := 0;
  for r := 1 to 5 do
    begin
      gotoXY (j + 13,9);
      write (win_record[r,1]:2);
      j := j + 5;
    end;
  j := 0;
  for r := 1 to 5 do
    begin
      gotoXY (j + 13,11);
      write (win_record[r,2]:2);
      j := j + 5;
    end;
  j := 0;
  for r := 1 to 5 do
    begin
      gotoXY (j + 13,13);
      write (win_record[r,3]:2);
      j := j + 5;
    end;
  j := 0;
  for r := 1 to 5 do
    begin
      gotoXY (j + 49,9);
      write (loss_record[r,1]:2);
      j := j + 5;
    end;
  j := 0;
  for r := 1 to 5 do
    begin
      gotoXY (j + 49,11);
      write (loss_record[r,2]:2);
      j := j + 5;
    end;
  j := 0;
  for r := 1 to 5 do
    begin
      gotoXY (j + 49,13);
      write (loss_record[r,3]:2);
      j := j + 5;
    end;
  readln;
end;
{}
procedure create_character;
begin
  window (1,1,80,25);
  textbackground (1);
  textcolor (3);
  clrscr;
  writeln;
  write (' Select a name for your HEAD BANGER: ');
  textcolor (5);
  gotoXY (38,2);
  readln (character.name);
  textcolor (3);
  write (' Select a color for your HEAD BANGER: ');
  readln (character.head_color);
end;
{}
procedure intro;
begin
  window (1,1,80,25);
  textcolor (3);
  textbackground (1);
  clrscr;
  writeln;
  writeln ('        Welcome to  the fabulous  HEAD BANGER game!!  Get  ready  for some');
  writeln ('        fast  paced  action!  Let me  tell you about  the history  of  the');
  writeln ('        HEAD  BANGERS.  They are  a group of  people who lived  happily on');
  writeln ('        their  island in the  Pacific ocean. They live their lives running');
  writeln ('        around banging into everything  around.  They seem to like it, but');
  writeln ('        their neighbors, the @*%!#, got tired of  hearing the loud crashes');
  writeln ('        everyday  all  day  long.  So  the  king of  the @*%!#  decided to');
  writeln ('        kidnap all  of the HEAD  BANGERS  and  freeze  them  inside  large');
  writeln ('        caverns on the island.  All of them were captured except one, you!');
  writeln ('        You must free all of your friends from the grip of the @*%!#. This');
  writeln ('        can be  done by moving  around long  enough inside  the caverns to');
  writeln ('        thaw out  the rest of the  HEAD BANGERS  without running  into the');
  writeln ('        walls or into your  friends. You  can choose  from three  diferent');
  writeln ('        speeds,  and defeat five different levels. Here is the catch.  The');
  writeln ('        faster you go, the harder  it is to control, but you don''t have to');
  writeln ('        last as long.  Going  slower is  easier to  control, but  you must');
  writeln ('        last longer  to thaw out  your friends.  The higher  the level the');
  writeln ('        higher the  number of  friends to thaw out.  It is up to only you.');
  writeln ('        You must move quickly and  carefully to  free all of your friends,');
  writeln ('        because if you  don''t, the @*%!# will  run the  island and turn it');
  writeln ('        into a huge parking lot for the @*%!# to park their cars when they');
  writeln ('        go to work, and the HEAD BANGERS will be forgotten  forever.  Good');
  writeln ('        luck, and bring them back alive.');
  readln;
end;
{}
procedure opening;
begin
  window (1,1,80,25);
  textbackground (1);
  clrscr;
  textbackground (0);
  for j := 1 to 40 do
    wrtat (j + 22, 11, ' ');
  for j := 1 to 5 do
    wrtat (61, j + 6, '  ');
  for j := 1 to 10 do
    wrtat (j + 12, 23, ' ');
  for j := 1 to 6 do
    wrtat (21, j + 16, '  ');
  for j := 1 to 10 do
    wrtat (j + 37, 23, ' ');
  for j := 1 to 6 do
    wrtat (46, j + 16, '  ');
  for j := 1 to 10 do
    wrtat (j + 62, 23, ' ');
  for j := 1 to 6 do
    wrtat (71, j + 16, '  ');
  textcolor (0);
  textbackground (1);
  for j := 1 to 21 do
    wrtat (j + 30,4, '');
  wrtat (51,3,'');
  window (21,6,60,10);
  textbackground (7);
  clrscr;
  textcolor (0);
  writeln;
  writeln ('   Those Amazing, Speedy, and Psycho');
  writeln;
  textcolor (4);
  writeln ('             HEAD BANGERS');
  window (1,1,80,25);
  textcolor (20);
  textbackground (7);
  wrtat (30,3,'  ARE YOU READY!!!!  ');
  textcolor (7);
  textbackground (1);
  gotoXY (1,13);
  writeln ('<I> Introduction        <R> Record of Win/Loss':63);
  writeln ('<C> Create a Character  <T> Program Speed Test':63);
  textcolor (15);
  wrtat (25,16,'  Level');
  wrtat (25,17,'---------');
  wrtat (25,18,'1: Easy');
  wrtat (25,19,'2: Medium');
  wrtat (25,20,'3: Hard');
  wrtat (25,21,'4: Harder');
  wrtat (25,22,'5: Hardest');
  wrtat (50,16,'  Speed');
  wrtat (50,17,'---------');
  wrtat (50,18,'1: Slow');
  wrtat (50,19,'2: Medium');
  wrtat (50,20,'3: Fast');
  textcolor (0);
  textbackground (3);
  window (11,16,20,22);
  clrscr;
  writeln;
  writeln ('  Level?');
  writeln;
  writeln;
  writeln ('   ( )');
  window (36,16,45,22);
  clrscr;
  writeln;
  writeln ('  Start?');
  writeln;
  writeln;
  writeln ('   ( )');
  window (61,16,70,22);
  clrscr;
  writeln;
  writeln ('  Speed?');
  writeln;
  writeln;
  writeln ('   ( )');
end;
{}
procedure test_speed;
var
  correct : char;
begin
  window (1,1,80,25);
  textbackground (1);
  textcolor (3);
  clrscr;
  writeln;
  writeln (' This character should take approxamately 10 seconds to cross the screen.');
  writeln (' Press <Enter> and from the first beep to the last beep is when you should time.');
  readln;
  sound (1000);
  delay (100);
  nosound;
  for j := 1 to 80 do
    begin
      wrtat (j,6,'');
      delay (easy);
    end;
  sound (1000);
  delay (100);
  nosound;
  wrtat (2,10,'Was the time correct? (Y/N)');
  repeat
   correct := readkey;
  until (correct = 'y') or (correct = 'n');
  case correct of
    'y' : wrtat (2,12,'Press <Enter> to continue.');
    'n' : begin
            wrtat (2,12,'If the time was too slow, lower this number and try again.');
            wrtat (56,13,'==> ');
            writeln (easy);
            wrtat (2,14,'If the time was too fast, raise this number and try again.');
            gotoXY (65,13);
            readln (easy);
            test_speed;
          end;
  end;
  medium := round(easy / 2);
  hard := round(easy / 3);
end;
{}
begin
  opening;
  window (1,20,80,20);
  textcolor (15);
  wrtat (15,1,level);
  wrtat (40,1,start);
  wrtat (65,1,speed);
  repeat
    gotoXY (40,1);
    selec := readkey;
    case selec of
          'i' : begin
                  intro;
                  start_up;
                end;
          'r' : begin
                  totrecord;
                  start_up;
                end;
          't' : begin
                  test_speed;
                  start_up;
                end;
          'c' : begin
                  create_character;
                  start_up;
                end;
      chr(72) : begin
                  if start = 'Y'
                    then start := 'N'
                    else start := 'Y';
                    wrtat (40,1,start);
                end;
      chr(80) : begin
                  if start = 'Y'
                    then start := 'N'
                    else start := 'Y';
                    wrtat (40,1,start);
                end;
      chr(75) : begin
                  repeat
                    gotoXY (15,1);
                    change_choice := readkey;
                    case change_choice of
                      chr(80) : dec(level);
                      chr(72) : inc(level);
                    end;
                    if level = '0'
                      then
                        level := '5'
                      else
                        if level = '6'
                          then level := '1';
                    wrtat (15,1,level);
                  until change_choice = chr(13);
                end;
      chr(77) : begin
                  repeat
                    gotoXY (65,1);
                    change_choice := readkey;
                    case change_choice of
                      chr(80) : dec(speed);
                      chr(72) : inc(speed);
                    end;
                    if speed = '0'
                      then
                        speed := '3'
                      else
                        if speed = '4'
                          then speed := '1';
                    wrtat (65,1,speed);
                  until change_choice = chr(13);
                end;
    end;
  until selec = chr(13);
  window (1,1,80,25);
end;
{****************************************************************************}
procedure write_screen;
begin
  case level of
    '1' : draw (39,10);
    '2' : begin
            draw (25,13);
            draw (53,13);
          end;
    '3' : begin
            draw (16,18);
            draw (39,7);
            draw (62,18);
          end;
    '4' : begin
            draw (16,18);
            draw (16,7);
            draw (62,7);
            draw (62,18);
          end;
    '5' : begin
            draw (16,18);
            draw (16,7);
            draw (39,12);
            draw (62,7);
            draw (62,18);
          end;
  end;
end;
{****************************************************************************}
procedure movement;
begin
  repeat
    write_screen;
    gotoXY (2,1);
    write ('   ');
    gotoXY (2,1);
    write (time:3);
    case up_down of
      true  : y := y + 1;
      false : y := y - 1;
    end;
    case left_right of
      true  : x := x + 1;
      false : x := x - 1;
    end;
    case level of
      '1' : level_1;
      '2' : level_2;
      '3' : level_3;
      '4' : level_4;
      '5' : level_5;
    end;
    case speed of
      '1' : dly := easy;
      '2' : dly := medium;
      '3' : dly := hard;
    end;
    writeat (x,y);
    if keypressed then
      move;
    delay (dly);
    clear;
  until hit = true;
end;
{****************************************************************************}
procedure run;
begin
  for r := 1 to 3 do
    for j := 1 to 5 do
      begin
       win_record[j,r] := 0;
       loss_record[j,r] := 0;
      end;
  level := '1';
  start := 'Y';
  speed := '1';
  easy := 130;
  medium := 65;
  hard := 43;
  character.name := 'HeadBanger';
  character.head_color := 15;
  repeat
    easy := 130;
    medium := 80;
    hard := 40;
    up_down := true;
    left_right := true;
    x := 2;
    y := 2;
    time := run_time;
    start_up;
    if start = 'Y'
      then
        begin
          case speed of
            '1' : dly := easy;
            '2' : dly := medium;
            '3' : dly := hard;
          end;
          screen_setup;
          go;
          screen_setup;
          write_screen;
          movement;
          keep_score;
        end;
  until start = 'N';
end;
{****************************************************************************}
begin
  run;
end.
