{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<} UNIT FNCTIONS; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



Var
  counter : byte;

  Function FIRSTLAST (name : string)                  : string;
  Function LASTFIRST (name : string)                  : string;
  Function TRUNCSTR  (strng : string)                 : string;
  Function UPSTRING                                   : string;
  Function STRINT    (gradestr : string; what : char) : integer;



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{=============================================================================}

{******** Reassembles the name from Last first form to First Last form *******}

Function FIRSTLAST (name : string) : string;

var
  comma,
  long   : byte;
  first,
  last   : string;

Begin
  comma := pos(',', name);
  long := length(name);
  if comma <> 0
    then
      begin
        first := copy(name, (comma + 2), long);
        last := copy(name, 1, (comma - 1));
        FIRSTLAST := concat(first, ' ', last);
      end
    else FIRSTLAST := name;
End;

{=============================================================================}

{******** Reassembles the name from First Last form to Last First form *******}

Function LASTFIRST (name : string) : string;

var
  space,
  comma,
  long   : byte;
  first,
  last   : string;

Begin
  space := pos(' ', name);
  comma := pos(',', name);
  long := length(name);
  if comma = 0
    then
      begin
        if (space <> 0)
          then
            begin
              first := copy(name, 1, (space - 1));
              last := copy(name, (space + 1), long);
              LASTFIRST := concat(last, ', ', first);
            end
          else LASTFIRST := name;
      end
    else LASTFIRST := name;
End;

{=============================================================================}

{******** Truncates a string or adds spaces to make it 23 spaces long ********}

Function TRUNCSTR (strng : string) : string;

var
  newstr : string;
  long   : integer;

Begin
  long := length(strng);
  newstr := copy(strng,1,23);
  if long < 23
    then
      for counter := long + 1 to 23 do
        newstr := newstr + ' ';
  TRUNCSTR := newstr;
End;

{=============================================================================}

{********* Upcases all the letters in a string for unity in all names ********}

Function UPSTRING : string;

var
  chrc  : char;
  strng : string;

Begin
  strng := '';
  repeat
    read (chrc);
    chrc := upcase(chrc);
    strng := strng + chrc;
  until eoln;
  readln;
  UPSTRING := strng;
End;

{=============================================================================}

{*** Changes a string to an integer, or sends back the bad grade (invalid) ***}

Function STRINT (gradestr : string; what : char) : integer;

const
  nograde  = -999;
  badgrade = -666;

var
  errorpos : integer;   {* Positoin of an error in the string *}
  gradeint : integer;   {* Converted integer from the string *}

Begin
  val(gradestr, gradeint, errorpos);
  if (errorpos = 0)
    then
      if (what = 'i')
        then
          begin
            if (gradeint >= 1000) and (gradeint <= 20000)
              then STRINT := gradeint
              else STRINT := badgrade;
          end
        else
          begin
            if ((gradeint >= 0) and (gradeint <= 100)) or (gradeint = nograde)
              then STRINT := gradeint
              else STRINT := badgrade;
          end;
  if errorpos <> 0 then STRINT := badgrade;
End;

{=============================================================================}

END.  {*** UNIT FNCTIONS ***}