{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} UNIT MENUS; {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<} INTERFACE {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



USES UTILITY, CRT;

Var
  chrc : char;

  Procedure HEADING;
  Procedure HEADER;
  Procedure BACKGROUND;
  Procedure FILEMENU     (wincolor, wintext, winborder : byte);
  Procedure PRINTMENU    (wincolor, wintext, winborder : byte);
  Procedure NEWMENU      (wincolor, wintext, winborder : byte);
  Procedure ADDMENU      (wincolor, wintext, winborder : byte);
  Procedure SEARCHMENU   (wincolor, wintext, winborder : byte);
  Procedure VIEWMENU     (wincolor, wintext, winborder : byte);
  Procedure EDITMENU     (wincolor, wintext, winborder : byte);
  Procedure HELPMENU     (wincolor, wintext, winborder : byte);
  Procedure PERIODMENU   (wincolor, wintext, winborder : byte);
  Procedure NOSTUDWIN    (wincolor, wintext, winborder : byte);
  Procedure NOGRADEWIN   (wincolor, wintext, winborder : byte);
  Procedure GRADEFULLWIN (wincolor, wintext, winborder : byte);
  Procedure DONE         (wincolor, wintext, winborder : byte);
  Procedure AYSURE       (wincolor, wintext, winborder : byte;
                          var chrc : char);
  Procedure EXITCHECK    (wincolor, wintext, winborder : byte;
                          var chrc : char);
  Procedure VABACKGROUND (gradepos : byte; maxdgrades : byte;
                          var seed, seed2 : byte);



{-----------------------------------------------------------------------------}
{<<<<<<<<<<<<<<<<<<<<<<<<<<<} IMPLEMENTATION {>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>}
{-----------------------------------------------------------------------------}



{=============================================================================}

{***************** Creates the heading for the background ********************}

Procedure HEADING;

Begin
  CLEAR (0,7,1,1,80,1);
  write ('     ile     dd     earch     iew     dit ');
  WRTS (64,1,' elp');
  TCTB (14,0);
  WRTS (76,1,' WG ');
  TCTB (1,7);
  WRTC (5,1,'F');
  WRTC (13,1,'A');
  WRTC (20,1,'S');
  WRTC (30,1,'V');
  WRTC (38,1,'E');
  WRTC (64,1,'H');
End;

{=============================================================================}

{*************** Creates the background for the main screen ******************}

Procedure BACKGROUND;

Begin
  HEADING;
  MAKEWIN (15,1,1,2,80,25,false,true,11);
  REGWIN;
  TCTB (11,1);
  WRTS (64,25, ' WiederGrades ');
  WRTS (4,2,' Teacher:');
  WRTS (4,25,' PERIOD 1 ');
End;

{=============================================================================}

{****************** Creates the header for the search option *****************}

Procedure HEADER;

Begin
  WRTS (10,1,'Name');
  WRTS (25,1,'ID Number');
  WRTS (40,1,'Daily Ave');
  WRTS (53,1,' Test Ave');
  WRTS (65,1,'Total Ave');
  writeln;
  writeln;
End;

{=============================================================================}

{************************ Creates the file menu ******************************}

Procedure FILEMENU (wincolor, wintext, winborder : byte);

Begin
  HEADING;
  TCTB (15,0);
  WRTS (4,1,' File ');
  CLEAR (15,1,3,3,78,24);
  MAKEWIN (wintext,wincolor,4,3,16,8,true,true,winborder);
  writeln ('  Load');
  writeln ('  Print');
  writeln ('  New');
  write   ('  Exit');
End;

{=============================================================================}

{*********************** Creates the print menu ******************************}

Procedure PRINTMENU (wincolor, wintext, winborder : byte);

Begin
  MAKEWIN (wintext,wincolor,29,9,47,13,true,true,winborder);
  writeln ('  ClassReport');
  writeln ('  OneStudent');
  write   ('  AllStudents');
End;

{=============================================================================}

{************************ Creates the new menu *******************************}

Procedure NEWMENU (wincolor, wintext, winborder : byte);

Begin
  MAKEWIN (wintext,wincolor,31,10,49,13,true,true,winborder);
  writeln ('  NewSixWeeks');
  write   ('  NewYear');
End;

{=============================================================================}

{************************ Creates the add menu *******************************}

Procedure ADDMENU (wincolor, wintext, winborder : byte);

Begin
  HEADING;
  TCTB (15,0);
  WRTS (12,1,' Add ');
  CLEAR (15,1,3,3,78,24);
  MAKEWIN (wintext,wincolor,12,3,30,9,true,true,winborder);
  writeln ('  Students');
  writeln ('  DailyNames');
  writeln ('  TestNames');
  writeln ('  DailyGrades');
  write   ('  TestGrades');
End;

{=============================================================================}

{*********************** Creates the search menu *****************************}

Procedure SEARCHMENU (wincolor, wintext, winborder : byte);

Begin
  HEADING;
  TCTB (15,0);
  WRTS (19,1,' Search ');
  CLEAR (15,1,3,3,78,24);
  MAKEWIN (wintext,wincolor,19,3,35,7,true,true,winborder);
  writeln ('  FirstName');
  writeln ('  LastName');
  write   ('  IDNumber');
End;

{=============================================================================}

{************************* Creates the view menu *****************************}

Procedure VIEWMENU (wincolor, wintext, winborder : byte);

Begin
  HEADING;
  TCTB (15,0);
  WRTS (29,1,' View ');
  CLEAR (15,1,3,3,78,24);
  MAKEWIN (wintext,wincolor,29,3,47,6,true,true,winborder);
  writeln ('  AllAverages');
  write   ('  ClassGrades');
End;

{=============================================================================}

{************************* Creates the edit menu *****************************}

Procedure EDITMENU (wincolor, wintext, winborder : byte);

Begin
  HEADING;
  TCTB (15,0);
  WRTS (37,1,' Edit ');
  CLEAR (15,1,3,3,78,24);
  MAKEWIN (wintext,wincolor,37,3,55,14,true,true,winborder);
  writeln ('  Name');
  writeln ('  IDNumber');
  writeln ('  DailyGrades');
  writeln ('  TestGrades');
  writeln ('  DailyNames');
  writeln ('  TestNames');
  writeln ('  CurveDaily');
  writeln ('  CurveTest');
  writeln ('  DropLowest');
  write   ('  ClassName');
End;

{=============================================================================}

{************************* Creates the help menu *****************************}

Procedure HELPMENU (wincolor, wintext, winborder : byte);

Begin
  HEADING;
  TCTB (15,0);
  WRTS (63,1,' Help ');
  CLEAR (15,1,3,3,78,24);
  MAKEWIN (wintext,wincolor,63,3,75,6,true,true,winborder);
  writeln ('  Help');
  write   ('  About');
End;

{=============================================================================}

{************************ Creates the period menu ****************************}

Procedure PERIODMENU (wincolor, wintext, winborder : byte);

var
  count : byte;

Begin
  MAKEWIN (wintext,wincolor,33,6,48,14,true,true,winborder);
  for count := 1 to 6 do
  writeln ('  Period ', count);
  write ('  Period 7');
End;

{=============================================================================}

{********************* Creates the no student window *************************}

Procedure NOSTUDWIN (wincolor, wintext, winborder : byte);

Begin
  MAKEWIN (wintext,wincolor,27,19,56,21,true,true,winborder);
  write (' No students! Press <Esc>');
  HIDECURSOR (1,1,wincolor);
  repeat
    chrc := readkey;
  until chrc = #27;
End;

{=============================================================================}

{********************** Creates the no grade window **************************}

Procedure NOGRADEWIN (wincolor, wintext, winborder : byte);

Begin
  MAKEWIN (wintext,wincolor,27,19,56,21,true,true,winborder);
  write ('  No grades! Press <Esc>');
  HIDECURSOR (1,1,wincolor);
  repeat
    chrc := readkey;
  until chrc = #27;
End;

{=============================================================================}

{******************** Creates the grade full window **************************}

Procedure GRADEFULLWIN (wincolor, wintext, winborder : byte);

Begin
  MAKEWIN (wintext,wincolor,24,19,59,21,true,true,winborder);
  write ('  All grades full! Press <Esc>');
  HIDECURSOR (1,1,wincolor);
  repeat
    chrc := readkey;
  until chrc = #27;
End;

{=============================================================================}

{*********************** Creates the done window *****************************}

Procedure DONE (wincolor, wintext, winborder : byte);

Begin
  MAKEWIN (wintext,wincolor,28,19,54,21,true,true,winborder);
  write ('   Done. Press <ESC>');
  HIDECURSOR (1,1,wincolor);
  repeat
    chrc := readkey;
  until chrc = #27;
End;

{=============================================================================}

{******************* Creates the are you sure window *************************}

Procedure AYSURE (wincolor, wintext, winborder : byte;
                  var chrc : char);

Begin
  MAKEWIN (wintext,wincolor,28,19,54,21,true,true,winborder);
  write ('  Are you sure? <Y/N>');
  HIDECURSOR (1,1,wincolor);
  repeat
    chrc := upcase(readkey);
  until (chrc = 'Y') or (chrc = 'N') or (chrc = #27);
End;

{=============================================================================}

{******************** Creates the check exit window **************************}

Procedure EXITCHECK (wincolor, wintext, winborder : byte;
                     var chrc : char);

Begin
  HEADING;
  CLEAR (15,1,3,3,78,24);
  MAKEWIN (wintext,wincolor,28,12,54,14,true,true,winborder);
  write ('  Exit WGrades? <Y/N>');
  HIDECURSOR (1,1,wincolor);
  repeat
    chrc := upcase(readkey);
  until (chrc = 'Y') or (chrc = 'N') or (chrc = #27);
  if chrc = #27 then chrc := 'N';
End;

{=============================================================================}

{****************** Creates the view all background **************************}

Procedure VABACKGROUND (gradepos : byte; maxdgrades : byte;
                        var seed, seed2 : byte);

var
  count : byte;

Begin
  case gradepos of
     1..10 : seed := 1;
    11..20 : seed := 11;
    21..30 : seed := 21;
    31..40 : seed := 31;
    41..45 : seed := 41;
  end;
  case gradepos of
     1..10 : seed2 := 10;
    11..20 : seed2 := 20;
    21..30 : seed2 := 30;
    31..40 : seed2 := 40;
    41..45 : seed2 := 45;
  end;
  CLEAR (14,1,3,3,78,24);
  if gradepos <= maxdgrades
    then writeln (' Current Daily Grade ==>')
    else writeln (' Current Test Grade  ==>');
  WRTS (57,1,'ClassAve ==> ');
  WRTS (2,2,'StudentAve ==> ');
  gotoXY (25,2);
  for count := seed to seed2 do
    if count <= maxdgrades
      then write ('  D',count:2)
      else write ('  T',count - maxdgrades:2);
  writeln;
End;

{=============================================================================}

END.  {*** UNIT MENUS ***}
